unit Unit1;
(* ------------------------------------------------------------------------------
  Brush Tools And Layers  : 1.0
  Copyright  1986-2018   : Copyright Adirondack Software & Graphics
  Last Modification       : 10-05-2018
  Compiler                : Delphi Tokyo
  Target Platform         : VCL Win32/Win64
  Operating System        : Windows 10
  ImageEn                 : 8.1.1
  This file is copyright  W W Miller, 1986-2018
  It may be used without restriction. This code distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
  ------------------------------------------------------------------------------ *)
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ExtDlgs, System.UITypes,
  System.Notification, Vcl.Buttons, Vcl.WinXCtrls, Vcl.Menus, System.ImageList,
  Vcl.ImgList, hyieutils, iexBitmaps, hyiedefs, iesettings, iexLayers,
  iexRulers, ieview, ImageEnView, iemview, imageenproc, imageenio,
  ieXCanvasUtils, iexHelperFunctions, iexColorButton, iexColorPalette,
  iexLayerMView;

type
  TForm1 = class(TForm)
    PageControl2: TPageControl;
    TabSheet1: TTabSheet;
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    ImageEnView1: TImageEnView;
    New1: TButton;
    Open1: TButton;
    Save1: TButton;
    SaveAs1: TButton;
    Close1: TButton;
    CloseAll1: TButton;
    Exit1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    ColorDialog1: TColorDialog;
    TabSheet3: TTabSheet;
    Undo1: TButton;
    Redo1: TButton;
    cxGroupBox5: TGroupBox;
    ImageEnMView1: TImageEnMView;
    NotificationCenter1: TNotificationCenter;
    TaskDialog1: TTaskDialog;
    TabSheet4: TTabSheet;
    ConvertTo32Bit1: TButton;
    ConvertTo24Bit1: TButton;
    ConvertTo8Bit1: TButton;
    ConvertTo4Bit1: TButton;
    ConvertTo1Bit1: TButton;
    ConvertToGray1: TButton;
    TabSheet6: TTabSheet;
    AddImageLayer1: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Exit2: TButton;
    Resample1: TButton;
    Resize1: TButton;
    Rulers1: TToggleSwitch;
    DisplayGrid1: TToggleSwitch;
    TrackBarZoom1: TTrackBar;
    Fit1: TToggleSwitch;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Undo2: TButton;
    Redo2: TButton;
    EditZoom1: TEdit;
    PopupMenu1: TPopupMenu;
    RemoveLayer1: TButton;
    TabSheet2: TTabSheet;
    SelectNone1: TSpeedButton;
    SelectLayers1: TSpeedButton;
    Selection1: TSpeedButton;
    TabSheet5: TTabSheet;
    AddFrame1: TButton;
    RemoveFrame1: TButton;
    TabSheet7: TTabSheet;
    Desktop1: TButton;
    ForegroundWindow1: TButton;
    ForegroundWindowClient1: TButton;
    TabSheet8: TTabSheet;
    BrushTools1: TSpeedButton;
    CloneTools1: TSpeedButton;
    CropTools1: TSpeedButton;
    Erase1: TSpeedButton;
    ScrollBox1: TScrollBox;
    GroupBox5: TGroupBox;
    LayerPreviewQuality1: TComboBox;
    Label8: TLabel;
    MultipleLayerSelection1: TToggleSwitch;
    lblPreviewQuality: TLabel;
    ImageEnPopupMenu1: TPopupMenu;
    LayerProperties1: TMenuItem;
    LayersPopupMenu1: TPopupMenu;
    AddLayer2: TMenuItem;
    RemoveLayer2: TMenuItem;
    GroupBox1: TGroupBox;
    LabelBrushShape1: TLabel;
    LabelBrushFill1: TLabel;
    ComboBoxBrushShape1: TComboBox;
    ComboBoxBrushFill1: TComboBox;
    LabelOperation1: TLabel;
    LabelPaintMode1: TLabel;
    ComboBoxOperation1: TComboBox;
    BrushPaintMode1: TComboBox;
    LabelBrushSize1: TLabel;
    TrackBarBrushSize1: TTrackBar;
    EditBrushSize1: TEdit;
    UpDownBrushSize1: TUpDown;
    LabelFeathering1: TLabel;
    TrackBarFeathering1: TTrackBar;
    EditFeathering1: TEdit;
    UpdownFeathering1: TUpDown;
    LabelTransparency1: TLabel;
    TrackbarTransparency1: TTrackBar;
    EditTransparency1: TEdit;
    UpDownTransparency1: TUpDown;
    LabelTransparencyMode1: TLabel;
    TransparencyMode1: TToggleSwitch;
    AddShape2: TMenuItem;
    SelectPolygon1: TSpeedButton;
    SelectCircle1: TSpeedButton;
    SelectMagicWand1: TSpeedButton;
    SelectLasso1: TSpeedButton;
    MeasureLength1: TSpeedButton;
    AddTextLayer1: TButton;
    GroupBox2: TGroupBox;
    LabelTextLayerText1: TLabel;
    TextLayerText1: TEdit;
    SetText1: TButton;
    LabelTextAlignment1: TLabel;
    TextLayerAlignment1: TComboBox;
    LabelTextLayout1: TLabel;
    TextLayerLayout1: TComboBox;
    LabelTextShape1: TLabel;
    TextLayerShape1: TComboBox;
    LabelTextOverflow1: TLabel;
    TextLayerOverflow1: TComboBox;
    SetFont1: TButton;
    ActivateTextEditor1: TButton;
    SizeToFit1: TButton;
    LoadStamp1: TButton;
    ImageEnView2: TImageEnView;
    Label9: TLabel;
    LayerBorderColor1: TColorBox;
    Label10: TLabel;
    LayerFillColor1: TColorBox;
    Label11: TLabel;
    LayerFillColor2: TColorBox;
    LabelFillGradient1: TLabel;
    LayerFillGradient1: TComboBox;
    LabelBorderWidth1: TLabel;
    LayerBorderWidth1: TEdit;
    UpDownBorderWidth1: TUpDown;
    LabelTransparenmcy2: TLabel;
    LayerTransparencyTrackBar1: TTrackBar;
    LayerTransparency1: TEdit;
    UpDownLayerTransparency1: TUpDown;
    LabelOpacity2: TLabel;
    LabelAlphaEdgeFeather1: TLabel;
    AlphaEdgeFeatheringTrackBar1: TTrackBar;
    LayerAlphaEdgeFeathering1: TEdit;
    AlphaEdgeFeatheringUpDown1: TUpDown;
    LayerAntialias1: TToggleSwitch;
    LabelAntalias1: TLabel;
    LabelOperation2: TLabel;
    LayerOperation1: TComboBox;
    LayerOpacityTrackBar1: TTrackBar;
    LayerOpacityLabel1: TLabel;
    LayerRemove1: TMenuItem;
    Solid1: TSpeedButton;
    Gradient1: TSpeedButton;
    Spray1: TSpeedButton;
    Textured1: TSpeedButton;
    CenteredTexture1: TSpeedButton;
    TexturedSpray1: TSpeedButton;
    Image1: TSpeedButton;
    Crop2: TButton;
    grpGeneral: TGroupBox;
    GroupBox4: TGroupBox;
    LabelShape1: TLabel;
    LabelModifier1: TLabel;
    Shapes1: TComboBox;
    edtModifier: TEdit;
    UpDownModifier1: TUpDown;
    GroupBox6: TGroupBox;
    btnSetPolylineTriangle: TButton;
    btnSetPolylineStar: TButton;
    btnSetPolylineHeart: TButton;
    btnSimplifyPolygon: TButton;
    btnClearAllPoints: TButton;
    GroupBox3: TGroupBox;
    LabelMagnification1: TLabel;
    LabelMagnificationStyle1: TLabel;
    LabelMagnificationSource1: TLabel;
    LayerMagnification1: TTrackBar;
    MagnificationStyle1: TComboBox;
    MagnifySource1: TComboBox;
    CropAlpha1: TButton;
    RestoreSize1: TButton;
    GroupBox7: TGroupBox;
    LineLayerLabelPosition1: TLabel;
    LabelStartShape1: TLabel;
    LabelEndShape1: TLabel;
    LabelLineLayerShapeSize1: TLabel;
    LabelPosition1: TComboBox;
    StartShape1: TComboBox;
    EndShape1: TComboBox;
    edtShapeSize: TEdit;
    UpDownShapeSize1: TUpDown;
    RulerUnits1: TComboBox;
    AddShapeLayer1: TButton;
    SoftShadow1: TToggleSwitch;
    LabelSoftShadow1: TLabel;
    AddLineLayer1: TButton;
    AddPolylineLayer1: TButton;
    grpStyle: TGroupBox;
    LabelBorderColor1: TLabel;
    LabelFillColorLineLayer1: TLabel;
    LabelLineWidth1: TLabel;
    LineWidth1: TEdit;
    UpDownLineWidth1: TUpDown;
    LineColor1: TColorBox;
    LineFillColor1: TColorBox;
    PolylineClosed1: TToggleSwitch;
    LabelPolylineClosed1: TLabel;
    LabelPolylineShape1: TLabel;
    PolylineShapes1: TComboBox;
    LayerVisible1: TToggleSwitch;
    LayerCropped1: TToggleSwitch;
    PositionLocked1: TToggleSwitch;
    AspectRatio1: TToggleSwitch;
    LayerSelectable1: TToggleSwitch;
    LabelVisible1: TLabel;
    LabelCrop1: TLabel;
    LabelLocked1: TLabel;
    LabelAspectRatio1: TLabel;
    LabelSelectable1: TLabel;
    LayerMask1: TToggleSwitch;
    MagnificationLayer1: TToggleSwitch;
    LabelMaskLayer1: TLabel;
    LabelMagnificationLaer1: TLabel;
    TextReadOnly1: TToggleSwitch;
    TextAutoSize1: TToggleSwitch;
    TextWordWrap1: TToggleSwitch;
    LabelTextReadOnly1: TLabel;
    LabelTextAutoSize1: TLabel;
    LabelTextWordWrap1: TLabel;
    RulerMode1: TToggleSwitch;
    LabelRulerMode1: TLabel;
    FontDialog1: TFontDialog;
    LineLayerSizeToFit1: TButton;
    LabelAutoClosePolylines1: TLabel;
    AutoClosePolylines1: TComboBox;
    AddLayer1: TButton;
    PopupMenuImageEnMView1: TPopupMenu;
    AddFrame2: TMenuItem;
    RemoveFrame2: TMenuItem;
    EditPolylineLayerWidth1: TEdit;
    LabelPolylineLineWidth1: TLabel;
    UpDownPolylineLayerWidth1: TUpDown;
    LabelPolylineColor1: TLabel;
    PolylineLayerLineColor1: TColorBox;
    LabelPolylineFillColor1: TLabel;
    PolylineLayerFillColor1: TColorBox;
    LabelPolylineFillColor2: TLabel;
    PolylineLayerFillColor2: TColorBox;
    LabelPolylineTransparency1: TLabel;
    TrackBarPolylineTransparency1: TTrackBar;
    PolylineLayerTransparency1: TEdit;
    UpDownPolylineLayerTransparency1: TUpDown;
    LabelPolylineLayerOpacity2: TLabel;
    TrackBarPolylineLayerOpacity1: TTrackBar;
    LabelPolylineLayerOpacity1: TLabel;
    LabelShapeOperation1: TLabel;
    PolylineLayerOperation1: TComboBox;
    LabelRotation1: TLabel;
    TrackBarLayerRotation1: TTrackBar;
    Edit1: TEdit;
    UpDownLayerRotation1: TUpDown;
    SelectRotation1: TSpeedButton;
    TrackBarPolylineWidth1: TTrackBar;
    LabelNoShape1: TLabel;
    ToggleSwitchNoShape1: TToggleSwitch;
    MergeLayer1: TButton;
    MergeAllLayers1: TButton;
    LayerMerge1: TMenuItem;
    MergeAllLayers2: TMenuItem;
    GroupBoxBrush1: TGroupBox;
    LabelPalette1: TLabel;
    IEColorPaletteBrush1: TIEColorPalette;
    ComboBoxBrushPalette1: TComboBox;
    AllowPointEditing1: TToggleSwitch;
    LabelAllowPolylineEditing1: TLabel;
    GroupBox8: TGroupBox;
    cxLabel1: TLabel;
    ColorUnderCursor1: TShape;
    LabelX1: TLabel;
    LabelAlpha1: TLabel;
    LabelY1: TLabel;
    LabelOpacity1: TLabel;
    LabelLayerPreviewQuality1: TLabel;
    PreviewQuality1: TComboBox;
    NoTools1: TSpeedButton;
    GroupBox9: TGroupBox;
    LabelBrushColor1: TLabel;
    ColorBox1: TColorBox;
    ShapeBrushColor1: TShape;
    ShapeBrushColor2: TShape;
    LabelBrushColor2: TLabel;
    ColorBox2: TColorBox;
    GroupBoxBrush2: TGroupBox;
    Label5: TLabel;
    IEColorPaletteBrush2: TIEColorPalette;
    ComboBoxBrushPalette2: TComboBox;
    TrackBarLayerBorderWidth1: TTrackBar;
    TrackBarLineLayerWidth1: TTrackBar;
    TabSheet9: TTabSheet;
    AutoEnhance1: TSpeedButton;
    AutoEnhance2: TSpeedButton;
    AutoEnhance3: TSpeedButton;
    AdjustGainOffset1: TSpeedButton;
    AutoSharp1: TSpeedButton;
    HistAutoEqualize1: TSpeedButton;
    WhiteBalanceAutoWhite1: TSpeedButton;
    WhiteBalanceGrayWorld1: TSpeedButton;
    Brighten1: TSpeedButton;
    Darken1: TSpeedButton;
    RemoveRedEye1: TSpeedButton;
    Tint1: TSpeedButton;
    Curves1: TSpeedButton;
    SaveLayers1: TButton;
    OpenLayers1: TButton;
    FlipHorizontal1: TButton;
    FlipVertical1: TButton;
    Rotate1: TButton;
    ImageEnLayerMView1: TImageEnLayerMView;
    ColorPicker1: TSpeedButton;
    PrintPreview1: TButton;
    FloodFillTool1: TSpeedButton;
    WindowsPriintWizard1: TButton;
    FloodFillAlphaTool1: TSpeedButton;
    GroupBox10: TGroupBox;
    Label6: TLabel;
    FloodFillColor1: TColorBox;
    Label7: TLabel;
    TrackBarFillAlpha1: TTrackBar;
    FillAlpha1: TEdit;
    UpDownFillAlpha1: TUpDown;
    Label12: TLabel;
    TrackBarFloodFillTolerance1: TTrackBar;
    FloodFillTolerance1: TEdit;
    UpDownFloodFillTolerance1: TUpDown;
    Label13: TLabel;
    TrackBarFillToolSampleSize1: TTrackBar;
    FillSampleSize1: TEdit;
    UpDownFillSampleSize1: TUpDown;
    Label14: TLabel;
    ToggleSwitchFillMaxFilter1: TToggleSwitch;
    Label15: TLabel;
    TrackBarBrushStep1: TTrackBar;
    EditBrushStep1: TEdit;
    UpDownBrushStep1: TUpDown;
    procedure ControlChange(Sender: TObject);
    procedure ShapeBrushColor1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ShapeBrushColor2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Open1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure ConvertTo32Bit1Click(Sender: TObject);
    procedure ConvertTo24Bit1Click(Sender: TObject);
    procedure ConvertTo8Bit1Click(Sender: TObject);
    procedure ConvertTo4Bit1Click(Sender: TObject);
    procedure ConvertTo1Bit1Click(Sender: TObject);
    procedure ConvertToGray1Click(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure TrackBarBrushSize1Change(Sender: TObject);
    procedure UpDownBrushSize1Click(Sender: TObject; Button: TUDBtnType);
    procedure Undo1Click(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure AddImageLayer1Click(Sender: TObject);
    procedure ImageEnMView1ImageSelect(Sender: TObject; idx: Integer);
    procedure FormCreate(Sender: TObject);
    procedure TrackBarFeathering1Change(Sender: TObject);
    procedure TrackbarTransparency1Change(Sender: TObject);
    procedure EditBrushSize1Change(Sender: TObject);
    procedure EditFeathering1Change(Sender: TObject);
    procedure ToggleSwitch1Click(Sender: TObject);
    procedure DisplayGrid1Click(Sender: TObject);
    procedure Fit1Click(Sender: TObject);
    procedure TrackBarZoom1Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure RemoveLayer1Click(Sender: TObject);
    procedure SelectNone1Click(Sender: TObject);
    procedure SelectLayers1Click(Sender: TObject);
    procedure Selection1Click(Sender: TObject);
    procedure AddFrame1Click(Sender: TObject);
    procedure RemoveFrame1Click(Sender: TObject);
    procedure Desktop1Click(Sender: TObject);
    procedure ForegroundWindow1Click(Sender: TObject);
    procedure ForegroundWindowClient1Click(Sender: TObject);
    procedure CropTools1Click(Sender: TObject);
    procedure BrushTools1Click(Sender: TObject);
    procedure CloneTools1Click(Sender: TObject);
    procedure Erase1Click(Sender: TObject);
    procedure Resample1Click(Sender: TObject);
    procedure Resize1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TransparencyMode1Click(Sender: TObject);
    procedure LayerProperties1Click(Sender: TObject);
    procedure MultipleLayerSelection1Click(Sender: TObject);
    procedure LayersPopupMenu1Popup(Sender: TObject);
    procedure SelectPolygon1Click(Sender: TObject);
    procedure SelectCircle1Click(Sender: TObject);
    procedure SelectMagicWand1Click(Sender: TObject);
    procedure SelectLasso1Click(Sender: TObject);
    procedure MeasureLength1Click(Sender: TObject);
    procedure AddTextLayer1Click(Sender: TObject);
    procedure SetText1Click(Sender: TObject);
    procedure TextLayerAlignment1Change(Sender: TObject);
    procedure TextLayerLayout1Change(Sender: TObject);
    procedure TextLayerShape1Change(Sender: TObject);
    procedure TextLayerOverflow1Change(Sender: TObject);
    procedure TextReadOnly1Click(Sender: TObject);
    procedure TextAutoSize1Click(Sender: TObject);
    procedure TextWordWrap1Click(Sender: TObject);
    procedure SetFont1Click(Sender: TObject);
    procedure ActivateTextEditor1Click(Sender: TObject);
    procedure SizeToFit1Click(Sender: TObject);
    procedure LoadStamp1Click(Sender: TObject);
    procedure LayerBorderColor1Change(Sender: TObject);
    procedure LayerFillColor1Change(Sender: TObject);
    procedure LayerFillColor2Change(Sender: TObject);
    procedure LayerBorderWidth1Change(Sender: TObject);
    procedure LayerFillGradient1Change(Sender: TObject);
    procedure AlphaEdgeFeatheringTrackBar1Change(Sender: TObject);
    procedure UpDownLayerTransparency1Click(Sender: TObject;
      Button: TUDBtnType);
    procedure AlphaEdgeFeatheringUpDown1Click(Sender: TObject;
      Button: TUDBtnType);
    procedure LayerAlphaEdgeFeathering1Change(Sender: TObject);
    procedure LayerTransparencyTrackBar1Change(Sender: TObject);
    procedure LayerOpacityTrackBar1Change(Sender: TObject);
    procedure LayerAntialias1Click(Sender: TObject);
    procedure LayerTransparency1Change(Sender: TObject);
    procedure LayerOperation1Change(Sender: TObject);
    procedure ComboBoxBrushShape1Change(Sender: TObject);
    procedure ComboBoxBrushFill1Change(Sender: TObject);
    procedure ComboBoxOperation1Change(Sender: TObject);
    procedure BrushPaintMode1Change(Sender: TObject);
    procedure LayerRemove1Click(Sender: TObject);
    procedure ImageEnPopupMenu1Popup(Sender: TObject);
    procedure Solid1Click(Sender: TObject);
    procedure Gradient1Click(Sender: TObject);
    procedure Spray1Click(Sender: TObject);
    procedure Textured1Click(Sender: TObject);
    procedure CenteredTexture1Click(Sender: TObject);
    procedure TexturedSpray1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ColorBox2Change(Sender: TObject);
    procedure Crop2Click(Sender: TObject);
    procedure AddShapeLayer1Click(Sender: TObject);
    procedure Shapes1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect;
      State: TOwnerDrawState);
    procedure Shapes1Change(Sender: TObject);
    procedure LayerVisible1Click(Sender: TObject);
    procedure AspectRatio1Click(Sender: TObject);
    procedure LayerSelectable1Click(Sender: TObject);
    procedure LayerCropped1Click(Sender: TObject);
    procedure SoftShadow1Click(Sender: TObject);
    procedure UpDownModifier1Click(Sender: TObject; Button: TUDBtnType);
    procedure LayerMagnification1Change(Sender: TObject);
    procedure MagnificationStyle1Change(Sender: TObject);
    procedure MagnifySource1Change(Sender: TObject);
    procedure CropAlpha1Click(Sender: TObject);
    procedure RestoreSize1Click(Sender: TObject);
    procedure AddLineLayer1Click(Sender: TObject);
    procedure AddPolylineLayer1Click(Sender: TObject);
    procedure PolylineClosed1Click(Sender: TObject);
    procedure btnSimplifyPolygonClick(Sender: TObject);
    procedure btnClearAllPointsClick(Sender: TObject);
    procedure btnSetPolylineTriangleClick(Sender: TObject);
    procedure btnSetPolylineStarClick(Sender: TObject);
    procedure btnSetPolylineHeartClick(Sender: TObject);
    procedure PolylineShapes1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure PolylineShapes1Change(Sender: TObject);
    procedure PositionLocked1Click(Sender: TObject);
    procedure LayerMask1Click(Sender: TObject);
    procedure LineColor1Change(Sender: TObject);
    procedure LineFillColor1Change(Sender: TObject);
    procedure LabelPosition1Change(Sender: TObject);
    procedure StartShape1Change(Sender: TObject);
    procedure EndShape1Change(Sender: TObject);
    procedure UpDownShapeSize1Click(Sender: TObject; Button: TUDBtnType);
    procedure LineLayerSizeToFit1Click(Sender: TObject);
    procedure AutoClosePolylines1Change(Sender: TObject);
    procedure PreviewQuality1Change(Sender: TObject);
    procedure AddLayer1Click(Sender: TObject);
    procedure UpDownPolylineLayerWidth1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure PolylineLayerLineColor1Change(Sender: TObject);
    procedure PolylineLayerFillColor1Change(Sender: TObject);
    procedure PolylineLayerFillColor2Change(Sender: TObject);
    procedure PolylineLayerOperation1Change(Sender: TObject);
    procedure TrackBarPolylineTransparency1Change(Sender: TObject);
    procedure TrackBarPolylineLayerOpacity1Change(Sender: TObject);
    procedure EditPolylineLayerWidth1Change(Sender: TObject);
    procedure SelectRotation1Click(Sender: TObject);
    procedure TrackBarLayerRotation1Change(Sender: TObject);
    procedure TrackBarPolylineWidth1Change(Sender: TObject);
    procedure TextLayerShape1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ToggleSwitchNoShape1Click(Sender: TObject);
    procedure MergeLayer1Click(Sender: TObject);
    procedure MergeAllLayers1Click(Sender: TObject);
    procedure IEColorPaletteBrush1SelectedColorChange(Sender: TObject);
    procedure ComboBoxBrushPalette1Change(Sender: TObject);
    procedure IEColorPaletteBrush1GetHintText(Sender: TObject; AColor: TColor;
      Index: Integer; var HintStr: string);
    procedure UpDownLineWidth1Click(Sender: TObject; Button: TUDBtnType);
    procedure AutoEnhance2Click(Sender: TObject);
    procedure AutoEnhance3Click(Sender: TObject);
    procedure AutoEnhance4Click(Sender: TObject);
    procedure AdjustGainOffset1Click(Sender: TObject);
    procedure AutoSharp1Click(Sender: TObject);
    procedure HistAutoEqualize1Click(Sender: TObject);
    procedure WhiteBalanceAutoWhite1Click(Sender: TObject);
    procedure WhiteBalanceGrayWorld1Click(Sender: TObject);
    procedure DeSkew1Click(Sender: TObject);
    procedure AutoCrop1Click(Sender: TObject);
    procedure RemoveRedEye1Click(Sender: TObject);
    procedure IncreaseBrightness1Click(Sender: TObject);
    procedure DecreaseBrightness1Click(Sender: TObject);
    procedure Grayscale1Click(Sender: TObject);
    procedure PencilSketch1Click(Sender: TObject);
    procedure Tint1Click(Sender: TObject);
    procedure Brightem1Click(Sender: TObject);
    procedure Darken1Click(Sender: TObject);
    procedure Curves1Click(Sender: TObject);
    procedure AllowPointEditing1Click(Sender: TObject);
    procedure NoTools1Click(Sender: TObject);
    procedure IEColorPaletteBrush2GetHintText(Sender: TObject; AColor: TColor;
      Index: Integer; var HintStr: string);
    procedure IEColorPaletteBrush2SelectedColorChange(Sender: TObject);
    procedure ComboBoxBrushPalette2Change(Sender: TObject);
    procedure TrackBarLayerBorderWidth1Change(Sender: TObject);
    procedure UpDownBorderWidth1Click(Sender: TObject; Button: TUDBtnType);
    procedure TrackBarLineLayerWidth1Change(Sender: TObject);
    procedure SaveLayers1Click(Sender: TObject);
    procedure OpenLayers1Click(Sender: TObject);
    procedure FlipHorizontal1Click(Sender: TObject);
    procedure FlipVertical1Click(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure ColorPicker1Click(Sender: TObject);
    procedure PrintPreview1Click(Sender: TObject);
    procedure WindowsPriintWizard1Click(Sender: TObject);
    procedure FloodFillColor1Click(Sender: TObject);
    procedure FloodFillAlphaTool1Click(Sender: TObject);
    procedure TrackBarFillAlpha1Change(Sender: TObject);
    procedure UpDownFillAlpha1Click(Sender: TObject; Button: TUDBtnType);
    procedure TrackBarFillToolSampleSize1Change(Sender: TObject);
    procedure UpDownFillSampleSize1Click(Sender: TObject; Button: TUDBtnType);
    procedure TrackBarFloodFillTolerance1Change(Sender: TObject);
    procedure ToggleSwitchFillMaxFilter1Click(Sender: TObject);
    procedure FloodFillColor1Change(Sender: TObject);
    procedure ImageEnLayerMView1GetTextEx(Sender: TObject; Index: Integer;
      Position: TIEMTextPos; var Text: WideString; Font: TFont;
      var BackgroundStyle: TBrushStyle; var BackgroundColor: TColor;
      var TruncSide: TIEMTruncSide);
    procedure TrackBarBrushStep1Change(Sender: TObject);
    procedure EditBrushStep1Change(Sender: TObject);
  private
    { Private declarations }
    procedure AddTabsheet;
    procedure UpdateGUI;
    procedure UpdateFrame;
    procedure UpdateFrames;
    procedure ClearStatusBar;
    procedure UpdateStatusBar;
    procedure DrawLayers;
    procedure UpdateTabSheets;
    procedure ConvertTo1Bit;
    procedure ConvertTo24Bit;
    procedure ConvertTo32Bit;
    procedure ConvertTo4Bit;
    procedure ConvertTo8Bit;
    procedure ImageEnViewUserInteraction(Sender: TObject;
      Event: TIEUserInteractionEvent; Info: Integer);
    procedure ImageEnViewDrawLayerBox(Sender: TObject; ACanvas: TCanvas;
      LayerIndex: Integer);
    procedure ImageEnViewNewLayer(Sender: TObject; LayerIdx: Integer;
      LayerKind: TIELayerKind);
    procedure ImageEnViewLayerNotify(Sender: TObject; layer: Integer;
      Event: TIELayerEvent);
    procedure ImageEnViewImageChange(Sender: TObject);
    procedure ImageEnViewLayerSelectionChange(Sender: TObject);
    procedure ImageEnViewViewChange(Sender: TObject; Change: Integer);
    procedure ImageEnViewMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure ImageEnViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageEnViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageEnViewKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ImageEnViewMeasure(Sender: TObject; MeasureType: TIEMeasureType;
      MeasureLayer: TIELayer; Size: Double; var Units: TIEUnits);
    function IsMultiFrameImage: Boolean;
    procedure ReadIni(IniFilename: string);
    procedure LoadRecentFiles(const AIniFilename: string; ASection: string);
    procedure SaveRecentFiles(const AIniFilename: string; ASection: string);
    procedure WriteIni(IniFilename: string);
    procedure LoadRecentFile(Sender: TObject);
    procedure ClearRecentFiles(Sender: TObject);
    procedure GetLineLayerParameters;
    procedure SetLineLayerParameters;
    procedure GetShapeLayerParameters;
    procedure SetShapeLayerParameters;
    procedure GetTextLayerParameters;
    procedure SetTextLayerParameters;
    procedure GetImageLayerParameters;
    procedure SetImageLayerParameters;
    procedure SetPolylineLayerParameters;
    procedure GetPolylineLayerParameters;
    procedure DxColorMap;
    procedure GeneratePalette(ABaseColor: TColor);
    procedure JascColorMap;
  public
    { Public declarations }
    AIniFilename: string;
    TabSheet: TTabSheet;
    ImageEnView: TImageEnView;
    AFilename: string;
    AMostRecentFiles: TStringlist;
    AX: Integer;
    AY: Integer;
    APolylineWidthChanging: Boolean;
    procedure UpdateUndo;
  protected
    procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Winapi.ShlObj, System.IniFiles, iexWindowsFunctions, uNewImage, uResample,
  uResize, uCurves, PalUtils;

function AppDataFolder: string;
{ Find AppData folder location. }
var
  iResult: bool;
  iPath: array [0 .. MAX_PATH] of char;
begin
  iResult := Winapi.ShlObj.ShGetSpecialFolderPath(0, iPath,
    CSIDL_LOCAL_APPDATA, False);
  if not iResult then
    raise Exception.Create('Could not find LocalAppData folder location.');
  Result := IncludeTrailingPathDelimiter(iPath);
end;

function DocumentsFolder: string;
{ Find Documents folder location. }
var
  iResult: bool;
  iPath: array [0 .. MAX_PATH] of char;
begin
  iResult := Winapi.ShlObj.ShGetSpecialFolderPath(0, iPath,
    CSIDL_PERSONAL, False);
  if not iResult then
    raise Exception.Create('Could not find Documents folder location.');
  Result := IncludeTrailingPathDelimiter(iPath);
end;

function DesktopFolder: string;
{ Find Desktop folder location. }
var
  iResult: bool;
  iPath: array [0 .. MAX_PATH] of char;
begin
  iResult := Winapi.ShlObj.ShGetSpecialFolderPath(0, iPath,
    CSIDL_DESKTOPDIRECTORY, False);
  if not iResult then
    raise Exception.Create('Could not find Documents folder location.');
  Result := IncludeTrailingPathDelimiter(iPath);
end;

function AddThousandSeparator(const AString: string; const AChar: char): string;
{ Add a specified thousand separator in the correct location in a string. }
var
  i: Integer; { Loop through separator position }
begin
  Result := AString;
  i := Length(AString) - 2;
  while i > 1 do
  begin
    Insert(AChar, Result, i);
    i := i - 3;
  end;
end;

function AddDefThousandSeparator(const AString: string): string;
{ Add the local default thousand separator in the correct location in a string. }
begin
  Result := AddThousandSeparator(AString,
    System.SysUtils.FormatSettings.ThousandSeparator);
end;

function IntegerToString(const i: Int64): string;
{ Add the local default thousand separator in the correct location in a number and return a string. }
begin
  Result := AddThousandSeparator(IntToStr(i),
    System.SysUtils.FormatSettings.ThousandSeparator);
end;

function EllipsifyText(const AsPath: Boolean; const AText: string;
  const ACanvas: Vcl.Graphics.TCanvas; const AMaxWidth: Integer): string;
{ Shortens text if necessary to fit within a specified number of pixels on a
  given canvas. If AsPath is True text is shortened path-wise by inserting an
  ellipsis in the text body, otherwise it is truncated and an ellipsis is
  appended. }
var
  iPChar: PChar; { Temp buffer to hold text }
  iRect: TRect; { Temp rectangle hold max width of text }
  iParams: UINT; { Flags passed to DraeTextEx API function }
begin
  if AText <> '' then
  begin
    Result := AText;
    if AText = '' then
      exit;
    { Allocate memory for PChar }
    GetMem(iPChar, Length(AText) * SizeOf(AText) + 1);
    try
      { Copy Text into PChar }
      iPChar := System.SysUtils.StrPCopy(iPChar, AText);
      { Create Rectangle to Store PChar }
      iRect := System.Classes.Rect(0, 0, AMaxWidth, high(Integer));
      { Set Params depending whether it's a path or not }
      if AsPath then
        iParams := Winapi.Windows.DT_PATH_ELLIPSIS
      else
        iParams := Winapi.Windows.DT_END_ELLIPSIS;
      { Tell it to Modify the PChar, and do not draw to the canvas }
      iParams := iParams + Winapi.Windows.DT_MODIFYSTRING +
        Winapi.Windows.DT_CALCRECT;
      { Ellipsify the string based on available space to draw in }
      Winapi.Windows.DrawTextEx(ACanvas.Handle, iPChar, -1, iRect,
        iParams, nil);
      { Copy the modified PChar into the result }
      Result := System.SysUtils.StrPas(iPChar);
    finally
      { Free Memory from PChar }
      FreeMem(iPChar, Length(AText) * SizeOf(AText) + 1);
    end;
  end;
end;

function DitherColor(AColor: TColor; AAlpha: Integer): TColor;
{ Dither a 32-bit color (with alpha value) to TColor. }
var
  iRGB: TRGB;
begin
  iRGB := TColor2TRGB(AColor);
  if (iRGB.r = 255) and (iRGB.g = 255) and (iRGB.b = 255) then
  begin
    iRGB.r := AAlpha;
    iRGB.g := AAlpha;
    iRGB.b := AAlpha;
  end
  else
  begin
    iRGB.r := Trunc(AAlpha / 255 * iRGB.r) + (255 - AAlpha);
    iRGB.g := Trunc(AAlpha / 255 * iRGB.g) + (255 - AAlpha);
    iRGB.b := Trunc(AAlpha / 255 * iRGB.b) + (255 - AAlpha);
  end;
  Result := TRGB2TColor(iRGB);
end;

function GetLayerKindStr(AImageEnView: TImageEnView): string;
var
  iIELayerKind: TIELayerKind;
begin
  iIELayerKind := AImageEnView.CurrentLayer.Kind;
  case ord(iIELayerKind) of
    0:
      Result := 'Image';
    1:
      Result := 'Shape';
    2:
      Result := 'Line';
    3:
      Result := 'Polyline';
    4:
      Result := 'Text';
  end;
end;

function GetShapeKindStr(AImageEnView: TImageEnView): string;
var
  iIELayerKind: TIELayerKind;
  iShapeString: string;
begin
  iIELayerKind := AImageEnView.CurrentLayer.Kind;
  if iIELayerKind = ielkShape then
    iShapeString := IEShapeToStr(TIEShapeLayer(AImageEnView.CurrentLayer).Shape)
  else
    iShapeString := '';
  Result := iShapeString;
end;

procedure TForm1.WhiteBalanceAutoWhite1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('WhiteBalance Auto White ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo1.Enabled := ImageEnView.Proc.CanUndo;
          Undo2.Enabled := ImageEnView.Proc.CanUndo;
          ImageEnView.Proc.WhiteBalance_AutoWhite;
          ImageEnView.Update;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.WhiteBalanceGrayWorld1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('WhiteBalance GrayWorld ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo1.Enabled := ImageEnView.Proc.CanUndo;
          Undo2.Enabled := ImageEnView.Proc.CanUndo;
          ImageEnView.Proc.WhiteBalance_GrayWorld;
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.WindowsPriintWizard1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ShowWindowsPrintWizard(ImageEnMView1, True);
    end;
  end;
end;

procedure TForm1.WMSysCommand;
{ Respond to minimize or maximize button clicks. }
var
  i: Integer;
  iZoom: Double;
begin
  DefaultHandler(Msg);
  if (Msg.CmdType = SC_MAXIMIZE) then
  begin
    for i := 0 to PageControl1.PageCount - 1 do
    begin
      if Assigned(PageControl1.Pages[i]) then
      begin
        ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
        if Assigned(ImageEnView) then
        begin
          if Fit1.State = tssOn then
          begin
            // ImageEnView.Fit()
            iZoom := ImageEnView.GetIdealZoom -
              ImageEnView.GetIdealZoom * 0.025;
            ImageEnView.Zoom := iZoom;
          end
          else
            ImageEnView.Zoom := 100;
          ImageEnView.Update;
        end;
      end;
    end;
  end
  else
  begin
    for i := 0 to PageControl1.PageCount - 1 do
    begin
      if Assigned(PageControl1.Pages[i]) then
      begin
        ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
        if Assigned(ImageEnView) then
        begin
          if Fit1.State = tssOn then
          begin
            // ImageEnView.Fit()
            iZoom := ImageEnView.GetIdealZoom -
              ImageEnView.GetIdealZoom * 0.025;
            ImageEnView.Zoom := iZoom;
          end
          else
            ImageEnView.Zoom := 100;
          ImageEnView.Update;
        end;
      end;
    end;
  end;
end;

procedure TForm1.GeneratePalette(ABaseColor: TColor);
{ 238 colors. }
begin
  if ComboBoxBrushPalette1.Focused then
    IEColorPaletteBrush1.Colors.Text := MakePalette(ABaseColor, soAscending);
  if ComboBoxBrushPalette1.Focused then
    IEColorPaletteBrush1.Colors.Text := MakePalette(ABaseColor, soAscending);
  if ComboBoxBrushPalette2.Focused then
    IEColorPaletteBrush2.Colors.Text := MakePalette(ABaseColor, soAscending);
  if ComboBoxBrushPalette2.Focused then
    IEColorPaletteBrush2.Colors.Text := MakePalette(ABaseColor, soAscending);
end;

procedure TForm1.JascColorMap;
var
  iStringList: TStringlist;
begin
  iStringList := TStringlist.Create;
  try
    iStringList.Clear;
    iStringList.BeginUpdate;
    iStringList.Add('clBlack');
    iStringList.Add('clWhite');
    iStringList.Add('clMaroon');
    iStringList.Add('clGreen');
    iStringList.Add('clOlive');
    iStringList.Add('clNavy');
    iStringList.Add('clPurple');
    iStringList.Add('clTeal');
    iStringList.Add('clGray');
    iStringList.Add('clSilver');
    iStringList.Add('clRed');
    iStringList.Add('clLime');
    iStringList.Add('clYellow');
    iStringList.Add('clBlue');
    iStringList.Add('clFuchsia');
    iStringList.Add('clAqua');
    iStringList.Add('$F2F2F2');
    iStringList.Add('$E6E6E6');
    iStringList.Add('$DADADA');
    iStringList.Add('$CECECE');
    iStringList.Add('$C2C2C2');
    iStringList.Add('$B6B6B6');
    iStringList.Add('$AAAAAA');
    iStringList.Add('$9E9E9E');
    iStringList.Add('$929292');
    iStringList.Add('$868686');
    iStringList.Add('$7A7A7A');
    iStringList.Add('$6E6E6E');
    iStringList.Add('$626262');
    iStringList.Add('$565656');
    iStringList.Add('$4A4A4A');
    iStringList.Add('$3E3E3E');
    iStringList.Add('$D4F0FF');
    iStringList.Add('$B1E2FF');
    iStringList.Add('$8ED4FF');
    iStringList.Add('$6BC6FF');
    iStringList.Add('$48B8FF');
    iStringList.Add('$25AAFF');
    iStringList.Add('$00AAFF');
    iStringList.Add('$0092DC');
    iStringList.Add('$003E75');
    iStringList.Add('$003F77');
    iStringList.Add('$004079');
    iStringList.Add('$00417B');
    iStringList.Add('$00427D');
    iStringList.Add('$004380');
    iStringList.Add('$007AB9');
    iStringList.Add('$006296');
    iStringList.Add('$004A73');
    iStringList.Add('$003250');
    iStringList.Add('$D4E3FF');
    iStringList.Add('$B1C7FF');
    iStringList.Add('$8EABFF');
    iStringList.Add('$6B8FFF');
    iStringList.Add('$4873FF');
    iStringList.Add('$2557FF');
    iStringList.Add('$0055FF');
    iStringList.Add('$0049DC');
    iStringList.Add('$003DB9');
    iStringList.Add('$003196');
    iStringList.Add('$002573');
    iStringList.Add('$001950');
    iStringList.Add('$D4D4FF');
    iStringList.Add('$B1B1FF');
    iStringList.Add('$8E8EFF');
    iStringList.Add('$6B6BFF');
    iStringList.Add('$4848FF');
    iStringList.Add('$2525FF');
    iStringList.Add('$0000FE');
    iStringList.Add('$0000DC');
    iStringList.Add('$0000B9');
    iStringList.Add('$000096');
    iStringList.Add('$000073');
    iStringList.Add('$000050');
    iStringList.Add('$E3D4FF');
    iStringList.Add('$C7B1FF');
    iStringList.Add('$AB8EFF');
    iStringList.Add('$8F6BFF');
    iStringList.Add('$7348FF');
    iStringList.Add('$5725FF');
    iStringList.Add('$5500FF');
    iStringList.Add('$4900DC');
    iStringList.Add('$3D00B9');
    iStringList.Add('$310096');
    iStringList.Add('$250073');
    iStringList.Add('$190050');
    iStringList.Add('$F0D4FF');
    iStringList.Add('$E2B1FF');
    iStringList.Add('$D48EFF');
    iStringList.Add('$C66BFF');
    iStringList.Add('$B848FF');
    iStringList.Add('$AA25FF');
    iStringList.Add('$AA00FF');
    iStringList.Add('$9200DC');
    iStringList.Add('$7A00B9');
    iStringList.Add('$620096');
    iStringList.Add('$4A0073');
    iStringList.Add('$320050');
    iStringList.Add('$FFD4FF');
    iStringList.Add('$FFB1FF');
    iStringList.Add('$FF8EFF');
    iStringList.Add('$FF6BFF');
    iStringList.Add('$FF48FF');
    iStringList.Add('$FF25FF');
    iStringList.Add('$FE00FE');
    iStringList.Add('$DC00DC');
    iStringList.Add('$B900B9');
    iStringList.Add('$960096');
    iStringList.Add('$730073');
    iStringList.Add('$500050');
    iStringList.Add('$FFD4F0');
    iStringList.Add('$FFB1E2');
    iStringList.Add('$FF8ED4');
    iStringList.Add('$FF6BC6');
    iStringList.Add('$FF48B8');
    iStringList.Add('$FF25AA');
    iStringList.Add('$FF00AA');
    iStringList.Add('$DC0092');
    iStringList.Add('$B9007A');
    iStringList.Add('$960062');
    iStringList.Add('$73004A');
    iStringList.Add('$500032');
    iStringList.Add('$FFD4E3');
    iStringList.Add('$FFB1C7');
    iStringList.Add('$FF8EAB');
    iStringList.Add('$FF6B8F');
    iStringList.Add('$FF4873');
    iStringList.Add('$FF2557');
    iStringList.Add('$FF0055');
    iStringList.Add('$DC0049');
    iStringList.Add('$B9003D');
    iStringList.Add('$960031');
    iStringList.Add('$730025');
    iStringList.Add('$500019');
    iStringList.Add('$FFD4D4');
    iStringList.Add('$FFB1B1');
    iStringList.Add('$FF8E8E');
    iStringList.Add('$FF6B6B');
    iStringList.Add('$FF4848');
    iStringList.Add('$FF2525');
    iStringList.Add('$FE0000');
    iStringList.Add('$DC0000');
    iStringList.Add('$B90000');
    iStringList.Add('$960000');
    iStringList.Add('$730000');
    iStringList.Add('$500000');
    iStringList.Add('$FFE3D4');
    iStringList.Add('$FFC7B1');
    iStringList.Add('$FFAB8E');
    iStringList.Add('$FF8F6B');
    iStringList.Add('$FF7348');
    iStringList.Add('$FF5725');
    iStringList.Add('$FF5500');
    iStringList.Add('$DC4900');
    iStringList.Add('$B93D00');
    iStringList.Add('$963100');
    iStringList.Add('$732500');
    iStringList.Add('$501900');
    iStringList.Add('$FFF0D4');
    iStringList.Add('$FFE2B1');
    iStringList.Add('$FFD48E');
    iStringList.Add('$FFC66B');
    iStringList.Add('$FFB848');
    iStringList.Add('$FFAA25');
    iStringList.Add('$FFAA00');
    iStringList.Add('$DC9200');
    iStringList.Add('$B97A00');
    iStringList.Add('$966200');
    iStringList.Add('$734A00');
    iStringList.Add('$503200');
    iStringList.Add('$FFFFD4');
    iStringList.Add('$FFFFB1');
    iStringList.Add('$FFFF8E');
    iStringList.Add('$FFFF6B');
    iStringList.Add('$FFFF48');
    iStringList.Add('$FFFF25');
    iStringList.Add('$FEFE00');
    iStringList.Add('$DCDC00');
    iStringList.Add('$B9B900');
    iStringList.Add('$969600');
    iStringList.Add('$737300');
    iStringList.Add('$505000');
    iStringList.Add('$F0FFD4');
    iStringList.Add('$E2FFB1');
    iStringList.Add('$D4FF8E');
    iStringList.Add('$C6FF6B');
    iStringList.Add('$B8FF48');
    iStringList.Add('$AAFF25');
    iStringList.Add('$AAFF00');
    iStringList.Add('$92DC00');
    iStringList.Add('$7AB900');
    iStringList.Add('$629600');
    iStringList.Add('$4A7300');
    iStringList.Add('$325000');
    iStringList.Add('$E3FFD4');
    iStringList.Add('$C7FFB1');
    iStringList.Add('$ABFF8E');
    iStringList.Add('$8FFF6B');
    iStringList.Add('$57FF25');
    iStringList.Add('$55FF00');
    iStringList.Add('$49DC00');
    iStringList.Add('$3DB900');
    iStringList.Add('$319600');
    iStringList.Add('$257300');
    iStringList.Add('$195000');
    iStringList.Add('$D4FFD4');
    iStringList.Add('$B1FFB1');
    iStringList.Add('$8EFF8E');
    iStringList.Add('$6BFF6B');
    iStringList.Add('$48FF48');
    iStringList.Add('$25FF25');
    iStringList.Add('$00FE00');
    iStringList.Add('$00DC00');
    iStringList.Add('$00B900');
    iStringList.Add('$009600');
    iStringList.Add('$007300');
    iStringList.Add('$005000');
    iStringList.Add('$D4FFE3');
    iStringList.Add('$B1FFC7');
    iStringList.Add('$8EFFAB');
    iStringList.Add('$6BFF8F');
    iStringList.Add('$48FF73');
    iStringList.Add('$25FF57');
    iStringList.Add('$00FF55');
    iStringList.Add('$00DC49');
    iStringList.Add('$00B93D');
    iStringList.Add('$009631');
    iStringList.Add('$007325');
    iStringList.Add('$005019');
    iStringList.Add('$D4FFF0');
    iStringList.Add('$B1FFE2');
    iStringList.Add('$8EFFD4');
    iStringList.Add('$6BFFC6');
    iStringList.Add('$48FFB8');
    iStringList.Add('$25FFAA');
    iStringList.Add('$00FFAA');
    iStringList.Add('$00DC92');
    iStringList.Add('$00B97A');
    iStringList.Add('$009662');
    iStringList.Add('$00734A');
    iStringList.Add('$005032');
    iStringList.Add('$E4FFFF');
    iStringList.Add('$D4FFFF');
    iStringList.Add('$C1FFFF');
    iStringList.Add('$B1FFFF');
    iStringList.Add('$9EFFFF');
    iStringList.Add('$8EFFFF');
    iStringList.Add('$6EFFFF');
    iStringList.Add('$6DFFFF');
    iStringList.Add('$6CFFFF');
    iStringList.Add('$57FFFF');
    iStringList.Add('$4AFFFF');
    iStringList.Add('$49FFFF');
    iStringList.Add('$48FFFF');
    iStringList.Add('$ACFFFF');
    iStringList.Add('$98FFFF');
    iStringList.Add('$84FFFF');
    iStringList.Add('$70FFFF');
    iStringList.Add('$66FFFF');
    iStringList.Add('$52FFFF');
    iStringList.Add('$3EFFFF');
    iStringList.Add('$2AFFFF');
    iStringList.Add('$16FFFF');
    iStringList.EndUpdate;
    if ComboBoxBrushPalette1.Focused then
      IEColorPaletteBrush1.Colors.Assign(iStringList);
    if ComboBoxBrushPalette2.Focused then
      IEColorPaletteBrush2.Colors.Assign(iStringList);
  finally
    iStringList.Free;
  end;
end;

procedure TForm1.DxColorMap;
{ Create a dxcolormap and fill the cyColorGrid1 with 160 colors. }
var
  iStringList: TStringlist;
  iColornameList: TStringlist;
begin
  iStringList := TStringlist.Create;
  try
    iColornameList := TStringlist.Create;
    try
      iStringList.Clear;
      iStringList.BeginUpdate;
      iStringList.Add('clBlack');
      iStringList.Add('clMaroon');
      iStringList.Add('clGreen');
      iStringList.Add('clOlive');
      iStringList.Add('clNavy');
      iStringList.Add('clPurple');
      iStringList.Add('clTeal');
      iStringList.Add('clGray');
      iStringList.Add('clSilver');
      iStringList.Add('clRed');
      iStringList.Add('clLime');
      iStringList.Add('clYellow');
      iStringList.Add('clBlue');
      iStringList.Add('clFuchsia');
      iStringList.Add('clAqua');
      iStringList.Add('clWhite');
      iStringList.Add('$00FFF8F0');
      iStringList.Add('$00D7EBFA');
      iStringList.Add('$00D4FF7F');
      iStringList.Add('$00FFFFF0');
      iStringList.Add('$00DCF5F5');
      iStringList.Add('$00C4E4FF');
      iStringList.Add('$00CDFFFF');
      iStringList.Add('$00E22B8A');
      iStringList.Add('$002A2AA5');
      iStringList.Add('$0087B8DE');
      iStringList.Add('$00A09E5F');
      iStringList.Add('$0000FF7F');
      iStringList.Add('$001E69D2');
      iStringList.Add('$00507FFF');
      iStringList.Add('$00ED9564');
      iStringList.Add('$00DCF8FF');
      iStringList.Add('$003C14DC');
      iStringList.Add('$008B0000');
      iStringList.Add('$008B8B00');
      iStringList.Add('$000B86B8');
      iStringList.Add('$00A9A9A9');
      iStringList.Add('$00006400');
      iStringList.Add('$006BB7BD');
      iStringList.Add('$008B008B');
      iStringList.Add('$002F6B55');
      iStringList.Add('$00008CFF');
      iStringList.Add('$00CC3299');
      iStringList.Add('$0000008B');
      iStringList.Add('$007A96E9');
      iStringList.Add('$008FBC8F');
      iStringList.Add('$008B3D48');
      iStringList.Add('$004F4F2F');
      iStringList.Add('$00D1CE00');
      iStringList.Add('$00D30094');
      iStringList.Add('$009314FF');
      iStringList.Add('$00FFBF00');
      iStringList.Add('$00696969');
      iStringList.Add('$00FF901E');
      iStringList.Add('$002222B2');
      iStringList.Add('$00F0FAFF');
      iStringList.Add('$00228B22');
      iStringList.Add('$00DCDCDC');
      iStringList.Add('$00FFF8F8');
      iStringList.Add('$0000D7FF');
      iStringList.Add('$0020A5DA');
      iStringList.Add('$002FFFAD');
      iStringList.Add('$00F0FFF0');
      iStringList.Add('$00B469FF');
      iStringList.Add('$005C5CCD');
      iStringList.Add('$0082004B');
      iStringList.Add('$00F0F0FF');
      iStringList.Add('$008CE6F0');
      iStringList.Add('$00FAE6E6');
      iStringList.Add('$00F5F0FF');
      iStringList.Add('$0000FC7C');
      iStringList.Add('$00CDFAFF');
      iStringList.Add('$00E6D8AD');
      iStringList.Add('$008080F0');
      iStringList.Add('$00FFFFE0');
      iStringList.Add('$00D2FAFA');
      iStringList.Add('$0090EE90');
      iStringList.Add('$00D3D3D3');
      iStringList.Add('$00C1B6FF');
      iStringList.Add('$007AA0FF');
      iStringList.Add('$00AAB220');
      iStringList.Add('$00FACE87');
      iStringList.Add('$00998877');
      iStringList.Add('$00DEC4B0');
      iStringList.Add('$00E0FFFF');
      iStringList.Add('$0032CD32');
      iStringList.Add('$00E6F0FA');
      iStringList.Add('$00AACD66');
      iStringList.Add('$00CD0000');
      iStringList.Add('$00D355BA');
      iStringList.Add('$00DB7093');
      iStringList.Add('$00EE687B');
      iStringList.Add('$009AFA00');
      iStringList.Add('$00CCD148');
      iStringList.Add('$008515C7');
      iStringList.Add('$00701919');
      iStringList.Add('$00FAFFF5');
      iStringList.Add('$00E1E4FF');
      iStringList.Add('$00B5E4FF');
      iStringList.Add('$00E6F5FD');
      iStringList.Add('$00238E6B');
      iStringList.Add('$0000A5FF');
      iStringList.Add('$000045FF');
      iStringList.Add('$00D670DA');
      iStringList.Add('$00AAE8EE');
      iStringList.Add('$0098FB98');
      iStringList.Add('$00EEEEAF');
      iStringList.Add('$009370DB');
      iStringList.Add('$00D5EFFF');
      iStringList.Add('$00BDDBFF');
      iStringList.Add('$003F85CD');
      iStringList.Add('$00CBC0FF');
      iStringList.Add('$00DDA0DD');
      iStringList.Add('$00E6E0B0');
      iStringList.Add('$0013458B');
      iStringList.Add('$007280FA');
      iStringList.Add('$0060A4F4');
      iStringList.Add('$00578B2E');
      iStringList.Add('$00EEF5FF');
      iStringList.Add('$00CD5A6A');
      iStringList.Add('$00908070');
      iStringList.Add('$00FAFAFF');
      iStringList.Add('$007FFF00');
      iStringList.Add('$00B48246');
      iStringList.Add('$008CB4D2');
      iStringList.Add('$00D8BFD8');
      iStringList.Add('$004763FD');
      iStringList.Add('$00D0E040');
      iStringList.Add('$00EE82EE');
      iStringList.Add('$00B3DEF5');
      iStringList.Add('$00F5F5F5');
      iStringList.Add('$0032CD9A');
      iStringList.Add(ColorToString(clActiveBorder));
      iStringList.Add(ColorToString(clActiveCaption));
      iStringList.Add(ColorToString(clAppWorkSpace));
      iStringList.Add(ColorToString(clBackground));
      iStringList.Add(ColorToString(clBtnFace));
      iStringList.Add(ColorToString(clBtnHighlight));
      iStringList.Add(ColorToString(clBtnShadow));
      iStringList.Add(ColorToString(clBtnText));
      iStringList.Add(ColorToString(clCaptionText));
      iStringList.Add(ColorToString(clGrayText));
      iStringList.Add(ColorToString(clHighlight));
      iStringList.Add(ColorToString(clHighlightText));
      iStringList.Add(ColorToString(clInactiveBorder));
      iStringList.Add(ColorToString(clInactiveCaption));
      iStringList.Add(ColorToString(clInactiveCaptionText));
      iStringList.Add(ColorToString(clInfoBk));
      iStringList.Add(ColorToString(clInfoText));
      iStringList.Add(ColorToString(clMenu));
      iStringList.Add(ColorToString(clMenuText));
      iStringList.Add(ColorToString(clScrollBar));
      iStringList.Add(ColorToString(cl3DDkShadow));
      iStringList.Add(ColorToString(clBtnFace));
      iStringList.Add(ColorToString(clHighlightText));
      iStringList.Add(ColorToString(cl3DLight));
      iStringList.Add(ColorToString(clBtnShadow));
      iStringList.Add(ColorToString(clWindow));
      iStringList.Add(ColorToString(clWindowFrame));
      iStringList.Add(ColorToString(clWindowText));
      iStringList.EndUpdate;
      if ComboBoxBrushPalette1.Focused then
        IEColorPaletteBrush1.Colors.Assign(iStringList);
      if ComboBoxBrushPalette2.Focused then
        IEColorPaletteBrush2.Colors.Assign(iStringList);
    finally
      iColornameList.Free;
    end;
  finally
    iStringList.Free;
  end;
end;

procedure TForm1.LoadRecentFiles(const AIniFilename: string; ASection: string);
var
  i: Integer;
  iFilename: string;
  iIni: TIniFile;
  iFileCount: Integer;
  iIndent: string;
begin
  AMostRecentFiles.BeginUpdate;
  try
    AMostRecentFiles.Clear;
    iIni := TIniFile.Create(AIniFilename);
    try
      iFileCount := iIni.ReadInteger('MostRecentFileCount', 'File Count', 0);
      for i := 0 to iFileCount - 1 do
      begin
        iIndent := format('%s%d', ['', i + 1]);
        iFilename := iIni.ReadString(ASection, iIndent, '');
        if iFilename = '' then
          break
        else if AMostRecentFiles.IndexOf(iFilename) < 0 then
          AMostRecentFiles.Append(iFilename);
      end;
    finally
      iIni.Free;
    end;
  finally
    AMostRecentFiles.EndUpdate;
  end;
end;

procedure TForm1.LoadStamp1Click(Sender: TObject);
begin
  OpenPictureDialog1.InitialDir := 'C:\Images';
  if OpenPictureDialog1.Execute then
  begin
    ImageEnView2.IO.LoadFromFile(OpenPictureDialog1.FileName);
    ImageEnView2.Update;
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        ImageEnView2.IEBitmap.SetTransparentColors(clBlack, clBlack, 0);
        ImageEnView.BrushTool.BrushImage.Assign(ImageEnView2.Bitmap);
        ImageEnView.BrushTool.BrushImage.SetTransparentColors(clBlack,
          clBlack, 0);
        ImageEnView.BrushTool.BrushImage.Width := ImageEnView2.IEBitmap.Width;
        ImageEnView.BrushTool.BrushImage.Height := ImageEnView2.IEBitmap.Height;
      end;
    end;
  end;
end;

procedure TForm1.MeasureLength1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.MouseInteract := [miMeasureLength];
    end;
  end;
end;

procedure TForm1.MergeAllLayers1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.LayersCount > 1 then
      begin;
        for i := ImageEnView.LayersCount - 1 downto 1 do
        begin
          ImageEnView.LayersMerge(0, i);
        end;
        ImageEnView.Update;
      end;
    end;
  end;
end;

procedure TForm1.MergeLayer1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (ImageEnView.LayersCount > 1) and (ImageEnView.LayersCurrent <> 0) then
      begin
        ImageEnView.LayersMerge(0, ImageEnView.LayersCurrent);
        ImageEnView.Update;
      end;
    end;
  end;
end;

procedure TForm1.MultipleLayerSelection1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      for i := 0 to PageControl1.PageCount - 1 do
      begin
        ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
        if Assigned(ImageEnView) then
        begin
          if MultipleLayerSelection1.State = tssOn then
            ImageEnView.LayerOptions := ImageEnView.LayerOptions +
              [loAllowMultiSelect]
          else
            ImageEnView.LayerOptions := ImageEnView.LayerOptions -
              [loAllowMultiSelect];
        end;
      end;
    end;
  end;
end;

procedure TForm1.SaveRecentFiles(const AIniFilename: string; ASection: string);
var
  i: Integer;
  iIndex: Integer;
  iIni: TIniFile;
begin
  if AMostRecentFiles.Find('-', iIndex) then
    AMostRecentFiles.Delete(iIndex);
  if AMostRecentFiles.Find('Clear Recent', iIndex) then
    AMostRecentFiles.Delete(iIndex);
  iIni := TIniFile.Create(AIniFilename);
  try
    iIni.WriteInteger('MostRecentFileCount', 'File Count',
      AMostRecentFiles.Count);
    if iIni.SectionExists(ASection) then
      iIni.EraseSection(ASection);
    for i := 1 to AMostRecentFiles.Count do
      iIni.WriteString(ASection, format('%s%d', ['', i]),
        AMostRecentFiles[i - 1]);
  finally
    iIni.Free;
  end;
end;

procedure TForm1.SelectCircle1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.MouseInteract := [miSelectCircle];
    end;
  end;
end;

procedure TForm1.Selection1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.MouseInteract := [miSelect];
    end;
  end;
end;

procedure TForm1.SelectLasso1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.MouseInteract := [miSelectLasso];
    end;
  end;
end;

procedure TForm1.SelectLayers1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
    end;
  end;
end;

procedure TForm1.SelectMagicWand1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.MouseInteract := [miSelectMagicWand];
    end;
  end;
end;

procedure TForm1.SelectPolygon1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.MouseInteract := [miSelectPolygon];
    end;
  end;
end;

procedure TForm1.SelectRotation1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if SelectRotation1.Down then
        ImageEnView.MouseInteract := [miRotateLayers]
      else
      begin
        ImageEnView.MouseInteract := [];
        SelectNone1.Down := True;
      end;
    end;
  end;
end;

procedure TForm1.ReadIni(IniFilename: string);
var
  iIniFile: TIniFile;
  iState: Integer;
begin
  iIniFile := TIniFile.Create(IniFilename);
  try
    iState := iIniFile.ReadInteger('Window', 'State', ord(wsNormal));
    { Check if window was minimised - we have special }
    { processing for minimized state since Delphi doesn't }
    { minimize windows - it uses application window }
    { instead }
    if iState = ord(wsMinimized) then
    begin
      { Set visible true else form will not restore properly }
      Self.Visible := True;
      Application.Minimize;
    end
    else
      Self.WindowState := TWindowState(iState);
    if Self.WindowState = wsNormal then
    begin
      Self.Left := iIniFile.ReadInteger('Window', 'Left',
        Screen.Width div 2 - Self.Width div 2);
      Self.Top := iIniFile.ReadInteger('Window', 'Top',
        Screen.Height div 2 - Self.Height div 2);
      Self.Width := iIniFile.ReadInteger('Window', 'Width', Self.Width);
      Self.Height := iIniFile.ReadInteger('Window', 'Height', Self.Height);
    end;
    LoadRecentFiles(IniFilename, 'MostRecentFiles');
  finally
    iIniFile.Free;
  end;
end;

procedure TForm1.WriteIni(IniFilename: string);
var
  iIniFile: TIniFile;
  iState: Integer;
begin
  iIniFile := TIniFile.Create(IniFilename);
  try
    iIniFile.WriteInteger('Window', 'Left', Left);
    iIniFile.WriteInteger('Window', 'Top', Top);
    iIniFile.WriteInteger('Window', 'Width', Width);
    iIniFile.WriteInteger('Window', 'Height', Height);
    if IsIconic(Application.Handle) then
      { Minimized - write that state }
      iState := ord(wsMinimized)
    else
      { Not mimimized - use window state of form }
      iState := ord(Self.WindowState);
    iIniFile.WriteInteger('Main', 'State', iState);
    SaveRecentFiles(IniFilename, 'MostRecentFiles');
  finally
    iIniFile.Free;
  end;
end;

procedure TForm1.AddFrame1Click(Sender: TObject);
var
  iFilename: string;
  iFrame: Integer;
  iBitDepth: Integer;
  iWidth: Integer;
  iHeight: Integer;
  iColor: string;
  iDimensions: string;
begin
  OpenPictureDialog1.InitialDir := 'C:\Images';
  if OpenPictureDialog1.Execute then
  begin
    iFilename := OpenPictureDialog1.FileName;
    AFilename := iFilename;
    iFrame := ImageEnMView1.AppendImage(OpenPictureDialog1.FileName);
    ImageEnMView1.ImageTopText[iFrame] := 'Frame ' + IntToStr(iFrame + 1);
    ImageEnMView1.ImageBottomText[iFrame] :=
      IntToStr(ImageEnMView1.MIO.Params[iFrame].Width) + ' x ' +
      IntToStr(ImageEnMView1.MIO.Params[iFrame].Height) + ' ' +
      IntToStr(ImageEnMView1.MIO.Params[iFrame].BitsPerSample *
      ImageEnMView1.MIO.Params[iFrame].SamplesPerPixel) + '-bit';
    AddTabsheet;
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        iWidth := ImageEnView.IEBitmap.Width;
        iHeight := ImageEnView.IEBitmap.Height;
        iDimensions := IntegerToString(iWidth) + ' x ' +
          IntegerToString(iHeight);
        iBitDepth := ImageEnView.IO.Params.BitsPerSample *
          ImageEnView.IO.Params.SamplesPerPixel;
        ImageEnMView1.MIO.Params[iFrame].ICO_BitCount[iFrame] := iBitDepth;
        if iBitDepth = 32 then
          iColor := 'RGBA 32-Bit'
        else
          iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
        ImageEnMView1.ImageTopText[iFrame] := iDimensions + ' ' + iColor;
        ImageEnMView1.ImageBottomText[iFrame] := 'Frame ' +
          IntToStr(iFrame + 1);
        PageControl1.Pages[PageControl1.ActivePageIndex].Caption :=
          ExtractFileName(AFilename);
        PageControl1.Pages[PageControl1.ActivePageIndex].Hint := AFilename;
        ImageEnMView1.CopyToIEBitmap(iFrame, ImageEnView.IEBitmap);
        ImageEnView.IO.Params.Assign(ImageEnMView1.MIO.Params[iFrame]);
        ImageEnView.Update;
        PageControl1.ActivePageIndex := iFrame;
        UpdateFrame;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.GetImageLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        LayerBorderColor1.Selected := TIEImageLayer(ImageEnView.CurrentLayer)
          .BorderColor;
        UpDownBorderWidth1.Position := TIEImageLayer(ImageEnView.CurrentLayer)
          .BorderWidth;
      end;
    end;
  end;
end;

procedure TForm1.SetImageLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (ImageEnView.CurrentLayer is TIEImageLayer) then
      begin
        TIEImageLayer(ImageEnView.CurrentLayer).BorderColor :=
          LayerBorderColor1.Selected;
        TIEImageLayer(ImageEnView.CurrentLayer).FillColor :=
          LayerFillColor1.Selected;
        TIEImageLayer(ImageEnView.CurrentLayer).FillColor2 :=
          LayerFillColor2.Selected;
        TIEImageLayer(ImageEnView.CurrentLayer).BorderWidth :=
          UpDownBorderWidth1.Position;
        LayerFillColor2.Selected;
        TIEImageLayer(ImageEnView.CurrentLayer).FillGradient :=
          TIELayerGradient(LayerFillGradient1.ItemIndex);
        TIEImageLayer(ImageEnView.CurrentLayer).Transparency :=
          LayerTransparencyTrackBar1.Position;
        TIEImageLayer(ImageEnView.CurrentLayer).Opacity :=
          LayerOpacityTrackBar1.Position / 100;
        TIEImageLayer(ImageEnView.CurrentLayer).AlphaEdgeFeathering :=
          StrToInt(LayerAlphaEdgeFeathering1.Text);
        if LayerAntialias1.State = tssOff then
          TIEImageLayer(ImageEnView.CurrentLayer).AntiAlias := False
        else
          TIEImageLayer(ImageEnView.CurrentLayer).AntiAlias := True;
        TIEImageLayer(ImageEnView.CurrentLayer).Operation :=
          TIERenderOperation(LayerOperation1.ItemIndex);
        LayerOpacityLabel1.Caption :=
          FloatToStr(TIEImageLayer(ImageEnView.CurrentLayer).Opacity);
        ImageEnView.Update;
        ImageEnView.IEBitmap.Modified := True;
        UpdateFrame;
        DrawLayers;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.AddImageLayer1Click(Sender: TObject);
var
  iLayer: Integer;
  iRGB: TRGB;
  iFilename: string;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        ImageEnView.LayersDeselectAll;
        if OpenPictureDialog1.Execute then
        begin
          iFilename := OpenPictureDialog1.FileName;
          iLayer := ImageEnView.LayersAdd(iFilename);
          ImageEnView.Layers[iLayer].Name := 'Image Layer ' + IntToStr(iLayer);
          ImageEnView.Layers[iLayer].Selectable := True;
          ImageEnView.Layers[iLayer].PosX := 0;
          ImageEnView.Layers[iLayer].PosY := 0;
          ImageEnView.Layers[iLayer].Width := ImageEnView.IEBitmap.Width;
          ImageEnView.Layers[iLayer].Height := ImageEnView.IEBitmap.Height;
          ImageEnView.CurrentLayer.BorderWidth := 0;
          ImageEnView.CurrentLayer.BorderColor := LayerBorderColor1.Selected;
          ImageEnView.CurrentLayer.FillColor := LayerFillColor1.Selected;
          ImageEnView.CurrentLayer.FillColor2 := LayerFillColor2.Selected;
          ImageEnView.CurrentLayer.FillGradient :=
            TIELayerGradient(LayerFillGradient1.ItemIndex);
          ImageEnView.CurrentLayer.Transparency :=
            StrToInt(LayerTransparency1.Text);
          ImageEnView.CurrentLayer.AlphaEdgeFeathering :=
            StrToInt(LayerAlphaEdgeFeathering1.Text);
          if LayerAntialias1.State = tssOff then
            ImageEnView.CurrentLayer.AntiAlias := False
          else
            ImageEnView.CurrentLayer.AntiAlias := True;
          ImageEnView.Layers[ImageEnView.LayersCurrent].Operation :=
            TIERenderOperation(LayerOperation1.ItemIndex);
          iRGB := ImageEnView.IEBitmap.Pixels
            [0, ImageEnView.IEBitmap.Height - 1];
          ImageEnView.Proc.SetTransparentColors(iRGB, iRGB, 0);
          ImageEnView.BackgroundStyle := iebsChessboard;
          ImageEnView.IO.Params.BitsPerSample := 8;
          ImageEnView.IO.Params.SamplesPerPixel := 4;
          ImageEnView.LayersCurrent := iLayer;
          ImageEnView.Update;
          RemoveLayer1.Enabled := ImageEnView.LayersCount > 1;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateStatusBar;
          SelectLayers1.Down := True;
        end;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.GetLineLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (ImageEnView.CurrentLayer is TIELineLayer) then
      begin
        LineColor1.Selected := TIELineLayer(ImageEnView.CurrentLayer)
          .BorderColor;
        LineFillColor1.Selected := TIELineLayer(ImageEnView.CurrentLayer)
          .FillColor;
        LineWidth1.Text := IntToStr(TIELineLayer(ImageEnView.CurrentLayer)
          .LineWidth);
      end;
    end;
  end;
end;

procedure TForm1.SetLineLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (ImageEnView.CurrentLayer is TIELineLayer) then
      begin
        // SHARED STYLE PROPERTIES
        ImageEnView.CurrentLayer.BorderColor := LayerBorderColor1.Selected;
        ImageEnView.CurrentLayer.BorderWidth := UpDownBorderWidth1.Position;
        ImageEnView.CurrentLayer.FillColor := LineFillColor1.Selected;
        // LINE PROPERTIES
        if ImageEnView.CurrentLayer is TIELineLayer then
          with TIELineLayer(ImageEnView.CurrentLayer) do
          begin
            StartShape := TIELineEndShape(StartShape1.ItemIndex);
            EndShape := TIELineEndShape(EndShape1.ItemIndex);
            ShapeSize := UpDownShapeSize1.Position;
            LineColor := LineColor1.Selected;
            LineWidth := UpDownLineWidth1.Position;
          end;
        ImageEnView.Update;
        ImageEnView.IEBitmap.Modified := True;
        UpdateFrame;
        DrawLayers;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.AddLayer1Click(Sender: TObject);
var
  iLayer: Integer;
  iRGB: TRGB;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        ImageEnView.LayersDeselectAll;
        iLayer := ImageEnView.LayersAdd(ielkImage);
        ImageEnView.Layers[iLayer].Name := 'Image Layer ' +
          IntToStr(ImageEnView.LayersCount + 1);
        ImageEnView.Layers[iLayer].Selectable := True;
        ImageEnView.Layers[iLayer].PosX := 0;
        ImageEnView.Layers[iLayer].PosY := 0;
        ImageEnView.Layers[iLayer].Width := ImageEnView.IEBitmap.Width;
        ImageEnView.Layers[iLayer].Height := ImageEnView.IEBitmap.Height;
        ImageEnView.CurrentLayer.BorderWidth := 0;
        ImageEnView.CurrentLayer.BorderColor := LayerBorderColor1.Selected;
        ImageEnView.CurrentLayer.FillColor := LayerFillColor1.Selected;
        ImageEnView.CurrentLayer.FillColor2 := LayerFillColor2.Selected;
        ImageEnView.CurrentLayer.FillGradient :=
          TIELayerGradient(LayerFillGradient1.ItemIndex);
        ImageEnView.CurrentLayer.Transparency :=
          StrToInt(LayerTransparency1.Text);
        ImageEnView.CurrentLayer.AlphaEdgeFeathering :=
          StrToInt(LayerAlphaEdgeFeathering1.Text);
        if LayerAntialias1.State = tssOff then
          ImageEnView.CurrentLayer.AntiAlias := False
        else
          ImageEnView.CurrentLayer.AntiAlias := True;
        ImageEnView.Layers[ImageEnView.LayersCurrent].Operation :=
          TIERenderOperation(LayerOperation1.ItemIndex);
        iRGB := ImageEnView.IEBitmap.Pixels[0, ImageEnView.IEBitmap.Height - 1];
        ImageEnView.Proc.SetTransparentColors(iRGB, iRGB, 0);
        ImageEnView.BackgroundStyle := iebsChessboard;
        ImageEnView.IO.Params.BitsPerSample := 8;
        ImageEnView.IO.Params.SamplesPerPixel := 4;
        ImageEnView.LayersCurrent := iLayer;
        ImageEnView.Update;
        RemoveLayer1.Enabled := ImageEnView.LayersCount > 1;
        ImageEnView.IEBitmap.Modified := True;
        DrawLayers;
        UpdateStatusBar;
        SelectLayers1.Down := True;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.AddLineLayer1Click(Sender: TObject);
var
  iLayer: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        iLayer := ImageEnView.LayersAdd(ielkLine);
        ImageEnView.Layers[iLayer].Name := 'Line Layer ' + IntToStr(iLayer);
        ImageEnView.Layers[iLayer].PosX := 10;
        ImageEnView.Layers[iLayer].PosY := 10;
        TIELineLayer(ImageEnView.CurrentLayer).Width := 100;
        TIELineLayer(ImageEnView.CurrentLayer).Height := 100;
        ImageEnView.Layers[iLayer].Height := 100;
        ImageEnView.Layers[iLayer].Width := 100;
        ImageEnView.Layers[iLayer].Selectable := True;
        SelectLayers1.Down := True;
        ImageEnView.MouseInteract := ImageEnView.MouseInteract +
          [miMoveLayers, miResizeLayers];
        SetLineLayerParameters;
        DrawLayers;
        ImageEnView.IEBitmap.Modified := True;
        UpdateStatusBar;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.AddPolylineLayer1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        ImageEnView.MouseInteract := [miDrawCreatePolylineLayers];
        ImageEnView.MouseInteract := ImageEnView.MouseInteract +
          [miEditLayerPoints];
        SelectLayers1.Down := False;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.GetShapeLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (ImageEnView.CurrentLayer is TIEShapeLayer) then
      begin
        Shapes1.ItemIndex := Shapes1.Items.IndexOf
          (IEShapeToStr(TIEShapeLayer(ImageEnView.CurrentLayer).Shape));
        LayerBorderColor1.Selected := TIEShapeLayer(ImageEnView.CurrentLayer)
          .BorderColor;
        LayerFillColor1.Selected := TIEShapeLayer(ImageEnView.CurrentLayer)
          .FillColor;
        LayerFillColor2.Selected := TIEShapeLayer(ImageEnView.CurrentLayer)
          .FillColor;
        UpDownBorderWidth1.Position := TIEShapeLayer(ImageEnView.CurrentLayer)
          .BorderWidth;
        Shapes1.ItemIndex := ord(TIEShapeLayer(ImageEnView.CurrentLayer).Shape);
        Shapes1.Refresh;
      end;
    end;
  end;
end;

procedure TForm1.SetShapeLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (ImageEnView.CurrentLayer is TIEShapeLayer) then
      begin
        TIEShapeLayer(ImageEnView.CurrentLayer).Shape :=
          TIEShape(Shapes1.ItemIndex);
        TIEShapeLayer(ImageEnView.CurrentLayer).BorderColor :=
          LayerBorderColor1.Selected;
        TIEShapeLayer(ImageEnView.CurrentLayer).FillColor :=
          LayerFillColor1.Selected;
        TIEShapeLayer(ImageEnView.CurrentLayer).Transparency :=
          LayerTransparencyTrackBar1.Position;
        TIEShapeLayer(ImageEnView.CurrentLayer).BorderWidth :=
          UpDownBorderWidth1.Position;
        ImageEnView.Update;
        Shapes1.Refresh;
        ImageEnView.IEBitmap.Modified := True;
        UpdateFrame;
        DrawLayers;
        UpdateStatusBar;
      end;
    end;
  end
  else
  begin
    Shapes1.Refresh;
  end;
end;

procedure TForm1.GetPolylineLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (ImageEnView.CurrentLayer is TIEPolylineLayer) then
      begin
        if TIEPolylineLayer(ImageEnView.CurrentLayer).PolylineClosed then
          PolylineClosed1.State := tssOn;
        UpDownPolylineLayerWidth1.Position :=
          TIEPolylineLayer(ImageEnView.CurrentLayer).LineWidth;
        PolylineLayerLineColor1.Selected :=
          TIEPolylineLayer(ImageEnView.CurrentLayer).LineColor;
        PolylineLayerFillColor1.Selected :=
          TIEPolylineLayer(ImageEnView.CurrentLayer).FillColor;
        PolylineLayerFillColor2.Selected :=
          TIEPolylineLayer(ImageEnView.CurrentLayer).FillColor2;
        TrackBarPolylineTransparency1.Position :=
          TIEPolylineLayer(ImageEnView.CurrentLayer).Transparency;
        TrackBarPolylineLayerOpacity1.Position :=
          Round(TIEPolylineLayer(ImageEnView.CurrentLayer).Opacity * 100);
        LabelPolylineLayerOpacity1.Caption :=
          FloatToStr(TIEImageLayer(ImageEnView.CurrentLayer).Opacity);
        PolylineLayerOperation1.ItemIndex :=
          ord(TIEPolylineLayer(ImageEnView.CurrentLayer).Operation);
      end;
    end;
  end;
end;

procedure TForm1.SetPolylineLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (ImageEnView.CurrentLayer is TIEPolylineLayer) then
      begin
        TIEPolylineLayer(ImageEnView.CurrentLayer).PolylineClosed :=
          PolylineClosed1.State = tssOn;
        TIEPolylineLayer(ImageEnView.CurrentLayer).LineWidth :=
          UpDownPolylineLayerWidth1.Position;
        TIEPolylineLayer(ImageEnView.CurrentLayer).LineColor :=
          PolylineLayerLineColor1.Selected;
        TIEPolylineLayer(ImageEnView.CurrentLayer).FillColor :=
          PolylineLayerFillColor1.Selected;
        TIEPolylineLayer(ImageEnView.CurrentLayer).FillColor2 :=
          PolylineLayerFillColor2.Selected;
        TIEPolylineLayer(ImageEnView.CurrentLayer).Transparency :=
          TrackBarPolylineTransparency1.Position;
        TIEPolylineLayer(ImageEnView.CurrentLayer).Opacity :=
          TrackBarPolylineLayerOpacity1.Position / 100;
        LabelPolylineLayerOpacity1.Caption :=
          FloatToStr(TIEImageLayer(ImageEnView.CurrentLayer).Opacity);
        TIEPolylineLayer(ImageEnView.CurrentLayer).Operation :=
          TIERenderOperation(PolylineLayerOperation1.ItemIndex);
        ImageEnView.Update;
        ImageEnView.IEBitmap.Modified := True;
        UpdateFrame;
        DrawLayers;
        UpdateStatusBar;
      end;
    end;
  end
  else
  begin
    Shapes1.Refresh;
  end;
end;

procedure TForm1.AddShapeLayer1Click(Sender: TObject);
var
  iIEShape: TIEShape;
  iLayer: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        iIEShape := TIEShape(Shapes1.ItemIndex);
        iLayer := ImageEnView.LayersAdd(iIEShape);
        ImageEnView.CurrentLayer.FillColor := LayerFillColor1.Selected;
        ImageEnView.CurrentLayer.BorderWidth := UpDownBorderWidth1.Position;
        ImageEnView.Update();
        ImageEnView.Layers[iLayer].Name := 'Shape Layer ' + IntToStr(iLayer);
        ImageEnView.CurrentLayer.Width := 50;
        ImageEnView.CurrentLayer.Height := 50;
        if TIEShapeLayer(ImageEnView.CurrentLayer).Shape in Shapes_Supporting_Modifier
        then
        begin
          case TIEShapeLayer(ImageEnView.CurrentLayer).Shape of
            iesCustomShape:
              UpDownModifier1.Position := 10;
            iesCustomStar:
              UpDownModifier1.Position := 10;
            iesCustomExplosion:
              UpDownModifier1.Position := 12;
            iesEllipseSegment:
              UpDownModifier1.Position := 45;
            iesCustomCog:
              UpDownModifier1.Position := 12;
            iesCustomAsterisk:
              UpDownModifier1.Position := 12;
            iesCustomFlower:
              UpDownModifier1.Position := 12;
            iesCustomRadiance:
              UpDownModifier1.Position := 12;
            iesCustomRadiance2:
              UpDownModifier1.Position := 12;
          end;
        end;
        DrawLayers;
        SelectLayers1.Down := True;
        ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.AddTabsheet;
{ Add a tabsheet to the pagecontrol. }
begin
  { create a new tabsheet }
  with PageControl1 do
    TabSheet := TTabSheet.Create(Self);
  { set the tabsheet.pagecontrol to PageControl1 }
  TabSheet.PageControl := PageControl1;
  { set the activepage to tabsheet }
  PageControl1.ActivePage := TabSheet;
  with TabSheet do
  begin
    ShowHint := True;
    ImageEnView := TImageEnView.Create(Self);
    ImageEnView.Parent := TabSheet;
    ImageEnView.Left := 0;
    ImageEnView.Top := 0;
    ImageEnView.Align := alClient;
    ImageEnView.Cursor := 1784;
    ImageEnView.AutoCursors := True;
    if Rulers1.State = tssOn then
      ImageEnView.ShowRulers := [rdHorizontal, rdVertical]
    else
      ImageEnView.ShowRulers := [];
    ImageEnView.Proc.UndoLimit := 99;
    ImageEnView.Proc.AutoUndo := False;
    ImageEnView.BackGround := clWhite;
    ImageEnView.Visible := True;
    ImageEnView.ShowHint := True;
    ImageEnView.BorderStyle := bsNone;
    ImageEnView.DisplayGrid := DisplayGrid1.State = tssOn;
    ImageEnView.SetChessboardStyle(8);
    ImageEnView.IO.Params.BMP_HandleTransparency := True;
    ImageEnView.PopupMenu := ImageEnPopupMenu1;
    ImageEnView.MouseInteract := [];
    ImageEnView.Gestures.Pan.Enabled := False;
    ImageEnView.Gestures.Zoom.Enabled := True;
    ImageEnView.SelectionOptions := ImageEnView.SelectionOptions +
      [iesoSelectTranspLayers, iesoAllowMoveByKeyboard, iesoCutBorders];
    ImageEnView.LayerOptions := ImageEnView.LayerOptions -
      [loAllowMultiSelect, loPreventOutOfBounds];
    ImageEnView.LayerOptions := ImageEnView.LayerOptions + [loPropsOnDblClick];
    ImageEnView.Center := True;
    ImageEnView.ZoomFilter := rfNone;
    ImageEnView.DelayZoomFilter := False;
    ImageEnView.ZoomFilter := rfNone;
    ImageEnView.DelayZoomFilter := False;
    ImageEnView.LayersRotationFilter := ierBicubic;
    ImageEnView.LayersRotationAntialias := True;
    ImageEnView.LayersRotationUseFilterOnPreview := False;
    ImageEnView.LayersFastDrawing := iefFast;
    ImageEnView.LayersRotationFilter := ierBicubic;
    ImageEnView.LayersRotationAntialias := True;
    ImageEnView.LayersRotationUseFilterOnPreview := False;
    ImageEnView.SetLayersGripStyle(clBlack, clLime, bsSolid, 5, iegsCircle);
    ImageEnView.Layers[0].VisibleBox := True;
    ImageEnView.Layers[0].Selectable := True;
    ImageEnView1.Layers[0].Locked := False;
    ImageEnView.BrushTool.BrushImage.Assign(ImageEnView2.Bitmap);
    ImageEnView.BrushTool.BrushImage.SetTransparentColors(clWhite, clWhite, 0);
    ImageEnView.OnNewLayer := ImageEnViewNewLayer;
    ImageEnView.OnViewChange := ImageEnViewViewChange;
    ImageEnView.OnImageChange := ImageEnViewImageChange;
    ImageEnView.OnKeyUp := ImageEnViewKeyUp;
    ImageEnView.OnMouseDown := ImageEnViewMouseDown;
    ImageEnView.OnMouseUp := ImageEnViewMouseUp;
    ImageEnView.OnMeasure := ImageEnViewMeasure;
    ImageEnView.OnMouseMove := ImageEnViewMouseMove;
    ImageEnView.OnLayerNotify := ImageEnViewLayerNotify;
    ImageEnView.OnSelectionChange := ImageEnViewLayerSelectionChange;
    ImageEnView.OnDrawLayerBox := ImageEnViewDrawLayerBox;
    ImageEnView.OnUserInteraction := ImageEnViewUserInteraction;
    ImageEnLayerMView1.AttachedImageEnView := ImageEnView;
    ImageEnLayerMView1.LayerOptions := ImageEnLayerMView1.LayerOptions +
      [lvSelection, lvVisibilityButton, lvLockButton, lvDragOrdering];
    ImageEnLayerMView1.LayerOrder := ieloBackgroundFirst;
    // ImageEnView.OnDrawBackBuffer := ImageEnViewDrawBackBuffer;
    // ImageEnView.OnDrawCanvas := ImageEnViewDrawCanvas;
    // ImageEnView.OnPaint := ImageEnViewPaint;
    // ImageEnView.OnSelectionChanging := ImageEnViewSelectionChanging;
    // ImageEnView.OnKeyDown := ImageEnViewKeyDown;
    // ImageEnView.OnSpecialKey := ImageEnViewSpecialKey;
    // ImageEnView.OnFinishWork := ImageEnViewFinishWork;
    // ImageEnView.OnProgress := ImageEnViewProgress;
    // ImageEnView.OnDrawLayer := ImageEnViewDrawLayer;
    // ImageEnView.Proc.OnProgress := ImageEnViewProgress;
    // ImageEnView.Proc.OnFinishWork := ImageEnViewFinishWork;
    // ImageEnView.OnProgress := ImageEnViewProgress;
    // ImageEnView.OnFinishWork := ImageEnViewFinishWork;
    // ImageEnView.OnMouseInSel := ImageEnViewMouseInSel;
  end;
end;

procedure TForm1.GetTextLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if (ImageEnView.CurrentLayer is TIETextLayer) then
      begin
        TextLayerText1.Text := TIETextLayer(ImageEnView.CurrentLayer).Text;
        LayerBorderColor1.Selected := TIETextLayer(ImageEnView.CurrentLayer)
          .BorderColor;
        LayerFillColor1.Selected := TIETextLayer(ImageEnView.CurrentLayer)
          .FillColor;
        LayerFillColor2.Selected := TIETextLayer(ImageEnView.CurrentLayer)
          .FillColor2;
        UpDownBorderWidth1.Position := TIETextLayer(ImageEnView.CurrentLayer)
          .BorderWidth;
        FontDialog1.Font.Name := TIETextLayer(ImageEnView.CurrentLayer)
          .Font.Name;
        FontDialog1.Font.Size := TIETextLayer(ImageEnView.CurrentLayer)
          .Font.Size;
        FontDialog1.Font.Color := TIETextLayer(ImageEnView.CurrentLayer)
          .Font.Color;
        TextLayerAlignment1.ItemIndex :=
          ord(TIETextLayer(ImageEnView.CurrentLayer).Alignment);
        TextLayerLayout1.ItemIndex :=
          ord(TIETextLayer(ImageEnView.CurrentLayer).Layout);
        TextLayerShape1.ItemIndex :=
          ord(TIETextLayer(ImageEnView.CurrentLayer).BorderShape);
        TextLayerOverflow1.ItemIndex :=
          ord(TIETextLayer(ImageEnView.CurrentLayer).TextOverflow);
        if TIETextLayer(ImageEnView.CurrentLayer).AutoSize = True then
          TextAutoSize1.State := tssOn
        else
          TextAutoSize1.State := tssOff;
        if TIETextLayer(ImageEnView.CurrentLayer).ReadOnly = True then
          TextReadOnly1.State := tssOn
        else
          TextReadOnly1.State := tssOff;
        if TIETextLayer(ImageEnView.CurrentLayer).WordWrap = True then
          TextWordWrap1.State := tssOn
        else
          TextWordWrap1.State := tssOff;
      end;
    end;
  end;
end;

procedure TForm1.SetTextLayerParameters;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIETextLayer then
      begin
        TIETextLayer(ImageEnView.CurrentLayer).BorderColor :=
          LayerBorderColor1.Selected;
        TIETextLayer(ImageEnView.CurrentLayer).FillColor :=
          LayerFillColor1.Selected;
        TIETextLayer(ImageEnView.CurrentLayer).FillColor2 :=
          LayerFillColor2.Selected;
        TIETextLayer(ImageEnView.CurrentLayer).BorderWidth :=
          UpDownBorderWidth1.Position;
        TIETextLayer(ImageEnView.CurrentLayer).Font.Name :=
          FontDialog1.Font.Name;
        TIETextLayer(ImageEnView.CurrentLayer).Font.Size :=
          FontDialog1.Font.Size;
        TIETextLayer(ImageEnView.CurrentLayer).Font.Color :=
          FontDialog1.Font.Color;
        if TextAutoSize1.State = tssOn then
          TIETextLayer(ImageEnView.CurrentLayer).AutoSize := True
        else
          TIETextLayer(ImageEnView.CurrentLayer).AutoSize := False;
        if LayerAntialias1.State = tssOn then
          TIETextLayer(ImageEnView.CurrentLayer).AntiAlias := True
        else
          TIETextLayer(ImageEnView.CurrentLayer).AntiAlias := False;
        with TIETextLayer(ImageEnView.CurrentLayer) do
        begin
          Text := TextLayerText1.Text;
          TextOverflow := TIETextOverflow(TextLayerOverflow1.ItemIndex);
          Alignment := TIEAlignment(TextLayerAlignment1.ItemIndex);
          Layout := TIELayout(TextLayerLayout1.ItemIndex);
          if TextLayerShape1.ItemIndex >= 0 then
            BorderShape := TIEShape(TextLayerShape1.ItemIndex);
          ReadOnly := TextReadOnly1.State = tssOn;
          WordWrap := TextWordWrap1.State = tssOn;
        end;
        ImageEnView.IEBitmap.Modified := True;
        ImageEnView.Update;
        UpdateFrame;
        DrawLayers;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.AddTextLayer1Click(Sender: TObject);
var
  iLayer: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Screen.Cursor := crHourglass;
      try
        iLayer := ImageEnView.LayersAdd(ielkText);
        ImageEnView.Layers[iLayer].Name := 'Text Layer ' + IntToStr(iLayer);
        RemoveLayer1.Enabled := ImageEnView.LayersCount > 1;
        ImageEnView.IEBitmap.Modified := True;
        ImageEnView.CurrentLayer.Width := 300;
        ImageEnView.CurrentLayer.Height := 150;
        TextLayerText1.Text := IEGlobalSettings().DefaultLayerText;
        TIELineLayer(ImageEnView.CurrentLayer).SizeToFit;
        SetTextLayerParameters;
        ImageEnView.Update;
        DrawLayers;
        UpdateStatusBar;
        SelectLayers1.Down := True;
        ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.AdjustGainOffset1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Adjust Gain Offset ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo1.Enabled := ImageEnView.Proc.CanUndo;
          Undo2.Enabled := ImageEnView.Proc.CanUndo;
          ImageEnView.Proc.AdjustGainOffset;
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.ConvertTo32Bit;
var
  iRGB: TRGB;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Convert to 32-Bit ' +
        IntToStr(ImageEnView.Proc.UndoCount));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      Redo1.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo1.Enabled := ImageEnView.Proc.CanRedo;
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Enabled := ImageEnView.Proc.CanUndo;
      Redo2.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo2.Enabled := ImageEnView.Proc.CanRedo;
      ImageEnView.EnableAlphaChannel := True;
      iRGB := ImageEnView.IEBitmap.Pixels[0, ImageEnView.IEBitmap.Height - 1];
      ImageEnView.Proc.SetTransparentColors(iRGB, iRGB, 0);
      ImageEnView.BackgroundStyle := iebsChessboard;
      ImageEnView.IO.Params.BitsPerSample := 8;
      ImageEnView.IO.Params.SamplesPerPixel := 4;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnView.Update;
      ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
        ImageEnView.IEBitmap);
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := 8;
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]
        .SamplesPerPixel := 4;
      ImageEnMView1.Update;
      ImageEnView.IEBitmap.Modified := True;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.ConvertTo32Bit1Click(Sender: TObject);
begin
  ConvertTo32Bit;
end;

procedure TForm1.ConvertTo24Bit;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Convert to 24-Bit ' +
        IntToStr(ImageEnView.Proc.UndoCount));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      Redo1.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo1.Enabled := ImageEnView.Proc.CanRedo;
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Enabled := ImageEnView.Proc.CanUndo;
      Redo2.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo2.Enabled := ImageEnView.Proc.CanRedo;
      ImageEnView.IO.Params.BitsPerSample := 8;
      ImageEnView.IO.Params.SamplesPerPixel := 3;
      ImageEnView.RemoveAlphaChannel();
      ImageEnView.BackgroundStyle := iebsSolid;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnView.Update;
      ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
        ImageEnView.IEBitmap);
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := 8;
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]
        .SamplesPerPixel := 3;
      ImageEnMView1.Update;
      ImageEnView.IEBitmap.Modified := True;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.ConvertTo4Bit;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Convert to 4-Bit ' +
        IntToStr(ImageEnView.Proc.UndoCount));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      Redo1.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo1.Enabled := ImageEnView.Proc.CanRedo;
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Enabled := ImageEnView.Proc.CanUndo;
      Redo2.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo2.Enabled := ImageEnView.Proc.CanRedo;
      ImageEnView.RemoveAlphaChannel();
      ImageEnView.Proc.ConvertTo(16);
      ImageEnView.IO.Params.BitsPerSample := 4;
      ImageEnView.IO.Params.SamplesPerPixel := 1;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnView.BackgroundStyle := iebsSolid;
      ImageEnView.Update;
      ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
        ImageEnView.IEBitmap);
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := 4;
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]
        .SamplesPerPixel := 1;
      ImageEnMView1.Update;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.ConvertTo24Bit1Click(Sender: TObject);
begin
  ConvertTo24Bit;
end;

procedure TForm1.ConvertTo8Bit;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Convert to 8-Bit ' +
        IntToStr(ImageEnView.Proc.UndoCount));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      Redo1.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo1.Enabled := ImageEnView.Proc.CanRedo;
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Enabled := ImageEnView.Proc.CanUndo;
      Redo2.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo2.Enabled := ImageEnView.Proc.CanRedo;
      ImageEnView.RemoveAlphaChannel();
      ImageEnView.Proc.ConvertTo(256);
      ImageEnView.IO.Params.BitsPerSample := 8;
      ImageEnView.IO.Params.SamplesPerPixel := 1;
      ImageEnView.BackgroundStyle := iebsSolid;
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
        ImageEnView.IEBitmap);
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := 8;
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]
        .SamplesPerPixel := 1;
      ImageEnMView1.Update;
      ImageEnView.IEBitmap.Modified := True;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.ConvertTo8Bit1Click(Sender: TObject);
begin
  ConvertTo8Bit;
end;

procedure TForm1.ConvertToGray1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Convert to Grayscale ' +
        IntToStr(ImageEnView.Proc.UndoCount));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      Redo1.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo1.Enabled := ImageEnView.Proc.CanRedo;
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Enabled := ImageEnView.Proc.CanUndo;
      Redo2.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo2.Enabled := ImageEnView.Proc.CanRedo;
      ImageEnView.Proc.ConvertToGray;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnView.BackgroundStyle := iebsSolid;
      ImageEnView.Update;
      ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
        ImageEnView.IEBitmap);
      ImageEnMView1.Update;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.ConvertTo4Bit1Click(Sender: TObject);
begin
  ConvertTo4Bit;
end;

procedure TForm1.ConvertTo1Bit;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Convert to 1-Bit ' +
        IntToStr(ImageEnView.Proc.UndoCount));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      Redo1.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo1.Enabled := ImageEnView.Proc.CanRedo;
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Enabled := ImageEnView.Proc.CanUndo;
      Redo2.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo2.Enabled := ImageEnView.Proc.CanRedo;
      ImageEnView.RemoveAlphaChannel();
      ImageEnView.Proc.ConvertToBWLocalThreshold(8, ietMean);
      ImageEnView.IO.Params.BitsPerSample := 1;
      ImageEnView.IO.Params.SamplesPerPixel := 1;
      ImageEnView.IEBitmap.Modified := True;
      ImageEnView.BackgroundStyle := iebsSolid;
      ImageEnView.Update;
      ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
        ImageEnView.IEBitmap);
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].BitsPerSample := 1;
      ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]
        .SamplesPerPixel := 1;
      ImageEnMView1.Update;
      UpdateFrame;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.ConvertTo1Bit1Click(Sender: TObject);
begin
  ConvertTo1Bit;
end;

procedure TForm1.Undo1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.Undo(True);
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      Redo1.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo1.Enabled := ImageEnView.Proc.CanRedo;
      Undo2.Enabled := ImageEnView.Proc.CanUndo;
      Redo2.Hint := ImageEnView.Proc.RedoCaptions[0];
      Redo2.Enabled := ImageEnView.Proc.CanRedo;
      ImageEnView.IEBitmap.Modified := ImageEnView.Proc.CanUndo;
      if Fit1.State = tssOn then
        ImageEnView.Fit
      else
        ImageEnView.Zoom := 100;
      UpdateTabSheets;
      UpdateFrame;
      DrawLayers;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.Darken1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo
            ('Darken ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo1.Enabled := ImageEnView.Proc.CanUndo;
          Undo2.Enabled := ImageEnView.Proc.CanUndo;
          ImageEnView.Proc.AdjustBrightnessContrastSaturation(-10, 0, 0);
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.DecreaseBrightness1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Brightness ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo1.Enabled := ImageEnView.Proc.CanUndo;
          Undo2.Enabled := ImageEnView.Proc.CanUndo;
          ImageEnView.Proc.AdjustBrightnessContrastSaturation(-10, 0, 0);
          ImageEnView.Update;
          ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
            ImageEnView.IEBitmap);
          ImageEnMView1.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.DeSkew1Click(Sender: TObject);
var
  i: Double;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo
            ('DeSkew ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo1.Enabled := ImageEnView.Proc.CanUndo;
          Undo2.Enabled := ImageEnView.Proc.CanUndo;
          i := ImageEnView.Proc.SkewDetection;
          ImageEnView.Proc.RotateAndCrop(i);
          ImageEnView.Update;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Desktop1Click(Sender: TObject);
var
  iPath: string;
  iFilename: string;
  iExtension: string;
  iDimensions: string;
  iBitDepth: Integer;
  iColor: string;
  iMaximized: Boolean;
begin
  iMaximized := WindowState = wsMaximized;
  WindowState := wsMinimized;
  try
    Sleep(500);
    AddTabsheet;
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        iFilename := DesktopFolder + 'Desktop Capture ' +
          IntToStr(PageControl1.PageCount);
        iExtension := '.jpg';
        iPath := iFilename + iExtension;
        ImageEnView.IO.CaptureFromScreen(iecsScreen, -1);
        ImageEnView.IO.Params.FileName := iPath;
        ImageEnMView1.AppendImage(ImageEnView.IEBitmap);
        ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
        ImageEnView.IEBitmap.UpdateFromTBitmap;
        ImageEnView.CurrentLayer.Name := 'Desktop Capture';
        ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
        ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
        ImageEnView.IO.Params.BitsPerSample := 8;
        ImageEnView.IO.Params.SamplesPerPixel := 3;
        Undo1.Enabled := ImageEnView.Proc.UndoCount <> 0;
        if Fit1.State = tssOn then
          ImageEnView.Zoom := ImageEnView.GetIdealZoom -
            ImageEnView.GetIdealZoom * 0.025;
        iDimensions := IntegerToString(ImageEnView.IO.Params.Width) + ' x ' +
          IntegerToString(ImageEnView.IO.Params.Height) + ' ';
        iBitDepth := ImageEnView.IO.Params.SamplesPerPixel *
          ImageEnView.IO.Params.BitsPerSample;
        iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
        PageControl1.ActivePage.Caption := 'Desktop Capture ' +
          IntToStr(PageControl1.PageCount) + '- ' + iDimensions + iColor;
        PageControl1.ActivePage.Hint := iFilename + iExtension;
        iDimensions := IntegerToString(ImageEnView.IEBitmap.Width) + ' x ' +
          IntegerToString(ImageEnView.IEBitmap.Height);
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width :=
          ImageEnView.IEBitmap.Width;
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height :=
          ImageEnView.IEBitmap.Height;
        if iBitDepth = 32 then
          iColor := 'RGBA 32-Bit'
        else
          iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
        ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions +
          ' ' + iColor;
        ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] :=
          'Desktop Capture ' + IntToStr(PageControl1.PageCount) + iExtension;
      end;
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      UpdateTabSheets;
      DrawLayers;
      UpdateStatusBar;
    end;
  finally
    if iMaximized then
      WindowState := wsMaximized
    else
      WindowState := wsNormal;
    if Fit1.State = tssOn then
      ImageEnView.Fit
    else
      ImageEnView.Zoom := 100;
  end;
end;

procedure TForm1.DisplayGrid1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      for i := 0 to PageControl1.PageCount - 1 do
      begin
        ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
        if Assigned(ImageEnView) then
        begin
          if DisplayGrid1.State = tssOn then
            ImageEnView.DisplayGrid := True
          else
            ImageEnView.DisplayGrid := False;
        end;
      end;
    end;
  end;
end;

procedure TForm1.DrawLayers;
{ Draw Layers to TImageEnMView }
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
        ImageEnView.Layers[0].Bitmap);
      ImageEnView.LayersDrawTo(ImageEnMView1.IEBitmap, True);
      ImageEnMView1.UpdateImage(ImageEnMView1.SelectedImage);
      ImageEnMView1.Update;
    end;
  end;
end;

procedure TForm1.TransparencyMode1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      for i := 0 to PageControl1.PageCount - 1 do
      begin
        ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
        if Assigned(ImageEnView) then
        begin
          if TransparencyMode1.State = tssOn then
            ImageEnView.BrushTool.TransparencyMode := ietmCompositing
          else
            ImageEnView.BrushTool.TransparencyMode := ietmReplace;
        end;
      end;
    end;
  end;
end;

procedure TForm1.LayerMagnification1Change(Sender: TObject);
var
  iIELayer: TIELayer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iIELayer := ImageEnView.CurrentLayer;
      if (iIELayer is TIEImageLayer) and (MagnificationStyle1.ItemIndex > -1)
      then
        with TIEImageLayer(iIELayer) do
        begin
          iIELayer.IsMask := LayerMask1.State = tssOn;
          Magnify.Enabled := MagnificationLayer1.State = tssOn;
          Magnify.Rate := LayerMagnification1.Position / 10;
          Magnify.Style := TIEMagnifyStyle(MagnificationStyle1.ItemIndex);
          Magnify.Source := TIEMagnifySource(MagnifySource1.ItemIndex);
        end;
    end;
  end;
end;

procedure TForm1.UpdateUndo;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Undo1.Enabled := ImageEnView.Proc.CanUndo;
      Undo2.Enabled := ImageEnView.Proc.CanUndo;
      Redo1.Enabled := ImageEnView.Proc.CanRedo;
      Redo2.Enabled := ImageEnView.Proc.CanRedo;
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
    end;
  end
  else
  begin
    Undo1.Enabled := False;
    Undo2.Enabled := False;
    Redo1.Enabled := False;
    Redo2.Enabled := False;
  end;
end;

procedure TForm1.UpdateTabSheets;
var
  i: Integer;
  iFilename: string;
  iDimensions: string;
  iBitDepth: Integer;
  iColor: string;
begin
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    iFilename := ImageEnMView1.ImageFileName[i];
    iDimensions := IntegerToString(ImageEnView.IEBitmap.Width) + ' x ' +
      IntegerToString(ImageEnView.IEBitmap.Height) + ' ';
    iBitDepth := ImageEnView.IO.Params.SamplesPerPixel *
      ImageEnView.IO.Params.BitsPerSample;
    iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
    if IEGetFileFramesCount(iFilename) > 1 then
      PageControl1.Pages[i].Caption := 'Frame ' + IntToStr(i + 1)
    else
      PageControl1.Pages[i].Caption := ExtractFileName(iFilename) + ' ' +
        iDimensions + iColor;
    PageControl1.Pages[i].Hint := iFilename;
  end;
end;

procedure TForm1.UpdateGUI;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      Save1.Enabled := (PageControl1.PageCount > 0) and
        (ImageEnView.IEBitmap.Modified);
      SaveAs1.Enabled := (PageControl1.PageCount > 0);
      OpenLayers1.Enabled := True;
      SaveLayers1.Enabled := ImageEnView.LayersCount > 1;
      Close1.Enabled := (PageControl1.PageCount > 0);
      CloseAll1.Enabled := (PageControl1.PageCount > 1);
      PrintPreview1.Enabled := (PageControl1.PageCount > 0);
      WindowsPriintWizard1.Enabled := (PageControl1.PageCount > 0);
      AddFrame1.Enabled := (PageControl1.PageCount > 0);
      RemoveFrame1.Enabled := (PageControl1.PageCount > 0);
      AddLayer1.Enabled := (PageControl1.PageCount > 0);
      AddImageLayer1.Enabled := (PageControl1.PageCount > 0);
      AddTextLayer1.Enabled := (PageControl1.PageCount > 0);
      AddShapeLayer1.Enabled := (PageControl1.PageCount > 0);
      AddLineLayer1.Enabled := (PageControl1.PageCount > 0);
      AddPolylineLayer1.Enabled := (PageControl1.PageCount > 0);
      RemoveLayer1.Enabled := (PageControl1.PageCount > 0) and
        (ImageEnView.LayersCurrent > 0);
      MergeLayer1.Enabled := (PageControl1.PageCount > 0) and
        (ImageEnView.LayersCount > 1);
      MergeAllLayers1.Enabled := (PageControl1.PageCount > 0) and
        (ImageEnView.LayersCount > 1);
      SelectNone1.Enabled := (PageControl1.PageCount > 0);
      SelectLayers1.Enabled := (PageControl1.PageCount > 0);
      Selection1.Enabled := (PageControl1.PageCount > 0);
      SelectPolygon1.Enabled := (PageControl1.PageCount > 0);
      SelectCircle1.Enabled := (PageControl1.PageCount > 0);
      SelectMagicWand1.Enabled := (PageControl1.PageCount > 0);
      SelectLasso1.Enabled := (PageControl1.PageCount > 0);
      SelectRotation1.Enabled := (PageControl1.PageCount > 0);
      MeasureLength1.Enabled := (PageControl1.PageCount > 0);
      NoTools1.Enabled := (PageControl1.PageCount > 0);
      BrushTools1.Enabled := (PageControl1.PageCount > 0);
      CloneTools1.Enabled := (PageControl1.PageCount > 0);
      CropTools1.Enabled := (PageControl1.PageCount > 0);
      FloodFillTool1.Enabled := (PageControl1.PageCount > 0);
      FloodFillAlphaTool1.Enabled := (PageControl1.PageCount > 0);
      Undo1.Enabled := (PageControl1.PageCount > 0) and
        (ImageEnView.Proc.CanUndo);
      Redo1.Enabled := (PageControl1.PageCount > 0) and
        (ImageEnView.Proc.CanRedo);
      Resample1.Enabled := (PageControl1.PageCount > 0);
      Resize1.Enabled := (PageControl1.PageCount > 0);
      Crop2.Enabled := (PageControl1.PageCount > 0) and (ImageEnView.Selected);
      FlipHorizontal1.Enabled := (PageControl1.PageCount > 0);
      FlipVertical1.Enabled := (PageControl1.PageCount > 0);
      Rotate1.Enabled := (PageControl1.PageCount > 0);
      AutoEnhance1.Enabled := (PageControl1.PageCount > 0);
      AutoEnhance2.Enabled := (PageControl1.PageCount > 0);
      AutoEnhance3.Enabled := (PageControl1.PageCount > 0);
      AdjustGainOffset1.Enabled := (PageControl1.PageCount > 0);
      AutoSharp1.Enabled := (PageControl1.PageCount > 0);
      HistAutoEqualize1.Enabled := (PageControl1.PageCount > 0);
      WhiteBalanceAutoWhite1.Enabled := (PageControl1.PageCount > 0);
      WhiteBalanceGrayWorld1.Enabled := (PageControl1.PageCount > 0);
      Brighten1.Enabled := (PageControl1.PageCount > 0);
      Darken1.Enabled := (PageControl1.PageCount > 0);
      RemoveRedEye1.Enabled := (PageControl1.PageCount > 0);
      Tint1.Enabled := (PageControl1.PageCount > 0);
    end
    else
    begin

    end;
  end
  else
  begin
    Save1.Enabled := False;
    SaveAs1.Enabled := False;
    OpenLayers1.Enabled := True;
    SaveLayers1.Enabled := False;
    Close1.Enabled := False;
    CloseAll1.Enabled := False;
    PrintPreview1.Enabled := False;
    WindowsPriintWizard1.Enabled := False;
    AddFrame1.Enabled := False;
    RemoveFrame1.Enabled := False;
    AddLayer1.Enabled := False;
    AddImageLayer1.Enabled := False;
    AddTextLayer1.Enabled := False;
    AddShapeLayer1.Enabled := False;
    AddLineLayer1.Enabled := False;
    AddPolylineLayer1.Enabled := False;
    RemoveLayer1.Enabled := False;
    MergeLayer1.Enabled := False;
    MergeAllLayers1.Enabled := False;
    SelectNone1.Enabled := False;
    SelectLayers1.Enabled := False;
    Selection1.Enabled := False;
    SelectPolygon1.Enabled := False;
    SelectCircle1.Enabled := False;
    SelectMagicWand1.Enabled := False;
    SelectLasso1.Enabled := False;
    SelectRotation1.Enabled := False;;
    MeasureLength1.Enabled := False;;
    NoTools1.Enabled := False;;
    BrushTools1.Enabled := False;;
    CloneTools1.Enabled := False;;
    CropTools1.Enabled := False;
    FloodFillTool1.Enabled := False;
    FloodFillAlphaTool1.Enabled := False;
    Undo1.Enabled := False;
    Redo1.Enabled := False;
    Resample1.Enabled := False;
    Resize1.Enabled := False;
    Crop2.Enabled := False;
    FlipHorizontal1.Enabled := False;
    FlipVertical1.Enabled := False;
    Rotate1.Enabled := False;
    AutoEnhance1.Enabled := False;
    AutoEnhance2.Enabled := False;
    AutoEnhance3.Enabled := False;
    AdjustGainOffset1.Enabled := False;
    AutoSharp1.Enabled := False;
    HistAutoEqualize1.Enabled := False;
    WhiteBalanceAutoWhite1.Enabled := False;
    WhiteBalanceGrayWorld1.Enabled := False;
    Brighten1.Enabled := False;
    Darken1.Enabled := False;
    RemoveRedEye1.Enabled := False;
    Tint1.Enabled := False;
  end;
end;

procedure TForm1.UpdateFrame;
var
  iDimensions: string;
  iColor: string;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnMView1.SelectedImage <> -1 then
      begin
        iDimensions := IntegerToString(ImageEnView.IEBitmap.Width) + ' x ' +
          IntegerToString(ImageEnView.IEBitmap.Height);
        if ImageEnView.IO.Params.BitsPerSample *
          ImageEnView.IO.Params.SamplesPerPixel = 32 then
          iColor := 'RGBA ' + IntToStr(ImageEnView.IO.Params.BitsPerSample *
            ImageEnView.IO.Params.SamplesPerPixel) + '-Bit'
        else
          iColor := 'RGB ' + IntToStr(ImageEnView.IO.Params.BitsPerSample *
            ImageEnView.IO.Params.SamplesPerPixel) + '-Bit';
        ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions +
          ' ' + iColor;
        if FileExists(AFilename) then
          if IEGetFileFramesCount(AFilename) > 1 then
            ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] :=
              'Frame ' + IntToStr(ImageEnMView1.SelectedImage + 1)
          else
            ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] :=
              ExtractFileName(AFilename);
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]
          .Assign(ImageEnView.IO.Params);
      end;
    end;
  end;
end;

procedure TForm1.UpdateFrames;
var
  i: Integer;
  iDimensions: string;
  iColor: string;
  iIndex: Integer;
begin
  if ImageEnMView1.ImageCount > 0 then
  begin
    iIndex := ImageEnMView1.SelectedImage;
    for i := 0 to ImageEnMView1.ImageCount - 1 do
    begin
      ImageEnMView1.SelectedImage := i;
      iDimensions := IntegerToString(ImageEnMView1.IEBitmap.Width) + ' x ' +
        IntegerToString(ImageEnMView1.IEBitmap.Height);
      if ImageEnMView1.MIO.Params[i].BitsPerSample * ImageEnMView1.MIO.Params[i]
        .SamplesPerPixel = 32 then
        iColor := 'RGBA ' + IntToStr(ImageEnMView1.MIO.Params[i].BitsPerSample *
          ImageEnMView1.MIO.Params[i].SamplesPerPixel) + '-Bit'
      else
        iColor := 'RGB ' + IntToStr(ImageEnMView1.MIO.Params[i].BitsPerSample *
          ImageEnMView1.MIO.Params[i].SamplesPerPixel) + '-Bit';
      ImageEnMView1.ImageTopText[i] := iDimensions + ' ' + iColor;
      if IEGetFileFramesCount(ImageEnMView1.MIO.Params[i].FileName) > 1 then
        ImageEnMView1.ImageBottomText[i] := 'Frame ' + IntToStr(i + 1)
      else
        ImageEnMView1.ImageBottomText[i] :=
          ExtractFileName(ImageEnMView1.MIO.Params[i].FileName);
    end;
    ImageEnMView1.SelectedImage := iIndex;
    PageControl1.ActivePageIndex := iIndex;
  end;
end;

procedure TForm1.ClearStatusBar;
var
  i: Integer;
begin
  Caption := 'Brush Tools, Frames And Layers';
  for i := 0 to StatusBar1.Panels.Count - 1 do
    StatusBar1.Panels[i].Text := '';
end;

procedure TForm1.UpdateStatusBar;
{ Display info }
var
  iWidth1: Integer;
  iWidth2: Integer;
  iBitDepth: Integer;
begin
  ImageEnView := nil;
  if (PageControl1.ActivePage.ControlCount > 0) and
    Assigned(PageControl1.ActivePage.Controls[0]) then
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
  if Assigned(ImageEnView) then
  begin
    Caption := 'Brush Tools, Frames And Layers- ' + AFilename;
    iBitDepth := ImageEnView.IO.Params.SamplesPerPixel *
      ImageEnView.IO.Params.BitsPerSample;
    iWidth1 := StatusBar1.Panels[0].Width - 10;
    iWidth2 := StatusBar1.Panels[1].Width - 10;
    StatusBar1.Panels[0].Text := EllipsifyText(True, ExtractFilePath(AFilename),
      Canvas, iWidth1);
    StatusBar1.Panels[1].Text := EllipsifyText(False,
      ExtractFileName(AFilename), Canvas, iWidth2);
    if iBitDepth = 32 then
      StatusBar1.Panels[2].Text := 'Color: RGBA' +
        IntToStr(ImageEnView.IO.Params.SamplesPerPixel *
        ImageEnView.IO.Params.BitsPerSample) + '-bit'
    else
      StatusBar1.Panels[2].Text := 'Color: RGB' +
        IntToStr(ImageEnView.IO.Params.SamplesPerPixel *
        ImageEnView.IO.Params.BitsPerSample) + '-bit';
    StatusBar1.Panels[3].Text := 'Zoom: ' + FloatToStrF(ImageEnView.Zoom,
      ffFixed, 10, 1) + '%';
    StatusBar1.Panels[4].Text := 'Layers: ' +
      IntToStr(ImageEnView.LayersCount - 1);
    StatusBar1.Panels[5].Text := 'Layer: ' +
      IntToStr(ImageEnView.LayersCurrent);
    StatusBar1.Panels[6].Text := 'Layer Name: ' + ImageEnView.Layers
      [ImageEnView.LayersCurrent].Name;
    StatusBar1.Panels[9].Text := 'Frames: ' +
      IntToStr(ImageEnMView1.ImageCount);
    if ImageEnMView1.SelectedImage <> -1 then
      StatusBar1.Panels[10].Text := 'Frame: ' +
        IntToStr(ImageEnMView1.SelectedImage + 1);
    StatusBar1.Panels[11].Text := 'Width: ' +
      IntegerToString(ImageEnView.IEBitmap.Width);
    StatusBar1.Panels[12].Text := 'Height: ' +
      IntegerToString(ImageEnView.IEBitmap.Height);
    if ImageEnView.IEBitmap.Modified then
      StatusBar1.Panels[13].Text := 'Modified'
    else
      StatusBar1.Panels[13].Text := '';
  end;
end;

procedure TForm1.UpDownModifier1Click(Sender: TObject; Button: TUDBtnType);
begin
  SetShapeLayerParameters;
end;

procedure TForm1.UpDownPolylineLayerWidth1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  if not APolylineWidthChanging then
    TrackBarPolylineWidth1.Position := UpDownPolylineLayerWidth1.Position;
  SetPolylineLayerParameters;
end;

procedure TForm1.UpDownShapeSize1Click(Sender: TObject; Button: TUDBtnType);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      // SHARED STYLE PROPERTIES
      ImageEnView.CurrentLayer.BorderColor := LineColor1.Selected;
      ImageEnView.CurrentLayer.BorderWidth := UpDownBorderWidth1.Position;
      ImageEnView.CurrentLayer.FillColor := LineFillColor1.Selected;
      // LINE PROPERTIES
      if ImageEnView.CurrentLayer is TIELineLayer then
        with TIELineLayer(ImageEnView.CurrentLayer) do
        begin
          StartShape := TIELineEndShape(StartShape1.ItemIndex);
          EndShape := TIELineEndShape(EndShape1.ItemIndex);
          ShapeSize := UpDownShapeSize1.Position;
        end;
    end;
  end;
end;

procedure TForm1.EditBrushSize1Change(Sender: TObject);
begin
  UpDownBrushSize1.Position := StrToInt(EditBrushSize1.Text);
  ControlChange(Sender);
end;

procedure TForm1.EditBrushStep1Change(Sender: TObject);
begin
  TrackBarBrushStep1.Position := StrToInt(EditBrushStep1.Text);
  ControlChange(Sender);
end;

procedure TForm1.EditFeathering1Change(Sender: TObject);
begin
  UpdownFeathering1.Position := StrToInt(EditFeathering1.Text);
  ControlChange(Sender);
end;

procedure TForm1.EditPolylineLayerWidth1Change(Sender: TObject);
begin
  SetPolylineLayerParameters;
end;

procedure TForm1.EndShape1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      SetLineLayerParameters;
    end;
  end;
end;

procedure TForm1.Erase1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.BrushFill := iebfEraser;
      ComboBoxBrushFill1.ItemIndex := 7;
    end;
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.LayerFillColor2Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.CurrentLayer.FillColor2 := LayerFillColor2.Selected;
      ImageEnView.Update;
      DrawLayers;
    end;
  end;
end;

procedure TForm1.Fit1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Fit1.State = tssOn then
        ImageEnView.Fit
      else
        ImageEnView.Zoom := 100;
    end;
  end;
end;

procedure TForm1.FlipHorizontal1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Flip Horizontally ' +
        IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      UpdateUndo;
      ImageEnView.Proc.Flip(fdHorizontal);
      ImageEnView.Deselect;
      UpdateFrames;
      UpdateTabSheets;
      DrawLayers;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.FlipVertical1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo('Flip Vertically ' +
        IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      UpdateUndo;
      ImageEnView.Proc.Flip(fdVertical);
      ImageEnView.Deselect;
      UpdateFrames;
      UpdateTabSheets;
      DrawLayers;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.FloodFillAlphaTool1Click(Sender: TObject);
begin
  if FloodFillAlphaTool1.Down then
  begin
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        ImageEnView.MouseInteract := [miAlphaFill];
      end;
    end;
  end
  else
  begin
    ImageEnView.MouseInteract := [];
    NoTools1.Down := True;
  end;
end;

procedure TForm1.FloodFillColor1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.FillTool.ColorFillValue := FloodFillColor1.Selected;
    end;
  end;
end;

procedure TForm1.FloodFillColor1Click(Sender: TObject);
begin
  if FloodFillTool1.Down then
  begin
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        ImageEnView.MouseInteract := [miColorFill];
      end;
    end;
  end
  else
  begin
    ImageEnView.MouseInteract := [];
    NoTools1.Down := True;
  end;
end;

procedure TForm1.ForegroundWindow1Click(Sender: TObject);
var
  iPath: string;
  iFilename: string;
  iExtension: string;
  iDimensions: string;
  iBitDepth: Integer;
  iColor: string;
  iMaximized: Boolean;
begin
  iMaximized := WindowState = wsMaximized;
  WindowState := wsMinimized;
  try
    Sleep(500);
    AddTabsheet;
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        iFilename := DesktopFolder + 'Capture ' +
          IntToStr(PageControl1.PageCount);
        iExtension := '.jpg';
        iPath := iFilename + iExtension;
        ImageEnView.IO.CaptureFromScreen(iecsForegroundWindow, -1);
        ImageEnView.IO.Params.FileName := iPath;
        ImageEnMView1.AppendImage(ImageEnView.IEBitmap);
        ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
        ImageEnView.IEBitmap.UpdateFromTBitmap;
        ImageEnView.CurrentLayer.Name := 'Capture';
        ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
        ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
        ImageEnView.IO.Params.BitsPerSample := 8;
        ImageEnView.IO.Params.SamplesPerPixel := 3;
        Undo1.Enabled := ImageEnView.Proc.UndoCount <> 0;
        if Fit1.State = tssOn then
          ImageEnView.Zoom := ImageEnView.GetIdealZoom -
            ImageEnView.GetIdealZoom * 0.025;
        iDimensions := IntegerToString(ImageEnView.IO.Params.Width) + ' x ' +
          IntegerToString(ImageEnView.IO.Params.Height) + ' ';
        iBitDepth := ImageEnView.IO.Params.SamplesPerPixel *
          ImageEnView.IO.Params.BitsPerSample;
        iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
        PageControl1.ActivePage.Caption := 'Capture ' +
          IntToStr(PageControl1.PageCount) + '- ' + iDimensions + iColor;
        PageControl1.ActivePage.Hint := iFilename + iExtension;
        iDimensions := IntegerToString(ImageEnView.IEBitmap.Width) + ' x ' +
          IntegerToString(ImageEnView.IEBitmap.Height);
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width :=
          ImageEnView.IEBitmap.Width;
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height :=
          ImageEnView.IEBitmap.Height;
        if iBitDepth = 32 then
          iColor := 'RGBA 32-Bit'
        else
          iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
        ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions +
          ' ' + iColor;
        ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] := 'Capture '
          + IntToStr(PageControl1.PageCount) + iExtension;
      end;
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      UpdateTabSheets;
      DrawLayers;
      UpdateStatusBar;
    end;
  finally
    WindowState := wsNormal;
    if iMaximized then
      WindowState := wsMaximized
    else
      WindowState := wsNormal;
    if Fit1.State = tssOn then
      ImageEnView.Fit
    else
      ImageEnView.Zoom := 100;
  end;
end;

procedure TForm1.ForegroundWindowClient1Click(Sender: TObject);
var
  iPath: string;
  iFilename: string;
  iExtension: string;
  iDimensions: string;
  iBitDepth: Integer;
  iColor: string;
  iMaximized: Boolean;
begin
  iMaximized := WindowState = wsMaximized;
  WindowState := wsMinimized;
  try
    Sleep(500);
    AddTabsheet;
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        iFilename := DesktopFolder + 'Capture ' +
          IntToStr(PageControl1.PageCount);
        iExtension := '.jpg';
        iPath := iFilename + iExtension;
        ImageEnView.IO.CaptureFromScreen(iecsForegroundWindowClient, -1);
        ImageEnView.IO.Params.FileName := iPath;
        ImageEnMView1.AppendImage(ImageEnView.IEBitmap);
        ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
        ImageEnView.IEBitmap.UpdateFromTBitmap;
        ImageEnView.CurrentLayer.Name := 'Capture';
        ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
        ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
        ImageEnView.IO.Params.BitsPerSample := 8;
        ImageEnView.IO.Params.SamplesPerPixel := 3;
        Undo1.Enabled := ImageEnView.Proc.UndoCount <> 0;
        if Fit1.State = tssOn then
          ImageEnView.Zoom := ImageEnView.GetIdealZoom -
            ImageEnView.GetIdealZoom * 0.025;
        iDimensions := IntegerToString(ImageEnView.IO.Params.Width) + ' x ' +
          IntegerToString(ImageEnView.IO.Params.Height) + ' ';
        iBitDepth := ImageEnView.IO.Params.SamplesPerPixel *
          ImageEnView.IO.Params.BitsPerSample;
        iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
        PageControl1.ActivePage.Caption := 'Capture ' +
          IntToStr(PageControl1.PageCount) + '- ' + iDimensions + iColor;
        PageControl1.ActivePage.Hint := iFilename + iExtension;
        iDimensions := IntegerToString(ImageEnView.IEBitmap.Width) + ' x ' +
          IntegerToString(ImageEnView.IEBitmap.Height);
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width :=
          ImageEnView.IEBitmap.Width;
        ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height :=
          ImageEnView.IEBitmap.Height;
        if iBitDepth = 32 then
          iColor := 'RGBA 32-Bit'
        else
          iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
        ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions +
          ' ' + iColor;
        ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] := 'Capture '
          + IntToStr(PageControl1.PageCount) + iExtension;
      end;
      ImageEnView.Update;
      ImageEnView.IEBitmap.Modified := True;
      UpdateTabSheets;
      DrawLayers;
      UpdateStatusBar;
    end;
  finally
    if iMaximized then
      WindowState := wsMaximized
    else
      WindowState := wsNormal;
    if Fit1.State = tssOn then
      ImageEnView.Fit
    else
      ImageEnView.Zoom := 100;
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  iIEShape: TIEShape;
begin
  Shapes1.Items.Clear;
  PolylineShapes1.Items.Clear;
  TextLayerShape1.Items.Clear;
  for iIEShape := Low(TIEShape) to High(TIEShape) do
  begin
    Shapes1.Items.Add(IntToStr(ord(iIEShape)));
    PolylineShapes1.Items.Add(IntToStr(ord(iIEShape)));
    TextLayerShape1.Items.Add(IntToStr(ord(iIEShape)));
  end;
  Shapes1.ItemIndex := 0;
  PolylineShapes1.ItemIndex := 0;
  TextLayerShape1.ItemIndex := -1;
  TextLayerAlignment1.ItemIndex := 2;
  TextLayerLayout1.ItemIndex := 2;
  TextLayerOverflow1.ItemIndex := 1;
  Shapes1.Refresh;
  PolylineShapes1.Refresh;
  TextLayerShape1.Refresh;
  IEGlobalSettings().DefaultLayerText := 'Double-click to edit text';
  UpdateUndo;
  PreviewQuality1.ItemIndex := 1;
  PreviewQuality1Change(nil);
  AutoClosePolylines1.ItemIndex := ord(iecmOnNearFinish);
  UpdateGUI;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  i: Integer;
  iClipboardHasImage: Boolean;
  iFilename: string;
  iResult: Integer;
  iNotification: TNotification;
  iFrames: Integer;
begin
  if PageControl1.PageCount > 0 then
    if Assigned(PageControl1.ActivePage) then
    begin
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        iClipboardHasImage := ImageEnView.Proc.IsClipboardAvailable;
        if iClipboardHasImage then
        begin
          if MessageBox(0,
            'The clipboard contains an image.  Clear the clipboard?',
            'The Clipboard Contains An Image', MB_ICONQUESTION or MB_YESNO) = mrYes
          then
          begin
            { Empty the clipboard }
            Winapi.Windows.OpenClipboard(Application.Handle);
            Winapi.Windows.EmptyClipboard;
            Winapi.Windows.CloseClipboard;
          end;
        end;
        if ImageEnMView1.ImageCount > 0 then
        begin
          iFilename := ImageEnMView1.MIO.Params
            [ImageEnMView1.SelectedImage].FileName;
          if FileExists(iFilename) then
            iFrames := IEGetFileFramesCount(iFilename)
          else
          begin
            CanClose := True;
            CloseAll1Click(Sender);
            exit;
          end;
          if (not IsMultiFrameImage) and (iFrames = 1) then
          begin
            for i := 0 to PageControl1.PageCount - 1 do
            begin
              if Assigned(PageControl1.Pages[i]) then
              begin
                ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
                if Assigned(ImageEnView) then
                begin
                  CanClose := not ImageEnView.IEBitmap.Modified;
                  if not CanClose then
                  begin
                    iResult :=
                      MessageBox(0,
                      PChar('The image ' + ExtractFileName(iFilename) +
                      ' has been modified and has not been saved.  Save the image?'),
                      'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
                    case iResult of
                      mrYes:
                        begin
                          if SavePictureDialog1.Execute then
                          begin
                            iFilename := SavePictureDialog1.FileName;
                            if System.SysUtils.FileExists(iFilename) then
                            begin
                              if ImageEnView.LayersCount > 1 then
                                ImageEnView.LayersMergeAll(True);
                              ImageEnView.IO.SaveToFile(iFilename);
                              if ImageEnView.IO.Aborting then
                              begin
                                iNotification :=
                                  NotificationCenter1.CreateNotification;
                                try
                                  iNotification.Name := 'ErrorNotification';
                                  iNotification.Title := 'Error Saving Image';
                                  iNotification.AlertBody :=
                                    'There was an error saving the image.  The image was not be saved.';
                                  NotificationCenter1.PresentNotification
                                    (iNotification);
                                finally
                                  iNotification.Free;
                                end;
                                exit;
                              end;
                              ImageEnMView1.IEBitmap.Modified := False;
                              CanClose := True;
                            end;
                          end
                          else
                          begin
                            CanClose := True;
                          end;
                        end;
                      mrNo:
                        begin
                          CanClose := True;
                          break;
                        end;
                      mrCancel:
                        begin
                          CanClose := False;
                          break;
                        end;
                    end;
                  end;
                end;
              end;
            end;
          end
          else if (IsMultiFrameImage) and (iFrames > 1)
          then { Multiframe image loaded }
          begin
            for i := 0 to PageControl1.PageCount - 1 do
            begin
              if System.SysUtils.FileExists(iFilename) then
              begin
                ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
                if Assigned(ImageEnView) then
                begin
                  if ImageEnView.IEBitmap.Modified then
                  begin
                    iResult :=
                      MessageBox(0,
                      PChar('The image ' + ExtractFileName(iFilename) +
                      ' has been modified and has not been saved.  Save the image?'),
                      'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
                    case iResult of
                      mrYes:
                        begin
                          ImageEnMView1.MIO.SaveToFile(iFilename);
                          if ImageEnMView1.MIO.Aborting then
                          begin
                            iNotification :=
                              NotificationCenter1.CreateNotification;
                            try
                              iNotification.Name := 'ErrorNotification';
                              iNotification.Title := 'Error Saving Image';
                              iNotification.AlertBody :=
                                'There was an error saving the image.  The image was not be saved.';
                              NotificationCenter1.PresentNotification
                                (iNotification);
                            finally
                              iNotification.Free;
                            end;
                            exit;
                          end;
                          ImageEnMView1.IEBitmap.Modified := False;
                          CanClose := True;
                          break;
                        end;
                      mrNo:
                        begin
                          CanClose := True;
                          Continue;
                        end;
                      mrCancel:
                        begin
                          CanClose := False;
                          break;;
                        end;
                    end;
                  end;
                end;
              end;
            end;
          end
          else
          begin
            if Assigned(PageControl1.ActivePage) and (not CanClose) then
            begin
              ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
              if Assigned(ImageEnView) then
              begin
                if ImageEnMView1.IEBitmap.Modified then
                begin
                  if SavePictureDialog1.Execute then
                  begin
                    iFilename := SavePictureDialog1.FileName;
                    iResult :=
                      MessageBox(0,
                      PChar('The image ' + ExtractFileName(iFilename) +
                      ' has been modified and has not been saved.  Save the image?'),
                      'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
                    case iResult of
                      mrYes:
                        begin
                          ImageEnMView1.MIO.SaveToFile(iFilename);
                          if ImageEnMView1.MIO.Aborting then
                          begin
                            iNotification :=
                              NotificationCenter1.CreateNotification;
                            try
                              iNotification.Name := 'ErrorNotification';
                              iNotification.Title := 'Error Saving Image';
                              iNotification.AlertBody :=
                                'There was an error saving the image.  The image was not be saved.';
                              NotificationCenter1.PresentNotification
                                (iNotification);
                            finally
                              iNotification.Free;
                            end;
                            exit;
                          end;
                          ImageEnMView1.IEBitmap.Modified := False;
                        end;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
  iColor: TColor;
  iName: string;
begin
  APolylineWidthChanging := False;
  ImageEnMView1.SetModernStyling();
  AIniFilename := AppDataFolder + 'ASG\BrushTools\' + 'BrushTools.ini';
  System.SysUtils.ForceDirectories(AppDataFolder + 'ASG\BrushTools');
  AMostRecentFiles := TStringlist.Create;
  PageControl2.ActivePageIndex := 0;
  ReadIni(AIniFilename);
  if FileExists('snowflake.bmp') then
    ImageEnView2.IO.LoadFromFile('snowflake.bmp');
  ImageEnView2.Update;
  IEColorPaletteBrush1.Colors.Add(ColorToString(clBlack));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clMaroon));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clGreen));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clOlive));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clNavy));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clPurple));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clTeal));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clSilver));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clGray));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clRed));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clLime));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clYellow));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clBlue));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clFuchsia));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clAqua));
  IEColorPaletteBrush1.Colors.Add(ColorToString(clWhite));
  for i := 0 to 128 do
  begin
    iColor := cxColorsByName[i].Color;
    iName := cxColorsByName[i].Name;
    ColorBox1.Items.AddObject(iName, TObject(iColor));
    ColorBox2.Items.AddObject(iName, TObject(iColor));
    IEColorPaletteBrush1.Colors.Add(ColorToString(iColor));
  end;
  IEColorPaletteBrush2.SelectedColor := clBlack;
  IEColorPaletteBrush2.Colors.Add(ColorToString(clBlack));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clMaroon));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clGreen));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clOlive));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clNavy));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clPurple));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clTeal));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clSilver));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clGray));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clRed));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clLime));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clYellow));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clBlue));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clFuchsia));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clAqua));
  IEColorPaletteBrush2.Colors.Add(ColorToString(clWhite));
  for i := 0 to 128 do
  begin
    iColor := cxColorsByName[i].Color;
    iName := cxColorsByName[i].Name;
    ColorBox1.Items.AddObject(iName, TObject(iColor));
    ColorBox2.Items.AddObject(iName, TObject(iColor));
    IEColorPaletteBrush2.Colors.Add(ColorToString(iColor));
  end;
  IEColorPaletteBrush1.SelectedColor := clBlack;
  IEColorPaletteBrush2.SelectedColor := clYellow;
  ScrollBox1.VertScrollBar.Position := 0;
  UpdateGUI;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WriteIni(AIniFilename);
  AMostRecentFiles.Free;
end;

procedure TForm1.Gradient1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.BrushFill := iebfGradient;
      ComboBoxBrushFill1.ItemIndex := 1;
    end;
  end;
end;

procedure TForm1.Grayscale1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Pencil Sketch Grayscale ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.PencilSketch(True);
          ImageEnView.Update;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.HistAutoEqualize1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Hist Auto Equalize ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.HistAutoEqualize;
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

function TForm1.IsMultiFrameImage: Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := ImageEnMView1.ImageCount - 1 downto 0 do
  begin
    if ImageEnMView1.MIO.Params[i].ImageCount > 1 then
    begin
      Result := True;
      break;
    end;
  end;
end;

procedure TForm1.Close1Click(Sender: TObject);
var
  i: Integer;
  iNotification: TNotification;
  iFilename: string;
  iResult: Integer;
  iFrames: Integer;
  iCanClose: Boolean;
  iLayersFilename: string;
  iFileType: TIOFileType;
  iLayerCount: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iCanClose := False;
      if PageControl1.PageCount > 0 then
      begin
        iFilename := ImageEnView.IO.Params.FileName;
        iFrames := IEGetFileFramesCount(iFilename);
        { Is a single frame image loaded }
        if (not IsMultiFrameImage) or (iFrames = 1) then
        begin
          iCanClose := not ImageEnView.IEBitmap.Modified;
          if not iCanClose then
          begin
            iResult := MessageBox(0,
              PChar('The image ' + ExtractFileName(iFilename) +
              ' has been modified and has not been saved.  Save the image?'),
              'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
            case iResult of
              mrYes:
                begin
                  if not FileExists(iFilename) then
                  begin
                    if System.SysUtils.FileExists(iFilename) then
                      SavePictureDialog1.FileName := iFilename;
                    SavePictureDialog1.FileName := ExtractFileName(iFilename);
                    if SavePictureDialog1.Execute then
                    begin
                      iFilename := SavePictureDialog1.FileName;
                      if System.SysUtils.FileExists(iFilename) then
                      begin
                        iLayerCount := ImageEnView.LayersCount;
                        if iLayerCount > 1 then
                        begin
                          TaskDialog1.Title := 'Merge Layers';
                          TaskDialog1.MainIcon := tdiNone;
                          TaskDialog1.Caption := 'Save Image';
                          TaskDialog1.Text :=
                            'The image contains layers.  Do you want to merge layers before saving the image?';
                          TaskDialog1.CommonButtons :=
                            [tcbYes, tcbNo, tcbCancel];
                          TaskDialog1.FooterText :=
                            'Developed By Adirondack Software & Graphics';
                          TaskDialog1.Flags :=
                            [tfUseHiconMain, tfAllowDialogCancellation];
                          iResult := -1;
                          if TaskDialog1.Execute then
                            iResult := TaskDialog1.ModalResult;
                          if iResult = mrYes then
                          begin
                            ImageEnView.LayersMergeAll(True);
                            UpdateStatusBar;
                          end;
                        end;
                        ImageEnView.IO.SaveToFile(iFilename);
                        if ImageEnView.IO.Aborting then
                        begin
                          iNotification :=
                            NotificationCenter1.CreateNotification;
                          try
                            iNotification.Name := 'ErrorNotification';
                            iNotification.Title := 'Error Saving Image';
                            iNotification.AlertBody :=
                              'There was an error saving the image.  The image was not be saved.';
                            NotificationCenter1.PresentNotification
                              (iNotification);
                          finally
                            iNotification.Free;
                          end;
                          exit;
                        end;
                        AFilename := iFilename;
                        ImageEnView.IEBitmap.Modified := False;
                        ImageEnMView1.IEMBitmap.Modified := False;
                        iCanClose := True;
                      end;
                    end;
                  end
                  else
                  begin
                    iLayersFilename := ChangeFileExt(iFilename, '.lyr');
                    iFileType := ImageEnView.IO.Params.FileType;
                    if iFileType <> ioIEN then { Save lyr file }
                    begin
                      ImageEnView.LayersSaveToFile(iLayersFilename);
                      if ImageEnView.IO.Aborting then
                      begin
                        iNotification := NotificationCenter1.CreateNotification;
                        try
                          iNotification.Name := 'ErrorNotification';
                          iNotification.Title := 'Error Saving Objects';
                          iNotification.AlertBody :=
                            'There was an error saving the objects.  The objects was not be saved.';
                          NotificationCenter1.PresentNotification
                            (iNotification);
                        finally
                          iNotification.Free;
                        end;
                      end;
                      { Save the file }
                      ImageEnView.IO.SaveToFile(iFilename);
                      if ImageEnView.IO.Aborting then
                      begin
                        iNotification := NotificationCenter1.CreateNotification;
                        try
                          iNotification.Name := 'ErrorNotification';
                          iNotification.Title := 'Error Saving Image';
                          iNotification.AlertBody :=
                            'There was an error saving the image.  The image was not be saved.';
                          NotificationCenter1.PresentNotification
                            (iNotification);
                        finally
                          iNotification.Free;
                        end;
                        exit;
                      end;
                      iCanClose := True;
                    end
                    else
                    begin { Save native file }
                      ImageEnView.IO.SaveToFileIEN(iFilename);
                      if ImageEnView.IO.Aborting then
                      begin
                        iNotification := NotificationCenter1.CreateNotification;
                        try
                          iNotification.Name := 'ErrorNotification';
                          iNotification.Title := 'Error Saving Image';
                          iNotification.AlertBody :=
                            'There was an error saving the image.  The image was not be saved.';
                          NotificationCenter1.PresentNotification
                            (iNotification);
                        finally
                          iNotification.Free;
                        end;
                        exit;
                      end;
                      iCanClose := True;
                    end;
                  end;
                  AFilename := iFilename;
                  ImageEnView.IEBitmap.Modified := False;
                  ImageEnMView1.IEMBitmap.Modified := False;
                end;
              mrNo:
                iCanClose := True;
              mrCancel:
                iCanClose := False;
            end;
          end
        end
        else if (IsMultiFrameImage) or (iFrames > 1)
        then { Multiframe image loaded }
        begin
          for i := 0 to PageControl1.PageCount - 1 do
          begin
            iFilename := ImageEnMView1.MIO.Params[i].FileName;
            if System.SysUtils.FileExists(iFilename) then
            begin
              ImageEnMView1.SelectedImage := i;
              if ImageEnMView1.IEMBitmap.Modified then
              begin
                iResult :=
                  MessageBox(0, PChar('The image ' + ExtractFileName(iFilename)
                  + ' has been modified and has not been saved.  Save the image?'),
                  'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
                case iResult of
                  mrYes:
                    begin
                      ImageEnMView1.MIO.SaveToFile(iFilename);
                      if ImageEnMView1.MIO.Aborting then
                      begin
                        iNotification := NotificationCenter1.CreateNotification;
                        try
                          iNotification.Name := 'ErrorNotification';
                          iNotification.Title := 'Error Saving Image';
                          iNotification.AlertBody :=
                            'There was an error saving the image.  The image was not be saved.';
                          NotificationCenter1.PresentNotification
                            (iNotification);
                        finally
                          iNotification.Free;
                        end;
                        exit;
                      end;
                      ImageEnView.IEBitmap.Modified := False;
                      ImageEnMView1.IEMBitmap.Modified := False;
                    end;
                  mrNo:
                    Continue;
                  mrCancel:
                    exit;
                end;
              end;
            end;
          end;
          iCanClose := True;
        end
        else
        begin
          if ImageEnMView1.IEMBitmap.Modified then
          begin
            if FileExists(iFilename) then
              SavePictureDialog1.FileName := iFilename;
            SavePictureDialog1.FileName := ExtractFileName(iFilename);
            if SavePictureDialog1.Execute then
            begin
              iFilename := SavePictureDialog1.FileName;
              iResult :=
                MessageBox(0,
                'The image has been modified and has not been saved.  Save the image?',
                'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
              case iResult of
                mrYes:
                  begin
                    ImageEnMView1.MIO.SaveToFile(iFilename);
                    if ImageEnView.IO.Aborting then
                    begin
                      iNotification := NotificationCenter1.CreateNotification;
                      try
                        iNotification.Name := 'ErrorNotification';
                        iNotification.Title := 'Error Saving Image';
                        iNotification.AlertBody :=
                          'There was an error saving the image.  The image was not be saved.';
                        NotificationCenter1.PresentNotification(iNotification);
                      finally
                        iNotification.Free;
                      end;
                      exit;
                    end;
                    iCanClose := True;
                    AFilename := iFilename;
                    ImageEnView.IEBitmap.Modified := False;
                    ImageEnMView1.IEMBitmap.Modified := False;
                  end;
              end;
            end;
          end;
        end;
      end;
      if iCanClose then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnMView1.DeleteImage(ImageEnMView1.SelectedImage);
          if Assigned(PageControl1.ActivePage) then
            PageControl1.ActivePage.Free;
          AFilename := '';
          if PageControl1.PageCount = 0 then
          begin
            ClearStatusBar;
          end
          else
            UpdateStatusBar
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
  UpdateGUI;
end;

procedure TForm1.CloseAll1Click(Sender: TObject);
var
  i: Integer;
  iClipboardHasImage: Boolean;
  iFilename: string;
  iResult: Integer;
  iNotification: TNotification;
  iFrames: Integer;
  iCanClose: Boolean;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iClipboardHasImage := ImageEnView.Proc.IsClipboardAvailable;
      if iClipboardHasImage then
      begin
        if MessageBox(0,
          'The clipboard contains an image.  Clear the clipboard?',
          'The Clipboard Contains An Image', MB_ICONQUESTION or MB_YESNO) = mrYes
        then
        begin
          { Empty the clipboard }
          Winapi.Windows.OpenClipboard(Application.Handle);
          Winapi.Windows.EmptyClipboard;
          Winapi.Windows.CloseClipboard;
        end;
      end;
      if ImageEnMView1.ImageCount > 0 then
      begin
        iFilename := ImageEnMView1.MIO.Params
          [ImageEnMView1.SelectedImage].FileName;
        iFrames := IEGetFileFramesCount(iFilename);
        if (not IsMultiFrameImage) or (iFrames = 1) then
        begin
          for i := 0 to PageControl1.PageCount - 1 do
          begin
            if Assigned(PageControl1.Pages[i]) then
            begin
              ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
              if Assigned(ImageEnView) then
              begin
                iCanClose := not ImageEnView.IEBitmap.Modified;
                if not iCanClose then
                begin
                  iResult :=
                    MessageBox(0,
                    PChar('The image ' + ExtractFileName(iFilename) +
                    ' has been modified and has not been saved.  Save the image?'),
                    'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
                  case iResult of
                    mrYes:
                      begin
                        if SavePictureDialog1.Execute then
                        begin
                          iFilename := SavePictureDialog1.FileName;
                          if System.SysUtils.FileExists(iFilename) then
                          begin
                            if ImageEnView.LayersCount > 1 then
                              ImageEnView.LayersMergeAll(True);
                            ImageEnView.IO.SaveToFile(iFilename);
                            if ImageEnView.IO.Aborting then
                            begin
                              iNotification :=
                                NotificationCenter1.CreateNotification;
                              try
                                iNotification.Name := 'ErrorNotification';
                                iNotification.Title := 'Error Saving Image';
                                iNotification.AlertBody :=
                                  'There was an error saving the image.  The image was not be saved.';
                                NotificationCenter1.PresentNotification
                                  (iNotification);
                              finally
                                iNotification.Free;
                              end;
                              exit;
                            end;
                            ImageEnMView1.IEBitmap.Modified := False;
                            PageControl1.Pages[i].Free;
                          end;
                        end
                        else
                        begin
                          PageControl1.Pages[i].Free;
                        end;
                      end;
                    mrNo:
                      begin
                        PageControl1.Pages[i].Free;
                        break;
                      end;
                    mrCancel:
                      begin
                        break;
                      end;
                  end;
                end;
              end;
            end;
          end;
          ImageEnMView1.Clear;
          for i := PageControl1.PageCount - 1 downto 0 do
            PageControl1.Pages[i].Free;
          ClearStatusBar;
        end
        else if (IsMultiFrameImage) or (iFrames > 1)
        then { Multiframe image loaded }
        begin
          for i := 0 to PageControl1.PageCount - 1 do
          begin
            if System.SysUtils.FileExists(iFilename) then
            begin
              ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
              if Assigned(ImageEnView) then
              begin
                if ImageEnView.IEBitmap.Modified then
                begin
                  iResult :=
                    MessageBox(0,
                    PChar('The image ' + ExtractFileName(iFilename) +
                    ' has been modified and has not been saved.  Save the image?'),
                    'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
                  case iResult of
                    mrYes:
                      begin
                        ImageEnMView1.MIO.SaveToFile(iFilename);
                        if ImageEnMView1.MIO.Aborting then
                        begin
                          iNotification :=
                            NotificationCenter1.CreateNotification;
                          try
                            iNotification.Name := 'ErrorNotification';
                            iNotification.Title := 'Error Saving Image';
                            iNotification.AlertBody :=
                              'There was an error saving the image.  The image was not be saved.';
                            NotificationCenter1.PresentNotification
                              (iNotification);
                          finally
                            iNotification.Free;
                          end;
                          exit;
                        end;
                        ImageEnMView1.IEBitmap.Modified := False;
                        PageControl1.Pages[i].Free;
                        break;
                      end;
                    mrNo:
                      begin
                        PageControl1.Pages[i].Free;
                        Continue;
                      end;
                    mrCancel:
                      begin
                        break;;
                      end;
                  end;
                end
                else
                begin

                end;
              end;
            end;
          end;
          for i := PageControl1.PageCount - 1 downto 0 do
            PageControl1.Pages[i].Free;
          ImageEnMView1.Clear;
          ClearStatusBar;
        end
        else
        begin
          if Assigned(PageControl1.ActivePage) then
          begin
            ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
            if Assigned(ImageEnView) then
            begin
              if ImageEnMView1.IEBitmap.Modified then
              begin
                if SavePictureDialog1.Execute then
                begin
                  iFilename := SavePictureDialog1.FileName;
                  iResult :=
                    MessageBox(0,
                    PChar('The image ' + ExtractFileName(iFilename) +
                    ' has been modified and has not been saved.  Save the image?'),
                    'Save Image', MB_ICONQUESTION or MB_YESNOCANCEL);
                  case iResult of
                    mrYes:
                      begin
                        ImageEnMView1.MIO.SaveToFile(iFilename);
                        if ImageEnMView1.MIO.Aborting then
                        begin
                          iNotification :=
                            NotificationCenter1.CreateNotification;
                          try
                            iNotification.Name := 'ErrorNotification';
                            iNotification.Title := 'Error Saving Image';
                            iNotification.AlertBody :=
                              'There was an error saving the image.  The image was not be saved.';
                            NotificationCenter1.PresentNotification
                              (iNotification);
                          finally
                            iNotification.Free;
                          end;
                          exit;
                        end;
                        ImageEnMView1.IEBitmap.Modified := False;
                      end;
                  end;
                  ImageEnMView1.Clear;
                  ClearStatusBar;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
  UpdateGUI;
end;

procedure TForm1.MagnificationStyle1Change(Sender: TObject);
var
  iIELayer: TIELayer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    iIELayer := ImageEnView.CurrentLayer;
    if (iIELayer is TIEImageLayer) and (MagnificationStyle1.ItemIndex > -1) then
      with TIEImageLayer(iIELayer) do
      begin
        iIELayer.IsMask := LayerMask1.State = tssOn;
        Magnify.Enabled := MagnificationLayer1.State = tssOn;
        Magnify.Rate := LayerMagnification1.Position / 10;
        Magnify.Style := TIEMagnifyStyle(MagnificationStyle1.ItemIndex);
        Magnify.Source := TIEMagnifySource(MagnifySource1.ItemIndex);
      end;
  end;
end;

procedure TForm1.MagnifySource1Change(Sender: TObject);
var
  iIELayer: TIELayer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    iIELayer := ImageEnView.CurrentLayer;
    if (iIELayer is TIEImageLayer) and (MagnificationStyle1.ItemIndex > -1) then
      with TIEImageLayer(iIELayer) do
      begin
        iIELayer.IsMask := LayerMask1.State = tssOn;
        Magnify.Enabled := MagnificationLayer1.State = tssOn;
        Magnify.Rate := LayerMagnification1.Position / 10;
        Magnify.Style := TIEMagnifyStyle(MagnificationStyle1.ItemIndex);
        Magnify.Source := TIEMagnifySource(MagnifySource1.ItemIndex);
      end;
  end;
end;

procedure TForm1.Brightem1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Brightnen ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.AdjustBrightnessContrastSaturation(10, 0, 0);
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.BrushPaintMode1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.PaintMode :=
        TIEPaintMode(BrushPaintMode1.ItemIndex);
    end;
  end;
end;

procedure TForm1.TextLayerAlignment1Change(Sender: TObject);
begin
  SetTextLayerParameters;
end;

procedure TForm1.LabelPosition1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      SetLineLayerParameters;
    end;
  end;
end;

procedure TForm1.LayerAlphaEdgeFeathering1Change(Sender: TObject);
begin
  AlphaEdgeFeatheringUpDown1.Position :=
    StrToInt(LayerAlphaEdgeFeathering1.Text);
end;

procedure TForm1.AllowPointEditing1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if AllowPointEditing1.State = tssOn then
        ImageEnView.MouseInteract := ImageEnView.MouseInteract +
          [miEditLayerPoints]
      else
      begin
        ImageEnView.MouseInteract := [miResizeLayers, miMoveLayers];
        SelectLayers1.Down := True;
      end;
    end;
  end;
end;

procedure TForm1.AlphaEdgeFeatheringTrackBar1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.CurrentLayer.AlphaEdgeFeathering :=
        StrToInt(LayerAlphaEdgeFeathering1.Text);
      AlphaEdgeFeatheringUpDown1.Position :=
        AlphaEdgeFeatheringTrackBar1.Position;
      ImageEnView.Update;
      DrawLayers;
    end;
  end;
end;

procedure TForm1.AlphaEdgeFeatheringUpDown1Click(Sender: TObject;
  Button: TUDBtnType);
begin
  AlphaEdgeFeatheringTrackBar1.Position := AlphaEdgeFeatheringUpDown1.Position;
end;

procedure TForm1.AspectRatio1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Layers[ImageEnView.LayersCurrent].AspectRatioLocked :=
        AspectRatio1.State = tssOn;
      ImageEnView.Update;
    end;
  end;
end;

procedure TForm1.TextLayerLayout1Change(Sender: TObject);
begin
  SetTextLayerParameters;
end;

procedure TForm1.TextLayerOverflow1Change(Sender: TObject);
begin
  SetTextLayerParameters;
end;

procedure TForm1.TextLayerShape1Change(Sender: TObject);
begin
  SetTextLayerParameters;
end;

procedure TForm1.TextLayerShape1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  iShapeColor: TColor;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iShapeColor := LayerFillColor1.Selected;
      if (LayerFillColor1.Selected <> clNone) then
        iShapeColor := LayerFillColor1.Selected;
      IEDrawShapeToComboListBoxItem(TComboBox(Control).Canvas, Rect,
        Control.Enabled, TIEShape(Index), iShapeColor);
    end;
  end;
end;

procedure TForm1.Textured1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.BrushFill := iebfTextured;
      ComboBoxBrushFill1.ItemIndex := 3;
    end;
  end;
end;

procedure TForm1.TexturedSpray1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.BrushFill := iebfTexturedSpray;
      ComboBoxBrushFill1.ItemIndex := 5;
    end;
  end;
end;

procedure TForm1.ColorBox1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      IEColorPaletteBrush1.SelectedColor := ColorBox1.Selected;
      ShapeBrushColor1.Brush.Color := DitherColor(ColorBox1.Selected,
        TrackbarTransparency1.Position);
      ImageEnView.Update;
      ControlChange(Sender);
    end;
  end;
end;

procedure TForm1.ColorBox2Change(Sender: TObject);
begin
  ShapeBrushColor2.Brush.Color := DitherColor(ColorBox2.Selected,
    TrackbarTransparency1.Position);
  ControlChange(Sender);
end;

procedure TForm1.ColorPicker1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.MouseInteract := [miColorPicker];
    end;
  end;
end;

procedure TForm1.ComboBoxBrushFill1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.BrushFill :=
        TIEBrushFill(ComboBoxBrushFill1.ItemIndex);
      case ComboBoxBrushFill1.ItemIndex of
        0:
          Solid1.Down := True;
        1:
          Gradient1.Down := True;
        2:
          Spray1.Down := True;
        3:
          Textured1.Down := True;
        4:
          CenteredTexture1.Down := True;
        5:
          TexturedSpray1.Down := True;
        6:
          Image1.Down := True;
        7:
          Erase1.Down := True;
      end;
    end;
  end;
end;

procedure TForm1.ComboBoxBrushShape1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.BrushShape :=
        TIECursorShape(ComboBoxBrushShape1.ItemIndex + 1);
      ImageEnView.CloneTool.CursorShape :=
        TIECursorShape(ComboBoxBrushShape1.ItemIndex + 1);
    end;
  end;
end;

procedure TForm1.ComboBoxOperation1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.Operation :=
        TIERenderOperation(ComboBoxOperation1.ItemIndex);
    end;
  end;
end;

procedure TForm1.ComboBoxBrushPalette1Change(Sender: TObject);
begin
  if ComboBoxBrushPalette1.Items[ComboBoxBrushPalette1.ItemIndex] = 'Default'
  then
  begin
    { Load a default color palette. }
    IEColorPaletteBrush1.HorzMargin := 8;
    IEColorPaletteBrush1.Clear;
    IEColorPaletteBrush1.Colors.Add(ColorToString(clBlack));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clMaroon));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clGreen));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clOlive));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clNavy));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clPurple));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clTeal));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clSilver));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clGray));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clRed));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clLime));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clYellow));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clBlue));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clFuchsia));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clAqua));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clWhite));
    IEColorPaletteBrush1.SelectedIndex := 0;
    ShapeBrushColor1.Brush.Color := IEColorPaletteBrush1.SelectedColor;
    GroupBoxBrush1.Caption := 'Default Palette: ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette1.Items[ComboBoxBrushPalette1.ItemIndex] = 'Jasc' then
  begin
    IEColorPaletteBrush1.HorzMargin := 3;
    { Load a JASC color palette. }
    JascColorMap;
    GroupBoxBrush1.Caption := 'Jasc Palette- ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette1.Items[ComboBoxBrushPalette1.ItemIndex] = 'Developers Express'
  then
  begin
    IEColorPaletteBrush1.HorzMargin := 3;
    { Load a Dx color palette. }
    DxColorMap;
    GroupBoxBrush1.Caption := 'Developers Express Palette- ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette1.Items[ComboBoxBrushPalette1.ItemIndex] = 'Gray' then
  begin
    IEColorPaletteBrush1.HorzMargin := 3;
    { Gray Palette. 238 colors. }
    GeneratePalette(clGray);
    GroupBoxBrush1.Caption := 'Gray Palette- ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette1.Items[ComboBoxBrushPalette1.ItemIndex] = 'Red' then
  begin
    IEColorPaletteBrush1.HorzMargin := 3;
    { RedPalette 238 colors. }
    GeneratePalette(clRed);
    GroupBoxBrush1.Caption := 'Red Palette- ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette1.Items[ComboBoxBrushPalette1.ItemIndex] = 'Green' then
  begin
    IEColorPaletteBrush1.HorzMargin := 3;
    { GreenPalette. 238 colors. }
    GeneratePalette(clGreen);
    GroupBoxBrush1.Caption := 'Green Palette- ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette1.Items[ComboBoxBrushPalette1.ItemIndex] = 'Blue' then
  begin
    IEColorPaletteBrush1.HorzMargin := 3;
    { BluePalette1Click. 238 colors. }
    GeneratePalette(clBlue);
    GroupBoxBrush1.Caption := 'Blue Palette- ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette1.Items[ComboBoxBrushPalette1.ItemIndex] = 'Brown' then
  begin
    IEColorPaletteBrush1.HorzMargin := 3;
    { Brown Palette. 238 colors. }
    GeneratePalette($00003E75);
    GroupBoxBrush1.Caption := 'Brown Palette- ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette1.Items[ComboBoxBrushPalette1.ItemIndex] = 'Yellow'
  then
  begin
    IEColorPaletteBrush1.HorzMargin := 3;
    { Yellow Palette. 238 colors. }
    GeneratePalette(clYellow);
    GroupBoxBrush1.Caption := 'Yellow Palette- ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
end;

procedure TForm1.ComboBoxBrushPalette2Change(Sender: TObject);
begin
  if ComboBoxBrushPalette2.Items[ComboBoxBrushPalette2.ItemIndex] = 'Default'
  then
  begin
    { Load a default color palette. }
    IEColorPaletteBrush2.HorzMargin := 8;
    IEColorPaletteBrush2.Clear;
    IEColorPaletteBrush2.Colors.Add(ColorToString(clBlack));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clMaroon));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clGreen));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clOlive));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clNavy));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clPurple));
    IEColorPaletteBrush1.Colors.Add(ColorToString(clTeal));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clSilver));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clGray));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clRed));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clLime));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clYellow));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clBlue));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clFuchsia));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clAqua));
    IEColorPaletteBrush2.Colors.Add(ColorToString(clWhite));
    IEColorPaletteBrush2.SelectedIndex := 0;
    ShapeBrushColor2.Brush.Color := IEColorPaletteBrush2.SelectedColor;
    GroupBoxBrush2.Caption := 'Default Palette: ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette2.Items[ComboBoxBrushPalette2.ItemIndex] = 'Jasc' then
  begin
    IEColorPaletteBrush2.HorzMargin := 3;
    { Load a JASC color palette. }
    JascColorMap;
    GroupBoxBrush2.Caption := 'Jasc Palette- ' +
      IntToStr(IEColorPaletteBrush2.ColorCount);
  end;
  if ComboBoxBrushPalette2.Items[ComboBoxBrushPalette2.ItemIndex] = 'Developers Express'
  then
  begin
    IEColorPaletteBrush2.HorzMargin := 3;
    { Load a Dx color palette. }
    DxColorMap;
    GroupBoxBrush1.Caption := 'Developers Express Palette- ' +
      IntToStr(IEColorPaletteBrush1.ColorCount);
  end;
  if ComboBoxBrushPalette2.Items[ComboBoxBrushPalette2.ItemIndex] = 'Gray' then
  begin
    IEColorPaletteBrush2.HorzMargin := 3;
    { Gray Palette. 238 colors. }
    GeneratePalette(clGray);
    GroupBoxBrush2.Caption := 'Gray Palette- ' +
      IntToStr(IEColorPaletteBrush2.ColorCount);
  end;
  if ComboBoxBrushPalette2.Items[ComboBoxBrushPalette2.ItemIndex] = 'Red' then
  begin
    IEColorPaletteBrush2.HorzMargin := 3;
    { RedPalette 238 colors. }
    GeneratePalette(clRed);
    GroupBoxBrush1.Caption := 'Red Palette- ' +
      IntToStr(IEColorPaletteBrush2.ColorCount);
  end;
  if ComboBoxBrushPalette2.Items[ComboBoxBrushPalette2.ItemIndex] = 'Green' then
  begin
    IEColorPaletteBrush2.HorzMargin := 3;
    { GreenPalette. 238 colors. }
    GeneratePalette(clGreen);
    GroupBoxBrush2.Caption := 'Green Palette- ' +
      IntToStr(IEColorPaletteBrush2.ColorCount);
  end;
  if ComboBoxBrushPalette2.Items[ComboBoxBrushPalette2.ItemIndex] = 'Blue' then
  begin
    IEColorPaletteBrush2.HorzMargin := 3;
    { BluePalette1Click. 238 colors. }
    GeneratePalette(clBlue);
    GroupBoxBrush2.Caption := 'Blue Palette- ' +
      IntToStr(IEColorPaletteBrush2.ColorCount);
  end;
  if ComboBoxBrushPalette2.Items[ComboBoxBrushPalette2.ItemIndex] = 'Brown' then
  begin
    IEColorPaletteBrush2.HorzMargin := 3;
    { Brown Palette. 238 colors. }
    GeneratePalette($00003E75);
    GroupBoxBrush2.Caption := 'Brown Palette- ' +
      IntToStr(IEColorPaletteBrush2.ColorCount);
  end;
  if ComboBoxBrushPalette2.Items[ComboBoxBrushPalette2.ItemIndex] = 'Yellow'
  then
  begin
    IEColorPaletteBrush2.HorzMargin := 3;
    { Yellow Palette. 238 colors. }
    GeneratePalette(clYellow);
    GroupBoxBrush2.Caption := 'Yellow Palette- ' +
      IntToStr(IEColorPaletteBrush2.ColorCount);
  end;
end;

procedure TForm1.ControlChange(Sender: TObject);
var
  iNeedImage, iNeedGradient: Boolean;
  iRGB: TRGB;
  iColor: TColor;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iNeedImage := TIEBrushFill(ComboBoxBrushFill1.ItemIndex) = iebfImage;
      iNeedGradient := TIEBrushFill(ComboBoxBrushFill1.ItemIndex)
        = iebfGradient;
      if iNeedImage then
        ImageEnView.BrushTool.BrushShape := iecsRectangle
      else
        ImageEnView.BrushTool.BrushShape :=
          TIECursorShape(ComboBoxBrushShape1.ItemIndex + 1);
      ImageEnView.BrushTool.BrushFill :=
        TIEBrushFill(ComboBoxBrushFill1.ItemIndex);
      ImageEnView.BrushTool.BrushColor := ShapeBrushColor1.Brush.Color;
      ImageEnView.BrushTool.BrushColor2 := ShapeBrushColor2.Brush.Color;
      ImageEnView.BrushTool.BrushStep := UpDownBrushStep1.Position;
      ImageEnView.BrushTool.BrushSize := UpDownBrushSize1.Position;
      ImageEnView.BrushTool.Operation :=
        TIERenderOperation(ComboBoxOperation1.ItemIndex);
      ImageEnView.BrushTool.Feathering := UpdownFeathering1.Position;
      ImageEnView.BrushTool.Transparency := UpDownTransparency1.Position;
      ImageEnView.CloneTool.CursorSize := UpDownBrushSize1.Position;
      ImageEnView.CloneTool.CursorShape :=
        TIECursorShape(ComboBoxBrushShape1.ItemIndex + 1);
      if iNeedImage then
        // Brushes with transparency work best with iepmDiscrete or iepmStamp
        ImageEnView.BrushTool.PaintMode := iepmStamp
      else
        ImageEnView.BrushTool.PaintMode :=
          TIEPaintMode(BrushPaintMode1.ItemIndex);
      if Erase1.Down then
      begin
        iRGB := ImageEnView.Layers[ImageEnView.LayersCurrent].Bitmap.Pixels
          [0, ImageEnView.IEBitmap.Height - 1];
        iColor := TRGB2TColor(iRGB);
        ImageEnView.BrushTool.BrushColor := iColor;
        ImageEnView.BrushTool.BrushFill := iebfEraser;
        ImageEnView.BrushTool.EraserOpacity := 1.0;
        ImageEnView.BrushTool.BrushShape := iecsRectangle;
      end;

      ImageEnView.Invalidate();
      ShapeBrushColor2.Visible := iNeedGradient;
      LabelBrushColor1.Enabled := not iNeedImage;
      ShapeBrushColor1.Enabled := not iNeedImage;
      ShapeBrushColor2.Enabled := not iNeedImage;
      LabelBrushSize1.Enabled := not iNeedImage;
      EditBrushSize1.Enabled := not iNeedImage;
      UpDownBrushSize1.Enabled := not iNeedImage;
      LabelBrushShape1.Enabled := not iNeedImage;
      ComboBoxBrushShape1.Enabled := not iNeedImage;
      LabelPaintMode1.Enabled := not iNeedImage;
      BrushPaintMode1.Enabled := not iNeedImage;
      UpdateUndo;
      Save1.Enabled := not ImageEnView.IsEmpty2;
    end;
  end;
end;

procedure TForm1.New1Click(Sender: TObject);
var
  iIndex: Integer;
  iIEBitmap: TIEBitmap;
  iDimensions: string;
  iColor: string;
  iBitDepth: Integer;
  iWidth: Integer;
  iHeight: Integer;
  iBitmapPixelFormat: TIEPixelFormat;
  iBitmapColor: TColor;
begin
  FormNewImage := TFormNewImage.Create(Self);
  try
    if FormNewImage.ShowModal = mrOk then
    begin
      AddTabsheet;
      if Assigned(PageControl1.ActivePage) then
      begin
        ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
        if Assigned(ImageEnView) then
        begin
          iWidth := StrToInt(FormNewImage.Width1.Text);
          iHeight := StrToInt(FormNewImage.Height1.Text);
          iBitmapColor := FormNewImage.ColorBox1.Selected;
          iBitmapPixelFormat := ie24RGB;
          iIEBitmap := TIEBitmap.Create(iWidth, iHeight, iBitmapPixelFormat);
          try
            iIEBitmap.Fill(iBitmapColor);
            iIndex := ImageEnMView1.AppendImage(iIEBitmap);
            ImageEnView.IEBitmap.Assign(iIEBitmap);
            ImageEnView.Update;
            ImageEnMView1.SelectedImage := iIndex;
            ImageEnMView1.MIO.Params[iIndex].FileType := ioICO;
            ImageEnMView1.MIO.Params[iIndex].Width := iWidth;
            ImageEnMView1.MIO.Params[iIndex].Height := iHeight;
            case FormNewImage.ColorDepth1.ItemIndex of
              0:
                begin
                  iBitDepth := 32;
                  ConvertTo32Bit;
                end;
              1:
                begin
                  iBitDepth := 24;
                  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]
                    .BitsPerSample := 8;
                  ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]
                    .SamplesPerPixel := 3;
                  // ConvertTo24Bit;
                end;
              2:
                begin
                  iBitDepth := 8;
                  ConvertTo8Bit;
                end;
              3:
                begin
                  iBitDepth := 4;
                  ConvertTo4Bit;
                end;
            else
              begin
                iBitDepth := 24;
                ConvertTo24Bit;
              end;
            end;
            iDimensions := IntegerToString(iWidth) + ' x ' +
              IntegerToString(iHeight);
            ImageEnMView1.MIO.Params[iIndex].ICO_BitCount[iIndex] := iBitDepth;
            if iBitDepth = 32 then
              iColor := 'RGBA 32-Bit'
            else
              iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
            ImageEnMView1.ImageTopText[iIndex] := iDimensions + ' ' + iColor;
            ImageEnMView1.ImageBottomText[iIndex] := 'Frame ' +
              IntToStr(iIndex + 1);
          finally
            iIEBitmap.Free;
          end;
          if AFilename = '' then
            AFilename := DesktopFolder + 'Untitled.png';
          Caption := 'Brush Tools, Frames And Layers- ' + AFilename;
          PageControl1.Pages[PageControl1.ActivePageIndex].Caption :=
            ExtractFileName(AFilename);
          PageControl1.Pages[PageControl1.ActivePageIndex].Hint := AFilename;
          ImageEnMView1.CopyToIEBitmap(iIndex, ImageEnView.IEBitmap);
          ImageEnView.IO.Params.Assign(ImageEnMView1.MIO.Params[iIndex]);
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          ImageEnMView1.IEMBitmap.Modified := True;
          if Fit1.State = tssOn then
            ImageEnView.Fit;
          ImageEnMView1.Update;
          ImageEnView.Proc.UndoLimit := 20;
          ComboBoxBrushShape1.ItemIndex := 0;
          ComboBoxBrushFill1.ItemIndex := 0;
          ComboBoxOperation1.ItemIndex := 0;
          BrushPaintMode1.ItemIndex := 0;
          ControlChange(nil);
          UpdateStatusBar;
        end;
      end;
    end;
  finally
    FormNewImage.Free;
  end;
end;

procedure TForm1.NoTools1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if NoTools1.Down then
      begin
        ImageEnView.MouseInteract := [];
        ImageEnView.Proc.AutoUndo := True;
        ControlChange(Sender);
      end
      else
      begin
        ImageEnView.MouseInteract := [];
        ImageEnView.Proc.AutoUndo := False;
      end;
    end;
  end;
end;

procedure TForm1.LayerAntialias1Click(Sender: TObject);
begin
  SetImageLayerParameters;
end;

procedure TForm1.LayerBorderColor1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.CurrentLayer.BorderColor := LayerBorderColor1.Selected;
      ImageEnView.Update;
      DrawLayers;
    end;
  end;
end;

procedure TForm1.LayerBorderWidth1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Layers[ImageEnView.LayersCurrent].BorderWidth :=
        StrToInt(LayerBorderWidth1.Text);
      ImageEnView.Update;
      DrawLayers;
    end;
  end;
end;

procedure TForm1.LayerFillColor1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.CurrentLayer.FillColor := LayerFillColor1.Selected;
      ImageEnView.Update;
      DrawLayers;
      Shapes1.Refresh;
      PolylineShapes1.Refresh;
    end;
  end;
end;

procedure TForm1.LayerFillGradient1Change(Sender: TObject);
begin
  SetImageLayerParameters;
end;

procedure TForm1.LayerOpacityTrackBar1Change(Sender: TObject);
begin
  SetImageLayerParameters;
end;

procedure TForm1.LayerOperation1Change(Sender: TObject);
begin
  SetImageLayerParameters;
end;

procedure TForm1.LayerProperties1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.LayersShowPropertiesDialog();
    end;
  end;
end;

procedure TForm1.LayerRemove1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.LayersCurrent > 0 then
      begin
        ImageEnView.LayersRemove(ImageEnView.LayersCurrent);
      end;
      RemoveLayer1.Enabled := ImageEnView.LayersCount > 1;
      DrawLayers;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.LayersPopupMenu1Popup(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      AddLayer2.Enabled := ImageEnView.LayersCount > 0;
      RemoveLayer2.Enabled := ImageEnView.LayersCount > 1;
    end;
  end;
end;

procedure TForm1.LayerTransparency1Change(Sender: TObject);
begin
  UpDownLayerTransparency1.Position := StrToInt(LayerTransparency1.Text);
end;

procedure TForm1.LayerTransparencyTrackBar1Change(Sender: TObject);
begin
  SetImageLayerParameters;
end;

procedure TForm1.LayerVisible1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Layers[ImageEnView.LayersCurrent].Visible :=
        LayerVisible1.State = tssOn;
      ImageEnView.Update;
    end;
  end;
end;

procedure TForm1.LineColor1Change(Sender: TObject);
begin
  SetLineLayerParameters;
end;

procedure TForm1.LineFillColor1Change(Sender: TObject);
begin
  SetLineLayerParameters;
end;

procedure TForm1.LineLayerSizeToFit1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIELineLayer then
      begin
        TIELineLayer(ImageEnView.CurrentLayer).SizeToFit;
        ImageEnView.Update();
      end;
    end;
  end;
end;

procedure TForm1.LoadRecentFile(Sender: TObject);
var
  i: Integer;
  iFilename: string;
  iFrame: Integer;
  iFrames: Integer;
  iPage: Integer;
  iBitDepth: Integer;
  iWidth: Integer;
  iHeight: Integer;
  iColor: string;
  iDimensions: string;
  iMenuItem: TMenuItem;
  iNotification: TNotification;
begin
  iFilename := '';
  if Sender is TMenuItem then
  begin
    iMenuItem := TMenuItem(Sender);
    iFilename := iMenuItem.Caption;
  end;
  if FileExists(iFilename) then
  begin
    iFrames := IEGetFileFramesCount(iFilename);
    if (IsMultiFrameImage) or (iFrames > 1) then
    begin
      { Clear frames }
      ImageEnMView1.Clear;
      ImageEnMView1.Update;
      { Close all pages }
      for iPage := PageControl1.PageCount - 1 downto 0 do
        PageControl1.Pages[iPage].Free;
    end;
    if iFrames > 1 then
    begin
      ImageEnMView1.MIO.LoadFromFile(iFilename);
      ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
    end
    else
    begin
      iFrame := ImageEnMView1.AppendImage(iFilename);
      ImageEnMView1.SelectedImage := iFrame;
      AddTabsheet;
      if Assigned(PageControl1.ActivePage) then
      begin
        ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
        if Assigned(ImageEnView) then
        begin
          if ImageEnView.LayersCount > 1 then
            ImageEnView.Layers[ImageEnView.LayersCount - 1].Name :=
              'Image Layer ' + IntToStr(ImageEnView.LayersCount)
          else
            ImageEnView.Layers[ImageEnView.LayersCount - 1].Name :=
              'Background';
          PageControl1.Pages[PageControl1.ActivePageIndex].Caption :=
            ExtractFileName(iFilename);
          PageControl1.Pages[PageControl1.ActivePageIndex].Hint := iFilename;
          ImageEnMView1.CopyToIEBitmap(ImageEnMView1.SelectedImage,
            ImageEnView.IEBitmap);
          ImageEnView.IO.Params.Assign
            (ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage]);
          ImageEnView.IEBitmap.Modified := False;
          iWidth := ImageEnView.IEBitmap.Width;
          iHeight := ImageEnView.IEBitmap.Height;
          iDimensions := IntegerToString(iWidth) + ' x ' +
            IntegerToString(iHeight);
          ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width := iWidth;
          ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height
            := iHeight;
          iBitDepth := ImageEnView.IO.Params.BitsPerSample *
            ImageEnView.IO.Params.SamplesPerPixel;
          if iBitDepth = 32 then
            iColor := 'RGBA 32-Bit'
          else
            iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
          ImageEnMView1.ImageTopText[ImageEnMView1.SelectedImage] := iDimensions
            + ' ' + iColor;
          ImageEnMView1.ImageBottomText[ImageEnMView1.SelectedImage] :=
            'Frame ' + IntToStr(ImageEnMView1.SelectedImage + 1);
          ImageEnView.Fit();
          ImageEnLayerMView1.ReadLayers();
        end;
      end;
    end;
    if ImageEnMView1.MIO.Aborting then
    begin
      { AdvTaskDialog1.Clear;
        AdvTaskDialog1.CustomButtons.Clear;
        AdvTaskDialog1.Title := 'Warning';
        AdvTaskDialog1.Instruction := 'Error Opening Image';
        AdvTaskDialog1.Content :=
        'There was an error opening the image.  The image can not be opened.';
        AdvTaskDialog1.CommonButtons := [cbOk];
        AdvTaskDialog1.Icon := tiWarning;
        AdvTaskDialog1.Footer :=
        'Developed By Adirondack Software & Graphics';
        AdvTaskDialog1.Execute; }
      iNotification := NotificationCenter1.CreateNotification;
      try
        iNotification.Name := 'ErrorNotification';
        iNotification.Title := 'Error Opening Image';
        iNotification.AlertBody :=
          'There was an error opening the image.  The image can not be opened.';
        NotificationCenter1.PresentNotification(iNotification);
      finally
        iNotification.Free;
      end;
      exit;
    end;
    Caption := 'Brush Tools, Frames And Layers- ' + iFilename;
    AFilename := iFilename;
    if iFrames > 1 then
    begin
      for i := 0 to iFrames - 1 do
      begin
        AddTabsheet;
        if Assigned(PageControl1.ActivePage) then
        begin
          ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
          if Assigned(ImageEnView) then
          begin
            PageControl1.Pages[PageControl1.ActivePageIndex].Caption :=
              ExtractFileName(AFilename);
            PageControl1.Pages[PageControl1.ActivePageIndex].Hint := AFilename;
            ImageEnMView1.CopyToIEBitmap(i, ImageEnView.IEBitmap);
            ImageEnView.IO.Params.Assign(ImageEnMView1.MIO.Params[i]);
            ImageEnView.Fit();
            ImageEnView.Layers[ImageEnView.LayersCount - 1].Name :=
              'Image Layer ' + IntToStr(ImageEnView.LayersCount);
            // Assign an image to use as a brush
            ImageEnView.BrushTool.BrushImage.Assign(ImageEnView2.Bitmap);
            // Remove white background
            ImageEnView.BrushTool.BrushImage.SetTransparentColors(clBlack,
              clBlack, 0);
            ImageEnView.MouseInteract := [miBrushTool]; // Paint Brush tool
            iWidth := ImageEnView.IEBitmap.Width;
            iHeight := ImageEnView.IEBitmap.Height;
            iDimensions := IntegerToString(iWidth) + ' x ' +
              IntegerToString(iHeight);
            ImageEnMView1.MIO.Params[i].Width := iWidth;
            ImageEnMView1.MIO.Params[i].Height := iHeight;
            iBitDepth := ImageEnView.IO.Params.BitsPerSample *
              ImageEnView.IO.Params.SamplesPerPixel;
            if iBitDepth = 32 then
              iColor := 'RGBA 32-Bit'
            else
              iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
            ImageEnMView1.ImageTopText[i] := iDimensions + ' ' + iColor;
            ImageEnMView1.ImageBottomText[i] := 'Frame ' + IntToStr(i + 1);
            ImageEnView.IEBitmap.Modified := False;
          end;
        end;
      end;
    end;
    if AMostRecentFiles.IndexOf(iFilename) = -1 then
      AMostRecentFiles.Add(iFilename);
    ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
    PageControl1.ActivePageIndex := PageControl1.PageCount - 1;
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iWidth := ImageEnView.IEBitmap.Width;
      if iWidth <= 256 then
      begin
        TrackBarBrushSize1.Position := 1;
        EditBrushSize1.Text := IntToStr(TrackBarBrushSize1.Position);
        ComboBoxBrushShape1.ItemIndex := 1;
      end
      else
      begin
        TrackBarBrushSize1.Position := 25;
        EditBrushSize1.Text := IntToStr(TrackBarBrushSize1.Position);
        ComboBoxBrushShape1.ItemIndex := 0;
      end;
    end;
    UpdateUndo;
    ImageEnView.BrushTool.Enabled := False;
    ImageEnView.AutoCursors := True;
    ImageEnView.Cursor := 1784;
    UpdateGUI;
    ImageEnLayerMView1.Update;
    UpdateStatusBar;
    Shapes1.Refresh;
    PolylineShapes1.Refresh;
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
var
  i: Integer;
  iFilename: string;
  iFrames: Integer;
  iPage: Integer;
  iBitDepth: Integer;
  iWidth: Integer;
  iHeight: Integer;
  iColor: string;
  iDimensions: string;
  iNotification: TNotification;
begin
  if OpenPictureDialog1.Execute then
  begin
    iFilename := OpenPictureDialog1.FileName;
    iFrames := IEGetFileFramesCount(iFilename);
    if FileExists(iFilename) then
    begin
      if (IsMultiFrameImage) or (iFrames > 1) then
      begin
        { Clear frames }
        ImageEnMView1.Clear;
        ImageEnMView1.Update;
        { Close all pages }
        for iPage := PageControl1.PageCount - 1 downto 0 do
          PageControl1.Pages[iPage].Free;
      end;
      if iFrames > 1 then
      begin
        ImageEnMView1.MIO.LoadFromFile(iFilename);
        ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
      end
      else
      begin
        ImageEnMView1.AppendImage(iFilename);
        ImageEnMView1.SelectedImage := ImageEnMView1.ImageCount - 1;
      end;
      if ImageEnMView1.MIO.Aborting then
      begin
        { AdvTaskDialog1.Clear;
          AdvTaskDialog1.CustomButtons.Clear;
          AdvTaskDialog1.Title := 'Warning';
          AdvTaskDialog1.Instruction := 'Error Opening Image';
          AdvTaskDialog1.Content :=
          'There was an error opening the image.  The image can not be opened.';
          AdvTaskDialog1.CommonButtons := [cbOk];
          AdvTaskDialog1.Icon := tiWarning;
          AdvTaskDialog1.Footer :=
          'Developed By Adirondack Software & Graphics';
          AdvTaskDialog1.Execute; }
        iNotification := NotificationCenter1.CreateNotification;
        try
          iNotification.Name := 'ErrorNotification';
          iNotification.Title := 'Error Opening Image';
          iNotification.AlertBody :=
            'There was an error opening the image.  The image can not be opened.';
          NotificationCenter1.PresentNotification(iNotification);
        finally
          iNotification.Free;
        end;
        exit;
      end;
      Caption := 'Brush Tools, Frames And Layers- ' + iFilename;
      AFilename := iFilename;
      for i := 0 to iFrames - 1 do
      begin
        AddTabsheet;
        if Assigned(PageControl1.ActivePage) then
        begin
          ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
          if Assigned(ImageEnView) then
          begin
            if ImageEnView.LayersCount > 1 then
              ImageEnView.Layers[ImageEnView.LayersCount - 1].Name :=
                'Image Layer ' + IntToStr(ImageEnView.LayersCount)
            else
              ImageEnView.Layers[ImageEnView.LayersCount - 1].Name :=
                'Background';
            PageControl1.Pages[PageControl1.ActivePageIndex].Caption :=
              ExtractFileName(iFilename);
            PageControl1.Pages[PageControl1.ActivePageIndex].Hint := iFilename;
            ImageEnMView1.CopyToIEBitmap(i, ImageEnView.IEBitmap);
            ImageEnView.IO.Params.Assign(ImageEnMView1.MIO.Params[i]);
            ImageEnView.Fit();

            // Assign an image to use as a brush
            ImageEnView.BrushTool.BrushImage.Assign(ImageEnView2.Bitmap);
            // Remove white background
            ImageEnView.BrushTool.BrushImage.SetTransparentColors(clWhite,
              clWhite, 0);
            ImageEnView.MouseInteract := [miBrushTool]; // Paint Brush tool
            iWidth := ImageEnView.IEBitmap.Width;
            iHeight := ImageEnView.IEBitmap.Height;
            iDimensions := IntegerToString(iWidth) + ' x ' +
              IntegerToString(iHeight);
            ImageEnMView1.MIO.Params[i].Width := iWidth;
            ImageEnMView1.MIO.Params[i].Height := iHeight;
            iBitDepth := ImageEnView.IO.Params.BitsPerSample *
              ImageEnView.IO.Params.SamplesPerPixel;
            if iBitDepth = 32 then
              iColor := 'RGBA 32-Bit'
            else
              iColor := 'RGB ' + IntToStr(iBitDepth) + '-Bit';
            ImageEnMView1.ImageTopText[i] := iDimensions + ' ' + iColor;
            ImageEnMView1.ImageBottomText[i] := 'Frame ' + IntToStr(i + 1);
            ImageEnView.IEBitmap.Modified := False;
            ImageEnLayerMView1.ReadLayers();
          end;
        end;
      end;
      if AMostRecentFiles.IndexOf(iFilename) = -1 then
        AMostRecentFiles.Add(iFilename);
      ImageEnMView1.SelectedImage := 0;
      PageControl1.ActivePageIndex := 0;
      ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
      if Assigned(ImageEnView) then
      begin
        iWidth := ImageEnView.IEBitmap.Width;
        if iWidth <= 256 then
        begin
          TrackBarBrushSize1.Position := 1;
          EditBrushSize1.Text := IntToStr(TrackBarBrushSize1.Position);
          ComboBoxBrushShape1.ItemIndex := 1;
        end
        else
        begin
          TrackBarBrushSize1.Position := 25;
          EditBrushSize1.Text := IntToStr(TrackBarBrushSize1.Position);
          ComboBoxBrushShape1.ItemIndex := 0;
        end;
      end;
      UpdateUndo;
      Redo2.Enabled := ImageEnView.Proc.CanRedo;
      ImageEnView.BrushTool.Enabled := False;
      ImageEnView.AutoCursors := True;
      ImageEnView.Cursor := 1784;
      Shapes1.Refresh;
      PolylineShapes1.Refresh;
      UpdateGUI;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.OpenLayers1Click(Sender: TObject);
var
  iIndex: Integer;
  iFilename: string;
  iExtension: string;
begin
  OpenPictureDialog1.Filter := 'ImageEn Layer File(*.ien)|*.ien|';
  OpenPictureDialog1.FilterIndex := 0;
  if OpenPictureDialog1.Execute then
  begin
    iFilename := OpenPictureDialog1.FileName;
    iExtension := ExtractFileExt(iFilename);
    AddTabsheet;
    if Assigned(PageControl1.ActivePage) then
    begin
      Screen.Cursor := crHourglass;
      try
        ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
        if Assigned(ImageEnView) then
        begin
          AFilename := iFilename;
          ImageEnView.LayersLoadFromFile(OpenPictureDialog1.FileName);
          iIndex := ImageEnMView1.AppendImage(iFilename);
          ImageEnMView1.SelectedImage := iIndex;
          UpdateFrame;
          UpdateTabSheets;
          // DrawLayers;
          UpdateStatusBar;
          SaveLayers1.Enabled := ImageEnView.LayersCount > 1;
          if Fit1.State = tssOn then
            ImageEnView.Fit
          else
            ImageEnView.Zoom := 100;
          SelectLayers1.Down := True;
          ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
        end;
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  ImageEnMView1.SelectedImage := PageControl1.ActivePageIndex;
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.IEBitmap.Modified := ImageEnView.Proc.CanUndo;
      if Rulers1.State = tssOn then
        ImageEnView.ShowRulers := [rdHorizontal, rdVertical]
      else
        ImageEnView.ShowRulers := [];
      if DisplayGrid1.State = tssOn then
        ImageEnView.DisplayGrid := True
      else
        ImageEnView.DisplayGrid := False;
      if Fit1.State = tssOn then
        ImageEnView.Fit
      else
        ImageEnView.Zoom := 100;
    end;
    if BrushTools1.Down then
    begin
      ImageEnView.MouseInteract := [miBrushTool];
      ImageEnView.BrushTool.Enabled := True;
      ImageEnView.CloneTool.Enabled := False;
      ImageEnView.CropTool.Enabled := False;
    end
    else
    begin
      ImageEnView.MouseInteract := [];
      ImageEnView.BrushTool.Enabled := False;
      ImageEnView.CloneTool.Enabled := False;
      ImageEnView.CropTool.Enabled := False;
    end;
    Shapes1.Refresh;
    PolylineShapes1.Refresh;
    UpdateStatusBar;
  end;
end;

procedure TForm1.PencilSketch1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Pencil Sketch ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.PencilSketch(False);
          ImageEnView.Update;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.CenteredTexture1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.BrushFill := iebfCenteredTexture;
      ComboBoxBrushFill1.ItemIndex := 4;
    end;
  end;
end;

procedure TForm1.LayerCropped1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Layers[ImageEnView.LayersCurrent].Cropped :=
        LayerCropped1.State = tssOn;
      ImageEnView.Update;
    end;
  end;
end;

procedure TForm1.LayerSelectable1Click(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Layers[ImageEnView.LayersCurrent].Selectable :=
        LayerSelectable1.State = tssOn;
      ImageEnView.Update;
    end;
  end;
end;

procedure TForm1.LayerMask1Click(Sender: TObject);
var
  iIELayer: TIELayer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iIELayer := ImageEnView.CurrentLayer;
      if (iIELayer is TIEImageLayer) and (MagnificationStyle1.ItemIndex > -1)
      then
        with TIEImageLayer(iIELayer) do
        begin
          iIELayer.IsMask := LayerMask1.State = tssOn;
          Magnify.Enabled := MagnificationLayer1.State = tssOn;
          Magnify.Rate := LayerMagnification1.Position / 10;
          Magnify.Style := TIEMagnifyStyle(MagnificationStyle1.ItemIndex);
          Magnify.Source := TIEMagnifySource(MagnifySource1.ItemIndex);
        end;
    end;
  end;
end;

procedure TForm1.ClearRecentFiles(Sender: TObject);
begin
  AMostRecentFiles.Clear;
end;

procedure TForm1.PolylineClosed1Click(Sender: TObject);
begin
  SetPolylineLayerParameters;
end;

procedure TForm1.PolylineLayerFillColor1Change(Sender: TObject);
begin
  SetPolylineLayerParameters;
end;

procedure TForm1.PolylineLayerFillColor2Change(Sender: TObject);
begin
  SetPolylineLayerParameters;
end;

procedure TForm1.PolylineLayerLineColor1Change(Sender: TObject);
begin
  SetPolylineLayerParameters;
end;

procedure TForm1.PolylineLayerOperation1Change(Sender: TObject);
begin
  SetPolylineLayerParameters;
end;

procedure TForm1.PolylineShapes1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEPolylineLayer then
        TIEPolylineLayer(ImageEnView.CurrentLayer)
          .SetPoints(TIEShape(PolylineShapes1.ItemIndex),
          PolylineClosed1.State = tssOn);
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.PolylineShapes1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  iShapeColor: TColor;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iShapeColor := LayerFillColor1.Selected;
      if (LayerFillColor1.Selected <> clNone) then
        iShapeColor := LayerFillColor1.Selected;
      IEDrawShapeToComboListBoxItem(TComboBox(Control).Canvas, Rect,
        Control.Enabled, TIEShape(Index), iShapeColor);
    end;
  end;
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
var
  i: Integer;
  iMenuItem: TMenuItem;
begin
  PopupMenu1.Items.Clear;
  if AMostRecentFiles.Count > 0 then
  begin
    for i := 0 to AMostRecentFiles.Count - 1 do
    begin
      iMenuItem := TMenuItem.Create(PopupMenu1);
      iMenuItem.Tag := i;
      iMenuItem.Caption := AMostRecentFiles[i];
      iMenuItem.OnClick := LoadRecentFile;
      PopupMenu1.Items.Add(iMenuItem);
    end;
    iMenuItem := TMenuItem.Create(PopupMenu1);
    PopupMenu1.Items.Add(iMenuItem);
    iMenuItem.Caption := '-';
    iMenuItem := TMenuItem.Create(PopupMenu1);
    PopupMenu1.Items.Add(iMenuItem);
    iMenuItem.Caption := 'Clear Recent';
    iMenuItem.OnClick := ClearRecentFiles;
  end;
end;

procedure TForm1.PositionLocked1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Layers[ImageEnView.LayersCurrent].Locked :=
        PositionLocked1.State = tssOn;
      ImageEnView.Update;
    end;
  end;
end;

procedure TForm1.PreviewQuality1Change(Sender: TObject);
const
  _cmbPreviewQuality_Fast = 0;
  _cmbPreviewQuality_Delayed_Best = 1;
  _cmbPreviewQuality_Best = 2;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      // Seperate code to make it easier to understand
      if PreviewQuality1.ItemIndex = _cmbPreviewQuality_Fast then
      begin
        // FASTEST DISPLAY
        // Zoom filter
        ImageEnView.ZoomFilter := rfNone;
        ImageEnView.DelayZoomFilter := False;
        // Rotation anti-alias
        ImageEnView.LayersRotationFilter := ierBicubic;
        ImageEnView.LayersRotationAntialias := True;
        ImageEnView.LayersRotationUseFilterOnPreview := False;
        // Fast drawing
        ImageEnView.LayersFastDrawing := iefFast;
      end
      else if PreviewQuality1.ItemIndex = _cmbPreviewQuality_Delayed_Best then
      begin
        // DELAYED HIGH QUALITY
        // Zoom filter
        ImageEnView.ZoomFilter := rfLanczos3;
        ImageEnView.DelayZoomFilter := True;
        // Rotation anti-alias
        ImageEnView.LayersRotationFilter := ierBicubic;
        ImageEnView.LayersRotationAntialias := True;
        ImageEnView.LayersRotationUseFilterOnPreview := True;
        // Fast drawing
        ImageEnView.LayersFastDrawing := iefDelayed;
      end
      else
      begin
        // HIGH QUALITY
        // Zoom filter
        ImageEnView.ZoomFilter := rfLanczos3;
        ImageEnView.DelayZoomFilter := False;
        // Rotation anti-alias
        ImageEnView.LayersRotationFilter := ierBicubic;
        ImageEnView.LayersRotationAntialias := True;
        ImageEnView.LayersRotationUseFilterOnPreview := True;
        // Fast drawing
        ImageEnView.LayersFastDrawing := iefNormal;
      end;
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.PrintPreview1Click(Sender: TObject);
// var
// iPrinterIndex: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      // iPrinterIndex := GetDefaultPrinterIndex;
      // Printer.PrinterIndex := iPrinterIndex;
      // if ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width >
      // ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height then
      // Printer.Orientation := poLandscape
      // else
      // Printer.Orientation := poPortrait;
      ImageEnMView1.MIO.PrintPreviewParams.PrintSelected := True;
      ImageEnMView1.MIO.DoPrintPreviewDialog('Print', True,
        'Print Preview', True);
    end;
  end;
end;

procedure TForm1.Redo1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.Redo(True);
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      UpdateUndo;
      Redo1.Hint := ImageEnView.Proc.RedoCaptions[0];
      ImageEnView.IEBitmap.Modified := ImageEnView.Proc.CanUndo;
      if Fit1.State = tssOn then
        ImageEnView.Fit
      else
        ImageEnView.Zoom := 100;
      UpdateTabSheets;
      UpdateFrame;
      DrawLayers;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.RemoveFrame1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnMView1.DeleteImage(ImageEnMView1.SelectedImage);
      ImageEnMView1.Update;
      if ImageEnMView1.ImageCount > 0 then
      begin
        for i := 0 to ImageEnMView1.ImageCount - 1 do
          ImageEnMView1.ImageTopText[i] := 'Frame ' + IntToStr(i + 1);
        PageControl1.ActivePage.Destroy;
        ImageEnMView1.CopyToIEBitmap(ImageEnMView1.SelectedImage,
          ImageEnView.IEBitmap);
        ImageEnView.Update;
        UpdateFrame;
        UpdateStatusBar;
      end
      else
      begin
        PageControl1.ActivePage.Free;
        ClearStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.RemoveLayer1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.LayersCurrent > 0 then
      begin
        ImageEnView.LayersRemove(ImageEnView.LayersCurrent);
      end;
      RemoveLayer1.Enabled := ImageEnView.LayersCount > 1;
      DrawLayers;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.RemoveRedEye1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Remove RedEye ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.RemoveRedEyes;
          ImageEnView.Update;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Resample1Click(Sender: TObject);
var
  iIEBitmap: TIEBitmap;
  iWidth: Integer;
  iHeight: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        FormResample := TFormResample.Create(Self);
        try
          Screen.Cursor := crHourglass;
          try
            iIEBitmap := TIEBitmap.Create;
            try
              iIEBitmap.Assign(ImageEnView.IEBitmap);
              FormResample.ImageEnView1.IEBitmap.Assign(iIEBitmap);
              FormResample.ImageEnView1.IO.Params.Assign(ImageEnView.IO.Params);
              FormResample.ImageEnView2.IEBitmap.Assign(iIEBitmap);
              FormResample.ImageEnView2.IO.Params.Assign(ImageEnView.IO.Params);
              FormResample.ImageEnView1.Update;
              FormResample.ImageEnView2.Update;
            finally
              iIEBitmap.Free;
            end;
          finally
            Screen.Cursor := crDefault;
          end;
          if FormResample.ShowModal = mrOk then
            if not FormResample.Applied then
            begin
              Screen.Cursor := crHourglass;
              try
                ImageEnView.Proc.SaveUndo
                  ('Resample ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
                Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
                Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
                UpdateUndo;
                iWidth := FormResample.ImageEnView2.IEBitmap.Width;
                iHeight := FormResample.ImageEnView2.IEBitmap.Height;
                ImageEnView.Proc.Resample(iWidth, iHeight,
                  TResampleFilter(FormResample.ComboBoxResampleFilter1.
                  ItemIndex), FormResample.Proportional1.Checked);
                ImageEnView.Update;
                ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
                ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
                ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
                  ImageEnView.IEBitmap);
                ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width :=
                  ImageEnView.IEBitmap.Width;
                ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height :=
                  ImageEnView.IEBitmap.Height;
                ImageEnMView1.Update;
                if Fit1.State = tssOn then
                  ImageEnView.Fit
                else
                  ImageEnView.Zoom := 100;
                ImageEnView.IEBitmap.Modified := True;
                UpdateTabSheets;
                DrawLayers;
                UpdateFrames;
                UpdateStatusBar;
              finally
                Screen.Cursor := crDefault;
              end;
            end;
        finally
          FormResample.Free;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Resize1Click(Sender: TObject);
var
  iIEBitmap: TIEBitmap;
  iWidth: Integer;
  iHeight: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        FormResize := TFormResize.Create(Self);
        try
          Screen.Cursor := crHourglass;
          try
            iIEBitmap := TIEBitmap.Create;
            try
              iIEBitmap.Assign(ImageEnView.IEBitmap);
              FormResize.ImageEnView1.IEBitmap.Assign(iIEBitmap);
              FormResize.ImageEnView1.IO.Params.Assign(ImageEnView.IO.Params);
              FormResize.ImageEnView2.IEBitmap.Assign(iIEBitmap);
              FormResize.ImageEnView2.IO.Params.Assign(ImageEnView.IO.Params);
              FormResize.ImageEnView1.Update;
              FormResize.ImageEnView2.Update;
            finally
              iIEBitmap.Free;
            end;
          finally
            Screen.Cursor := crDefault;
          end;
          if FormResize.ShowModal = mrOk then
            if not FormResize.Applied then
            begin
              Screen.Cursor := crHourglass;
              try
                ImageEnView.Proc.SaveUndo
                  ('Resize ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
                Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
                Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
                UpdateUndo;
                iWidth := FormResize.ImageEnView2.IEBitmap.Width;
                iHeight := FormResize.ImageEnView2.IEBitmap.Height;
                ImageEnView.Proc.ImageResize(iWidth, iHeight,
                  TIEHAlign(FormResize.ComboBoxVerticalAlignment1.ItemIndex),
                  TIEVAlign(FormResize.ComboBoxVerticalAlignment1.ItemIndex));
                ImageEnView.Update;
                ImageEnView.IO.Params.Width := ImageEnView.IEBitmap.Width;
                ImageEnView.IO.Params.Height := ImageEnView.IEBitmap.Height;
                ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
                  ImageEnView.IEBitmap);
                ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Width :=
                  ImageEnView.IEBitmap.Width;
                ImageEnMView1.MIO.Params[ImageEnMView1.SelectedImage].Height :=
                  ImageEnView.IEBitmap.Height;
                ImageEnMView1.Update;
                if Fit1.State = tssOn then
                  ImageEnView.Fit
                else
                  ImageEnView.Zoom := 100;
                ImageEnView.IEBitmap.Modified := True;
                UpdateTabSheets;
                DrawLayers;
                UpdateFrames;
                UpdateStatusBar;
              finally
                Screen.Cursor := crDefault;
              end;
            end;
        finally
          FormResize.Free;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Save1Click(Sender: TObject);
var
  iFilename: string;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iFilename := ImageEnView.IO.Params.FileName;
      if FileExists(iFilename) then
        ImageEnView.IO.SaveToFile(iFilename);
    end;
  end;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
var
  iFilename: string;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      SavePictureDialog1.Filter :=
        'All (*.ien;*.svg;*.gif;*.pcx;*.ani;*.svg;*.jpg;*.jpeg;*.gif;*.tif;*.tiff;*.png;*.gif;*.png;*.jpg;'
        + '*.jpeg;*.bmp;*.jpg;*.jpeg;*.gif;*.png;*.ico;*.emf;*.wmf;*.tif;*.tiff)|*.svg;*.gif;*.cur;*.pcx;*.ani;'
        + '*.svg;*.jpg;*.jpeg;*.gif;*.tif;*.tiff;*.png;*.gif;*.png;*.jpg;*.jpeg;*.bmp;*.jpg;*.jpeg;*.gif;*.png;'
        + '*.ico;*.emf;*.wmf;*.tif;*.tiff|' +
        'ImageEn Native File (*.ien}|*.ien|' +
        'Scalable Vector Graphics File (*.svg)|*.svg|' +
        'CompuServe GIF Image (*.gif)|*.gif|' + 'PCX Image (*.pcx)|*.pcx|' +
        'ANI Image (*.ani)|*.ani|' +
        'SVG graphics from DevExpress (*.svg)|*.svg|' +
        'JPEG graphics from DevExpress (*.jpg)|*.jpg|' +
        'JPEG graphics from DevExpress (*.jpeg)|*.jpeg|' +
        'GIF graphics from DevExpress (*.gif)|*.gif|' +
        'TIFF graphics from DevExpress (*.tif)|*.tif|' +
        'TIFF graphics from DevExpress (*.tiff)|*.tiff|' +
        'PNG graphics from DevExpress (*.png)|*.png|' +
        'GIF Image (*.gif)|*.gif|' + 'Portable Network Graphics (*.png)|*.png|'
        + 'JPEG Image File (*.jpg)|*.jpg|' + 'JPEG Image File (*.jpeg)|*.jpeg|'
        + 'Bitmaps (*.bmp)|*.bmp|' + 'JPEG Images (*.jpg)|*.jpg|' +
        'JPEG Images (*.jpeg)|*.jpeg|' + 'GIF Images (*.gif)|*.gif|' +
        'PNG Images (*.png)|*.png|' + 'Icons (*.ico)|*.ico|' +
        'Enhanced Metafiles (*.emf)|*.emf|' + 'Metafiles (*.wmf)|*.wmf|' +
        'TIFF Images (*.tif)|*.tif|' + 'TIFF Images (*.tiff)|*.tiff';
      if SavePictureDialog1.Execute then
      begin
        iFilename := SavePictureDialog1.FileName;
        if iFilename <> '' then
          ImageEnView.IO.SaveToFile(iFilename);
        if ImageEnView.IO.Aborting then
        begin
          exit;
        end;
        PageControl1.Pages[PageControl1.ActivePageIndex].Caption :=
          ExtractFileName(iFilename);
        PageControl1.Pages[PageControl1.ActivePageIndex].Hint := iFilename;
        if AMostRecentFiles.IndexOf(iFilename) = -1 then
          AMostRecentFiles.Add(iFilename);
        AFilename := iFilename;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.SaveLayers1Click(Sender: TObject);
var
  iFilename: string;
  iExtension: string;
  iNotification: TNotification;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      SavePictureDialog1.Filter := 'ImagEn Layer File(*.ien)|*.ien|';
      SavePictureDialog1.FilterIndex := 0;
      if SavePictureDialog1.Execute then
      begin
        iFilename := SavePictureDialog1.FileName;
        iExtension := ExtractFileExt(iFilename);
        if iFilename <> '' then
          ImageEnView.IO.SaveToFileIEN(iFilename);
        if ImageEnView.IO.Aborting then
        begin
          { AdvTaskDialog1.Clear;
            AdvTaskDialog1.CustomButtons.Clear;
            AdvTaskDialog1.Title := 'Warning';
            AdvTaskDialog1.Instruction := 'Error Opening Image';
            AdvTaskDialog1.Content :=
            'There was an error opening the image.  The image can not be opened.';
            AdvTaskDialog1.CommonButtons := [cbOk];
            AdvTaskDialog1.Icon := tiWarning;
            AdvTaskDialog1.Footer :=
            'Developed By Adirondack Software & Graphics';
            AdvTaskDialog1.Execute; }
          iNotification := NotificationCenter1.CreateNotification;
          try
            iNotification.Name := 'ErrorNotification';
            iNotification.Title := 'Error Opening Image';
            iNotification.AlertBody :=
              'There was an error opening the image.  The image can not be opened.';
            NotificationCenter1.PresentNotification(iNotification);
          finally
            iNotification.Free;
          end;
          exit;
        end;
        PageControl1.Pages[PageControl1.ActivePageIndex].Caption :=
          ExtractFileName(iFilename);
        PageControl1.Pages[PageControl1.ActivePageIndex].Hint := iFilename;
        if AMostRecentFiles.IndexOf(iFilename) = -1 then
          AMostRecentFiles.Add(iFilename);
        AFilename := iFilename;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.ShapeBrushColor2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog1.Color := TShape(Sender).Brush.Color;
  if ColorDialog1.Execute then
    TShape(Sender).Brush.Color := ColorDialog1.Color;
  ControlChange(nil);
end;

procedure TForm1.Shapes1Change(Sender: TObject);
begin
  SetShapeLayerParameters;
end;

procedure TForm1.Shapes1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  iShapeColor: TColor;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      iShapeColor := LayerFillColor1.Selected;
      if (LayerFillColor1.Selected <> clNone) then
        iShapeColor := LayerFillColor1.Selected;
      IEDrawShapeToComboListBoxItem(TComboBox(Control).Canvas, Rect,
        Control.Enabled, TIEShape(Index), iShapeColor);
    end;
  end;
end;

procedure TForm1.ShapeBrushColor1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog1.Color := TShape(Sender).Brush.Color;
  if ColorDialog1.Execute then
    TShape(Sender).Brush.Color := ColorDialog1.Color;
  ControlChange(nil);
  ColorBox1.Selected := ColorDialog1.Color;
end;

procedure TForm1.SelectNone1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      // if ImageEnView.Selected then
      ImageEnView.Deselect;
      ImageEnView.MouseInteract := [];
    end;
  end;
end;

procedure TForm1.BrushTools1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if BrushTools1.Down then
      begin
        ImageEnView.MouseInteract := [miBrushTool];
        ImageEnView.BrushTool.Enabled := True;
        ImageEnView.CloneTool.Enabled := False;
        ImageEnView.CropTool.Enabled := False;
        ImageEnView.Proc.AutoUndo := True;
        ShapeBrushColor1.Brush.Color := DitherColor(ColorBox1.Selected,
          TrackbarTransparency1.Position);
        IEColorPaletteBrush1.SelectedColor := ColorBox1.Selected;
        ControlChange(Sender);
      end
      else
      begin
        ImageEnView.MouseInteract := [];
        ImageEnView.BrushTool.Enabled := False;
        ImageEnView.CloneTool.Enabled := False;
        ImageEnView.CropTool.Enabled := False;
        ImageEnView.Proc.AutoUndo := False;
        NoTools1.Down := True;
      end;
    end;
  end;
end;

procedure TForm1.btnClearAllPointsClick(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
      if ImageEnView.CurrentLayer is TIEPolylineLayer then
        TIEPolylineLayer(ImageEnView.CurrentLayer).ClearAllPoints();
    ImageEnView.Update();
  end;
end;

procedure TForm1.CropAlpha1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
      if ImageEnView.CurrentLayer is TIEImageLayer then
        TIEImageLayer(ImageEnView.CurrentLayer).CropAlpha();
    ImageEnView.Update();
  end;
end;

procedure TForm1.RestoreSize1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
        TIEImageLayer(ImageEnView.CurrentLayer).RestoreSize();
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.Rotate1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Proc.SaveUndo
        ('Rotate ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
      Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
      Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
      UpdateUndo;
      ImageEnView.Proc.Rotate(90);
      ImageEnView.Deselect;
      UpdateFrames;
      UpdateTabSheets;
      DrawLayers;
      UpdateStatusBar;
    end;
  end;
end;

procedure TForm1.btnSetPolylineHeartClick(Sender: TObject);
var
  iIEPolyLineLayer: TIEPolylineLayer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer.Kind <> ielkPolyline then
        exit;
      iIEPolyLineLayer := TIEPolylineLayer(ImageEnView.CurrentLayer);
      iIEPolyLineLayer.ClearAllPoints();
      iIEPolyLineLayer.AddPoint(100, 500);
      iIEPolyLineLayer.AddCurvePoints(-1, 500, 200, 20);
      iIEPolyLineLayer.AddCurvePoints(-1, 900, 500, 20);
      iIEPolyLineLayer.AddPoint(500, 1000);
      iIEPolyLineLayer.PolylineClosed := True;
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.btnSetPolylineStarClick(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEPolylineLayer then
        TIEPolylineLayer(ImageEnView.CurrentLayer).SetPoints(iesStar5, True);
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.btnSetPolylineTriangleClick(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEPolylineLayer then
        With TIEPolylineLayer(ImageEnView.CurrentLayer) do
        begin
          ClearAllPoints();
          AddPoint(500, 0);
          AddPoint(1000, 1000);
          AddPoint(0, 1000);
          PolylineClosed := True;
        end;
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.btnSimplifyPolygonClick(Sender: TObject);
var
  iPointCount: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEPolylineLayer then
      begin
        iPointCount := TIEPolylineLayer(ImageEnView.CurrentLayer)
          .PointCount div 2;
        if iPointCount < 3 then
          raise Exception.Create
            ('Polyline does not have enough points to simplify');
        TIEPolylineLayer(ImageEnView.CurrentLayer).SimplifyPolygon(iPointCount);
        ImageEnView.Update();
      end;
    end;
  end;
end;

procedure TForm1.ActivateTextEditor1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIETextLayer then
        TIETextLayer(ImageEnView.CurrentLayer).ActivateEditor()
      else if ImageEnView.CurrentLayer is TIELineLayer then
        TIELineLayer(ImageEnView.CurrentLayer).ActivateEditor();
    end;
  end;
end;

procedure TForm1.SetFont1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      With ImageEnView do
        case CurrentLayer.Kind of
          ielkText:
            begin
              FontDialog1.Font.Assign(TIETextLayer(CurrentLayer).Font);
              if FontDialog1.Execute then
                SetTextLayerParameters;
            end;
          ielkLine:
            begin
              FontDialog1.Font.Assign(TIELineLayer(CurrentLayer).LabelFont);
              if FontDialog1.Execute then
                SetLineLayerParameters;
            end;
        end;
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.SetText1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      With ImageEnView do
        case CurrentLayer.Kind of
          ielkText:
            TIETextLayer(CurrentLayer).Text := TextLayerText1.Text;
          ielkLine:
            TIELineLayer(CurrentLayer).LabelText := TextLayerText1.Text;
        end;
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.SizeToFit1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIETextLayer then
        TIETextLayer(ImageEnView.CurrentLayer).SizeToText
      else if ImageEnView.CurrentLayer is TIELineLayer then
        TIELineLayer(ImageEnView.CurrentLayer).SizeToFit;
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.SoftShadow1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.CurrentLayer.SoftShadow.Enabled := SoftShadow1.State = tssOn;
      ImageEnView.Update;
      DrawLayers;
      Shapes1.Refresh;
    end;
  end;
end;

procedure TForm1.Solid1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.BrushFill := iebfSolid;
      ComboBoxBrushFill1.ItemIndex := 0;
    end;
  end;
end;

procedure TForm1.Spray1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.BrushTool.BrushFill := iebfSpray;
      ComboBoxBrushFill1.ItemIndex := 2;
    end;
  end;
end;

procedure TForm1.StartShape1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      SetLineLayerParameters;
    end;
  end;
end;

procedure TForm1.AutoClosePolylines1Change(Sender: TObject);
begin
  SetPolylineLayerParameters;
end;

procedure TForm1.AutoCrop1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Auto Crop 2 ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.AutoCrop2;
          ImageEnView.Update;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.AutoEnhance2Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Auto Enhance 1 ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.AutoImageEnhance1;
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.AutoEnhance3Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Auto Enhance 2 ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.AutoImageEnhance2;
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.AutoEnhance4Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Auto Enhance 3 ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.AutoImageEnhance3;
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.AutoSharp1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Auto Sharp ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.AutoSharp;
          ImageEnView.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.TextAutoSize1Click(Sender: TObject);
begin
  SetTextLayerParameters;
end;

procedure TForm1.TextReadOnly1Click(Sender: TObject);
begin
  SetTextLayerParameters;
end;

procedure TForm1.TextWordWrap1Click(Sender: TObject);
begin
  SetTextLayerParameters;
end;

procedure TForm1.Tint1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo
            ('Tint ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.AdjustTint(25);
          ImageEnView.Update;
          ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
            ImageEnView.IEBitmap);
          ImageEnMView1.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.CloneTools1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if CloneTools1.Down then
      begin
        ImageEnView.MouseInteract := [miCloneTool];
        ImageEnView.CloneTool.CursorSize := UpDownBrushSize1.Position;
        ImageEnView.CloneTool.Continuous := False;
        ImageEnView.Proc.AutoUndo := True;
      end
      else
      begin
        ImageEnView.MouseInteract := [];
        ImageEnView.Proc.AutoUndo := False;
      end;
    end;
  end;
end;

procedure TForm1.Crop2Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.Selected then
      begin
        ImageEnView.Proc.SaveUndo
          ('Crop ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
        Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
        Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
        UpdateUndo;
        ImageEnView.Proc.CropSel();
        ImageEnView.Deselect;
        UpdateFrames;
        UpdateTabSheets;
        DrawLayers;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.CropTools1Click(Sender: TObject);
var
  iUndoHint: string;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if CropTools1.Down then
      begin
        ImageEnView.BrushTool.Enabled := False;
        ImageEnView.CloneTool.Enabled := False;
        ImageEnView.CropTool.Enabled := True;
        ImageEnView.MouseInteract := [miCropTool];
        ImageEnView.Proc.SaveUndo
          ('Crop ' + IntToStr(ImageEnView.Proc.UndoCount + 1));
        Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
        Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
        UpdateUndo;
        UpdateStatusBar;
      end
      else
      begin
        iUndoHint := ImageEnView.Proc.UndoCaptions[0];
        if Undo1.Hint = iUndoHint then
          ImageEnView.Proc.ClearUndoAt(ImageEnView.Proc.UndoCount - 1);
        Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
        Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
        UpdateUndo;
        ImageEnView.BrushTool.Enabled := False;
        ImageEnView.CloneTool.Enabled := False;
        ImageEnView.CropTool.Enabled := False;
        ImageEnView.MouseInteract := [];
        ImageEnView.IEBitmap.Modified := ImageEnView.Proc.CanUndo;
        UpdateStatusBar;
      end;
    end;
  end;
end;

procedure TForm1.Curves1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      FormCurves := TFormCurves.Create(Self);
      try
        FormCurves.IEColorCurve1.AssignSource(ImageEnView.IEBitmap);
        if (FormCurves.ShowModal = mrOk) and (not FormCurves.Applied) then
        begin
          ImageEnView.Proc.SaveUndo('ColorCurve ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          FormCurves.IEColorCurve1.ApplyCurve(ImageEnView.IEBitmap);
          ImageEnView.Update();
          ImageEnView.IEBitmap.Modified := True;
          UpdateUndo;
        end;
      finally
        FormCurves.Free;
      end;
    end;
  end;
end;

procedure TForm1.ToggleSwitch1Click(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      for i := 0 to PageControl1.PageCount - 1 do
      begin
        ImageEnView := TImageEnView(PageControl1.Pages[i].Controls[0]);
        if Assigned(ImageEnView) then
        begin
          if Rulers1.State = tssOn then
            ImageEnView.ShowRulers := [rdHorizontal, rdVertical]
          else
            ImageEnView.ShowRulers := [];
        end;
      end;
    end;
  end;
end;

procedure TForm1.ToggleSwitchFillMaxFilter1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.FillTool.MaxFilter :=
        ToggleSwitchFillMaxFilter1.State = tssOn;
    end;
  end;
end;

procedure TForm1.ToggleSwitchNoShape1Click(Sender: TObject);
begin
  if ToggleSwitchNoShape1.State = tssOff then
    TextLayerShape1.ItemIndex := -1;
end;

procedure TForm1.TrackBarBrushSize1Change(Sender: TObject);
begin
  UpDownBrushSize1.Position := TrackBarBrushSize1.Position;
  UpdownFeathering1.Position := TrackBarFeathering1.Position;
  UpDownTransparency1.Position := TrackbarTransparency1.Position;
  ControlChange(Sender);
end;

procedure TForm1.TrackBarBrushStep1Change(Sender: TObject);
begin
  UpDownBrushStep1.Position := TrackBarBrushStep1.Position;
  ControlChange(Sender);
end;

procedure TForm1.TrackBarFeathering1Change(Sender: TObject);
begin
  UpdownFeathering1.Position := TrackBarFeathering1.Position;
  ControlChange(Sender);
end;

procedure TForm1.TrackBarFillAlpha1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      UpDownFillAlpha1.Position := TrackBarFillAlpha1.Position;
    end;
  end;
end;

procedure TForm1.TrackBarFillToolSampleSize1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      UpDownFillSampleSize1.Position := TrackBarFillToolSampleSize1.Position;
      ImageEnView.FillTool.SampleSize := TrackBarFillToolSampleSize1.Position;
    end;
  end;
end;

procedure TForm1.TrackBarFloodFillTolerance1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.FillTool.Tolerance := TrackBarFloodFillTolerance1.Position;
    end;
  end;
end;

procedure TForm1.TrackBarLayerBorderWidth1Change(Sender: TObject);
begin
  UpDownBorderWidth1.Position := TrackBarLayerBorderWidth1.Position;
end;

procedure TForm1.TrackBarLayerRotation1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      UpDownLayerRotation1.Position := TrackBarLayerRotation1.Position;
      ImageEnView.CurrentLayer.Rotate := TrackBarLayerRotation1.Position;
      ImageEnView.Update();
    end;
  end;
end;

procedure TForm1.TrackBarLineLayerWidth1Change(Sender: TObject);
begin
  UpDownLineWidth1.Position := TrackBarLineLayerWidth1.Position;
end;

procedure TForm1.TrackBarPolylineLayerOpacity1Change(Sender: TObject);
begin
  SetPolylineLayerParameters;
end;

procedure TForm1.TrackBarPolylineTransparency1Change(Sender: TObject);
begin
  SetPolylineLayerParameters;
end;

procedure TForm1.TrackBarPolylineWidth1Change(Sender: TObject);
begin
  APolylineWidthChanging := True;
  UpDownPolylineLayerWidth1.Position := TrackBarPolylineWidth1.Position;
  SetPolylineLayerParameters;
  APolylineWidthChanging := False;
end;

procedure TForm1.TrackbarTransparency1Change(Sender: TObject);
begin
  UpDownTransparency1.Position := TrackbarTransparency1.Position;
  ShapeBrushColor1.Brush.Color := DitherColor(ColorBox1.Selected,
    TrackbarTransparency1.Position);
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.Layers[ImageEnView.LayersCurrent].Kind = ielkShape then
        TIEShapeLayer(ImageEnView.CurrentLayer).Transparency :=
          TrackbarTransparency1.Position;
      ControlChange(Sender);
    end;
  end;
end;

procedure TForm1.TrackBarZoom1Change(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.Zoom := TrackBarZoom1.Position;
      EditZoom1.Text := IntToStr(TrackBarZoom1.Position);
    end;
  end;
end;

procedure TForm1.UpDownBorderWidth1Click(Sender: TObject; Button: TUDBtnType);
begin
  TrackBarLayerBorderWidth1.Position := UpDownBorderWidth1.Position;
end;

procedure TForm1.UpDownBrushSize1Click(Sender: TObject; Button: TUDBtnType);
begin
  TrackBarBrushSize1.Position := UpDownBrushSize1.Position;
end;

procedure TForm1.UpDownFillAlpha1Click(Sender: TObject; Button: TUDBtnType);
begin
  TrackBarFillAlpha1.Position := UpDownFillAlpha1.Position;
end;

procedure TForm1.UpDownFillSampleSize1Click(Sender: TObject;
  Button: TUDBtnType);
begin
  TrackBarFillToolSampleSize1.Position := UpDownFillSampleSize1.Position;
end;

procedure TForm1.UpDownLayerTransparency1Click(Sender: TObject;
  Button: TUDBtnType);
begin
  LayerTransparencyTrackBar1.Position := UpDownLayerTransparency1.Position;
end;

procedure TForm1.UpDownLineWidth1Click(Sender: TObject; Button: TUDBtnType);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      { Adjust the layer height }
      case Button of
        btNext: { up }
          begin
            ImageEnView.CurrentLayer.Height := ImageEnView.CurrentLayer.Height +
              UpDownLineWidth1.Position;
          end;
        btPrev: { down }
          begin
            ImageEnView.CurrentLayer.Height := ImageEnView.CurrentLayer.Height -
              UpDownLineWidth1.Position;
          end;
      end;
      TrackBarLineLayerWidth1.Position := UpDownLineWidth1.Position;
      SetLineLayerParameters;
    end;
  end;
end;

procedure TForm1.IEColorPaletteBrush1GetHintText(Sender: TObject;
  AColor: TColor; Index: Integer; var HintStr: string);
var
  iR: Byte;
  iG: Byte;
  iB: Byte;
  iHSLH: Byte;
  iHSLS: Byte;
  iHSLL: Byte;
  iHSVH, iHSVS, iHSVV: Integer;
  iName: string;
begin
  if Index <> -1 then
  begin
    AColorToRGB(AColor, iR, iG, iB);
    ColorToHSL(AColor, iHSLH, iHSLS, iHSLL);
    ColorToHSV(AColor, iHSVH, iHSVS, iHSVV);
    if cxNameByColor(AColor, iName) then
      HintStr := 'Color: ' + ColorToHex(AColor) + #13 + 'Name: ' + iName + #13 +
        'RGB: (R) ' + IntToStr(iR) + ' (G) ' + IntToStr(iG) + ' (B) ' +
        IntToStr(iB) + #13 + 'HSL: (H) ' + IntToStr(iHSLH) + ' (S) ' +
        IntToStr(iHSLS) + ' (L) ' + IntToStr(iHSLL) + #13 + 'HSV: (H) ' +
        IntToStr(iHSVH) + ' (S) ' + IntToStr(iHSVS) + ' (V) ' + IntToStr(iHSVV)
    else
      HintStr := 'Color: ' + ColorToHex(AColor) + #13 + 'Name: ' +
        ColorToPrettyName(AColor) + #13 + 'RGB: (R) ' + IntToStr(iR) + ' (G) ' +
        IntToStr(iG) + ' (B) ' + IntToStr(iB) + #13 + 'HSL: (H) ' +
        IntToStr(iHSLH) + ' (S) ' + IntToStr(iHSLS) + ' (L) ' + IntToStr(iHSLL)
        + #13 + 'HSV: (H) ' + IntToStr(iHSVH) + ' (S) ' + IntToStr(iHSVS) +
        ' (V) ' + IntToStr(iHSVV);
  end;
end;

procedure TForm1.IEColorPaletteBrush1SelectedColorChange(Sender: TObject);
begin
  ColorBox1.Selected := IEColorPaletteBrush1.SelectedColor;
  ShapeBrushColor1.Brush.Color := DitherColor(ColorBox1.Selected,
    TrackbarTransparency1.Position);
  ControlChange(Sender);
end;

procedure TForm1.IEColorPaletteBrush2GetHintText(Sender: TObject;
  AColor: TColor; Index: Integer; var HintStr: string);
var
  iR: Byte;
  iG: Byte;
  iB: Byte;
  iHSLH: Byte;
  iHSLS: Byte;
  iHSLL: Byte;
  iHSVH, iHSVS, iHSVV: Integer;
  iName: string;
begin
  if Index <> -1 then
  begin
    AColorToRGB(AColor, iR, iG, iB);
    ColorToHSL(AColor, iHSLH, iHSLS, iHSLL);
    ColorToHSV(AColor, iHSVH, iHSVS, iHSVV);
    if cxNameByColor(AColor, iName) then
      HintStr := 'Color: ' + ColorToHex(AColor) + #13 + 'Name: ' + iName + #13 +
        'RGB: (R) ' + IntToStr(iR) + ' (G) ' + IntToStr(iG) + ' (B) ' +
        IntToStr(iB) + #13 + 'HSL: (H) ' + IntToStr(iHSLH) + ' (S) ' +
        IntToStr(iHSLS) + ' (L) ' + IntToStr(iHSLL) + #13 + 'HSV: (H) ' +
        IntToStr(iHSVH) + ' (S) ' + IntToStr(iHSVS) + ' (V) ' + IntToStr(iHSVV)
    else
      HintStr := 'Color: ' + ColorToHex(AColor) + #13 + 'Name: ' +
        ColorToPrettyName(AColor) + #13 + 'RGB: (R) ' + IntToStr(iR) + ' (G) ' +
        IntToStr(iG) + ' (B) ' + IntToStr(iB) + #13 + 'HSL: (H) ' +
        IntToStr(iHSLH) + ' (S) ' + IntToStr(iHSLS) + ' (L) ' + IntToStr(iHSLL)
        + #13 + 'HSV: (H) ' + IntToStr(iHSVH) + ' (S) ' + IntToStr(iHSVS) +
        ' (V) ' + IntToStr(iHSVV);
  end;
end;

procedure TForm1.IEColorPaletteBrush2SelectedColorChange(Sender: TObject);
begin
  ColorBox2.Selected := IEColorPaletteBrush2.SelectedColor;
  ShapeBrushColor2.Brush.Color := ColorBox2.Selected;
  ControlChange(Sender);
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Image1.Down then
      begin
        ImageEnView.BrushTool.BrushFill := iebfImage;
        ComboBoxBrushFill1.ItemIndex := 6;
        ImageEnView.Proc.AutoUndo := True;
      end
      else
      begin
        ImageEnView.Proc.AutoUndo := False;
      end;
    end;
  end;
end;

procedure TForm1.ImageEnLayerMView1GetTextEx(Sender: TObject; Index: Integer;
  Position: TIEMTextPos; var Text: WideString; Font: TFont;
  var BackgroundStyle: TBrushStyle; var BackgroundColor: TColor;
  var TruncSide: TIEMTruncSide);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if Position = iemtpTop then
      begin
        Font.Style := [fsBold];
        Text := 'Kind: ' + GetLayerKindStr(ImageEnView) + '     ';
        Text := Text + 'Name: ' + ImageEnView.Layers[index].Name;
      end
      else
      begin
        Font.Style := [];
        Text := 'X: ' + IntegerToString(ImageEnView.Layers[index].PosX)
          + '     ';
        Text := Text + 'Y: ' + IntegerToString(ImageEnView.Layers[index].PosY)
          + '     ';
        Text := Text + 'Width: ' + IntegerToString
          (ImageEnView.Layers[index].Width) + '     ';
        Text := Text + 'Height: ' + IntegerToString
          (ImageEnView.Layers[index].Height);
      end;
    end;
  end;
end;

procedure TForm1.ImageEnMView1ImageSelect(Sender: TObject; idx: Integer);
begin
  PageControl1.ActivePageIndex := idx;
end;

procedure TForm1.ImageEnPopupMenu1Popup(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      LayerProperties1.Enabled := ImageEnView.LayersCount > 1;
      LayerRemove1.Enabled := ImageEnView.LayersCount > 1;
    end;
  end;
end;

procedure TForm1.ImageEnViewViewChange(Sender: TObject; Change: Integer);
begin
  TrackBarZoom1.Position := Round(ImageEnView.Zoom);
end;

procedure TForm1.IncreaseBrightness1Click(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      if ImageEnView.CurrentLayer is TIEImageLayer then
      begin
        Screen.Cursor := crHourglass;
        try
          ImageEnView.Proc.SaveUndo('Brightness ' +
            IntToStr(ImageEnView.Proc.UndoCount + 1));
          Undo1.Hint := ImageEnView.Proc.UndoCaptions[0];
          Undo2.Hint := ImageEnView.Proc.UndoCaptions[0];
          UpdateUndo;
          ImageEnView.Proc.AdjustBrightnessContrastSaturation(10, 0, 0);
          ImageEnView.Update;
          ImageEnMView1.SetIEBitmapEx(ImageEnMView1.SelectedImage,
            ImageEnView.IEBitmap);
          ImageEnMView1.Update;
          ImageEnView.IEBitmap.Modified := True;
          DrawLayers;
          UpdateFrame;
          UpdateStatusBar;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  end;
end;

procedure TForm1.ImageEnViewLayerSelectionChange(Sender: TObject);
begin
  UpdateStatusBar;
end;

procedure TForm1.ImageEnViewLayerNotify(Sender: TObject; layer: Integer;
  Event: TIELayerEvent);
var
  iIELayerKind: TIELayerKind;
begin
  if (Event = ielSelected) or (Event = ielLeftClicked) then
  begin
    iIELayerKind := ImageEnView.CurrentLayer.Kind;
    if iIELayerKind = ielkImage then
      GetImageLayerParameters
    else if iIELayerKind = ielkShape then
      GetShapeLayerParameters
    else if iIELayerKind = ielkLine then
      GetLineLayerParameters
    else if iIELayerKind = ielkText then
      GetTextLayerParameters
    else if iIELayerKind = ielkPolyline then
      GetPolylineLayerParameters;
    ImageEnLayerMView1.Update;
    UpdateStatusBar;
  end
  else if (Event = ielMoving) or (Event = ielResizing) or (Event = ielMoved) or
    (Event = ielResized) or (Event = ielRemoved) then
  begin
    DrawLayers;
  end;
  UpdateGUI;
end;

procedure TForm1.ImageEnViewKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  UpdateGUI;
  DrawLayers;
end;

procedure TForm1.ImageEnViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  UpdateGUI;
  UpdateUndo;
end;

procedure TForm1.ImageEnViewMeasure(Sender: TObject;
  MeasureType: TIEMeasureType; MeasureLayer: TIELayer; Size: Double;
  var Units: TIEUnits);
begin
  // MEASURE LENGTHS
  if MeasureLayer is TIELineLayer then
    with TIELineLayer(MeasureLayer) do
    begin
      LineColor := clBlue;
      LineWidth := 1;
      LabelFont.Color := clBlue;
    end
  else
    // MEASURE AREAS
    if MeasureLayer is TIETextLayer then
      with TIETextLayer(MeasureLayer) do
      begin
        BorderColor := clBlack;
        BorderWidth := 3;
        FillColor := clSilver;
        Font.Color := clBlue;
        Transparency := 128;
      end;
end;

procedure TForm1.ImageEnViewMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
end;

procedure TForm1.ImageEnViewNewLayer(Sender: TObject; LayerIdx: Integer;
  LayerKind: TIELayerKind);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    ImageEnView := TImageEnView(PageControl1.ActivePage.Controls[0]);
    if Assigned(ImageEnView) then
    begin
      ImageEnView.IEBitmap.Modified := True;
      if LayerKind = ielkImage then
      begin
        SelectLayers1.Down := True;
        ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
        ImageEnView.Update;
        DrawLayers;
        UpdateStatusBar;
      end;
      if LayerKind = ielkShape then
      begin
        ImageEnView.CurrentLayer.BorderColor := LayerBorderColor1.Selected;
        TIEShapeLayer(ImageEnView.CurrentLayer).BorderWidth :=
          UpDownBorderWidth1.Position;
        ImageEnView.CurrentLayer.FillColor := LayerFillColor1.Selected;
        SelectLayers1.Down := True;
        ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
        ImageEnView.Update;
        DrawLayers;
        UpdateStatusBar;
      end;
      if LayerKind = ielkLine then
      begin
        ImageEnView.CurrentLayer.BorderColor := LineColor1.Selected;
        ImageEnView.CurrentLayer.BorderWidth := UpDownBorderWidth1.Position;
        ImageEnView.CurrentLayer.FillColor := LineFillColor1.Selected;
        SelectLayers1.Down := True;
        ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
        ImageEnView.Update;
        DrawLayers;
        UpdateStatusBar;
      end;
      if LayerKind = ielkPolyline then
      begin
        ImageEnView.Layers[LayerIdx].Name := 'Polyline Layer ' +
          IntToStr(LayerIdx);
        ImageEnView.CurrentLayer.BorderColor := LineColor1.Selected;
        ImageEnView.CurrentLayer.BorderWidth := UpDownBorderWidth1.Position;
        ImageEnView.CurrentLayer.FillColor := LineFillColor1.Selected;
        ImageEnView.Update;
        DrawLayers;
        UpdateStatusBar;
      end;
      if LayerKind = ielkText then
      begin
        ImageEnView.CurrentLayer.BorderColor := LineColor1.Selected;
        ImageEnView.CurrentLayer.BorderWidth := UpDownBorderWidth1.Position;
        ImageEnView.CurrentLayer.FillColor := LineFillColor1.Selected;
        SelectLayers1.Down := True;
        ImageEnView.MouseInteract := [miMoveLayers, miResizeLayers];
        ImageEnView.Update;
      end;
    end;
  end;
  UpdateGUI;
end;

procedure TForm1.ImageEnViewUserInteraction(Sender: TObject;
  Event: TIEUserInteractionEvent; Info: Integer);
var
  iColor: TColor;
begin
  if Event = ieiColorPickerHover then
  begin
    // Hovering over image - show color in our panel
    ShapeBrushColor1.Brush.Color := TColor(Info);
  end
  else if Event = ieiColorPickerClick then
  begin
    // Clicked image - set this color
    iColor := TColor(Info);
    ShapeBrushColor1.Brush.Color := iColor;
    ColorBox1.Selected := iColor;
  end;
end;

procedure TForm1.ImageEnViewDrawLayerBox(Sender: TObject; ACanvas: TCanvas;
  LayerIndex: Integer);
begin
  with ACanvas do
  begin
    Pen.Style := psSolid;
    Pen.Width := 1;
    Pen.mode := pmCopy;
    Pen.Color := clGreen;
    Brush.Style := bsClear;
    with TIELayer(ImageEnView.Layers[LayerIndex]).ClientAreaBox do
      Rectangle(Left - 1, Top - 1, Right + 1, Bottom + 1);
  end;
end;

procedure TForm1.ImageEnViewImageChange(Sender: TObject);
begin
  if CropTools1.Down then
  begin
    UpdateFrame;
    UpdateTabSheets;
    DrawLayers;
    UpdateStatusBar;
    CropTools1.Down := False;
  end;
  if (BrushTools1.Down) or (FloodFillTool1.Down) then
  begin
    UpdateFrame;
    DrawLayers;
  end;
  ControlChange(Sender);
  UpdateGUI;
end;

procedure TForm1.ImageEnViewMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  iX: Integer;
  iY: Integer;
  iAlpha: Integer;
  iOpacity: Integer;
  iRGB: TRGB;
  iColor: TColor;
begin;
  iX := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvXScr2Bmp(X);
  iY := ImageEnView.Layers[ImageEnView.LayersCurrent].ConvYScr2Bmp(Y);
  AX := iX;
  AY := iY;
  if ImageEnView.Layers[ImageEnView.LayersCurrent].Kind = ielkImage then
  begin
    if (iX >= 0) and (iX <= ImageEnView.IEBitmap.Width - 1) and (iY >= 0) and
      (iY <= ImageEnView.IEBitmap.Height - 1) then
    begin
      if not ImageEnView.BrushTool.Enabled then
      begin
        iRGB := ImageEnView.Layers[ImageEnView.LayersCurrent]
          .Bitmap.Pixels[iX, iY];
        iColor := TRGB2TColor(iRGB);
        iAlpha := ImageEnView.Layers[ImageEnView.LayersCurrent]
          .Bitmap.Alpha[iX, iY];
        iOpacity := IEAlphaToOpacity(iAlpha);
        ColorUnderCursor1.Brush.Color := DitherColor(iColor, iAlpha);
        if (ImageEnView.Selected) and (ImageEnView.IsPointInsideSelection(X, Y))
        then
        begin
          StatusBar1.Panels[7].Width := 150;
          StatusBar1.Panels[8].Width := 150;
          StatusBar1.Panels[7].Text := 'Selected Width: ' +
            IntegerToString(ImageEnView.SelectedRect.Width);
          StatusBar1.Panels[8].Text := 'Selected Height: ' +
            IntegerToString(ImageEnView.SelectedRect.Height);
        end
        else
        begin
          StatusBar1.Panels[7].Width := 125;
          StatusBar1.Panels[8].Width := 125;
          StatusBar1.Panels[7].Text := 'Column: ' + IntegerToString(iX + 1);
          StatusBar1.Panels[8].Text := 'Row: ' + IntegerToString(iY + 1);
        end;
        LabelX1.Caption := 'X: ' + IntegerToString(iX);
        LabelY1.Caption := 'Y: ' + IntegerToString(iY);
        LabelAlpha1.Caption := 'Alpha: ' + IntToStr(iAlpha);
        LabelOpacity1.Caption := 'Opacity: ' + IntToStr(iOpacity);
        StatusBar1.Panels[9].Text := 'Alpha: ' + IntToStr(iAlpha);
        StatusBar1.Panels[10].Text := 'Opacity: ' + IntToStr(iOpacity);
        StatusBar1.Update;
      end
      else if ImageEnView.MouseCapture then
      begin
        DrawLayers;
      end;
    end;
  end;
  if (iX >= 0) and (iX <= ImageEnView.IEBitmap.Width - 1) and (iY >= 0) and
    (iY <= ImageEnView.IEBitmap.Height - 1) then
  begin
    ImageEnView.IEBitmap.Modified := ImageEnView.Proc.CanUndo;
    if ImageEnView.IEBitmap.Modified then
      StatusBar1.Panels[13].Text := 'Modified'
    else
      StatusBar1.Panels[13].Text := '';
  end
  else if not ImageEnView.MouseCapture then
  begin
    if ImageEnView.IEBitmap.Modified then
      StatusBar1.Panels[13].Text := 'Modified'
    else
      StatusBar1.Panels[13].Text := '';
    ImageEnView.Update;
  end;
  UpdateGUI;
end;

end.
